

ifeq "$(TVP_SUPPORT)" "true"
DEFINES += -DCC_TVP_SUPPORT
endif

ifeq "$(SUPPORT_COMBINE_4K_2K)" "true"
DEFINES += -DCC_DYNAMIC_FBMSRM_CONF
endif

ifeq "$(INPUTSOURCE_VIDEO_ON_TEXTURE)" "true"
DEFINES += -DCC_INPUTSOURCE_VIDEO_ON_TEXTURE
endif

#
# Seamless Support Option: DivX Cert, Netflix, Dash, Live_stream, YouTube HTML5 are seamless applications and need to enable CC_ENABLE_SEAMLESS_FOR_2D
#
ifeq "$(SEAMLESS_SUPPORT)" "true"
DEFINES += -DCC_ENABLE_SEAMLESS_FOR_MVC
endif

# SYSTEM EEPROM to NAND/NOR/EMMC
ifeq "$(EEPTOFLASH)" "true"
ifeq "$(BOOT_TYPE)" "ROM2EMMC"
else
DEFINES += -DREPLACE_EEPROM_WITH_FLASH_BLOCK_SIZE_AUTO_DETECTION
endif
endif

# For CEC & MHL HAL layer
ifeq "$(ANDROID_TV_TIF_CEC_MHL)" "true"
DEFINES += -DSYS_ANDROID_TV_TIF_SUPPORT
endif

#### AFT setting ####
DEFINES += -DATD_FINETUNE_STEPSIZE=31250

##############################################
# Sony Gamma                                 #
##############################################
ifneq "$(DEMO_BOARD)" "true"
#DEFINES += -DCC_SONY_GAMMA
endif

##################################
# USB Upgrade                    #
##################################
ifeq "$(FORCE_UPGRADE)" "true"
DEFINES += -DCC_FORCE_USB_UPGRADE
endif

#####################################
# Enable Customized NPTV EEP Layout #
#####################################
ifneq "$(DEMO_BOARD)" "true"
#DEFINES += -DCC_CUST_NPTV_EEP      # to-be-ported
endif

##################################
# Sony Specific                  #
##################################
ifneq "$(DEMO_BOARD)" "true"
  DEFINES += -DCC_SUPPORT_7SEG_DISPLAY
  #DEFINES += -DCC_BYPASS_AVI_INFOFRAME
  DEFINES += -DCC_AUD_7BAND_EQUALIZER
  DEFINES += -DCC_TUNER_CONN_DEFAULT_SURF
  DEFINES += -DDMX_NT_UCODE_DISABLE
  DEFINES += -DDISABLE_CEC_WITHOUT_ACK
  DEFINES += -DCC_AUD_SPEAKER_HEIGHT
  DEFINES += -DCC_AUD_SPEAKER_HEIGHT_MODE
  DEFINES += -DCC_NEW_POST_MULTI_VS_SUPPORT
  #DEFINES += -DCC_AUD_USE_FLASH_AQ   # in Sakura_us.def
  #DEFINES += -DCC_ENABLE_AV_SYNC
  #DEFINES += -DCC_AUD_VOLUME_OFFSET
  DEFINES += -DCC_SONY_BACKLIGHT_SEQUENCE
endif

##############################################################
# Overwirte the ADC Auto-color Efuse value from 0xAA to 0xFF #
##############################################################
ifneq "$(DEMO_BOARD)" "true"
DEFINES += -DCC_EEP_ADC_AUTOCOLOR_OVER_RULE_EFUSE_VALUE=0xFF
endif


####################################################
# Disable Dual Mono Notification from Audio Driver #
####################################################
DEFINES += -DCC_AUD_DISABLE_DUAL_MONO

##################################################
# To Disable WSS525 Timeout so that PQ setting   #
# won't be reset by AP due to resolution changes #
##################################################
DEFINES += -DDISABLE_WSS525_TIMEOUT

################################################
# CC VBI ECC Fine-tune (For CC "Dou-Fu" issue) #
################################################
DEFINES += -DTVD_CC_ECC_SWITCH
DEFINES += -DTVD_CC_ECC_OFF_NRL=0x23

###############################################
# TVD Threshold for Analog CC in weak Signal  #
###############################################
DEFINES += -DTVD_CC_NRL_THRESHOLD_BLOCK=250
DEFINES += -DTVD_CC_NRL_THRESHOLD_UNBLOCK=240
DEFINES += -DTVD_CC_PER_THRESHOLD_BLOCK=100
DEFINES += -DTVD_CC_PER_THRESHOLD_UNBLOCK=90

##########################
# CC AUTO DETECTION      #
##########################
ifneq "$(AUTO_CC_DETECT)" "false"
DEFINES +=-DTVD_CC_ECC_SWITCH
DEFINES +=-DSUPPORT_PALCC_LINE18
DEFINES +=-DSUPPORT_AUTO_CC_DETECT
endif

#################################
# Boot up Logo and Sound        #
#################################
ifneq "$(BOOT_UP_LOGO_SOUND)" "false"
#DEFINES += -DCC_AUD_SETUP_MELODY
endif
# Temp disabled, because it will assert
DEFINES += -DDRV_LOGO_ENABLE=0

#################################
# DSP Code                      #
#################################
#export DSP_CODE_US = y    # to-be-ported

#################################
# IR Configuration              #
#################################
ifneq "$(DEMO_BOARD)" "true"
    ifeq "$(MTK_IR_ENABLE)" "true"
    DEFINES += -DCC_MTK_IR_ENABLE
    endif
endif


#
# nandboot support 8K
#
ifeq "$(NAND_PROFILE_8KB_2MB)" "true"
DEFINES += -DCC_NANDBOOT_SUPPORT_8K
else ifeq "$(NAND_PROFILE_8KB_1MB)" "true"
DEFINES += -DCC_NANDBOOT_SUPPORT_8K
endif

ifneq "$(SDM_SUPPORT)" "false"
DEFINES += -DLINUX_NAND_USE_SDM
endif
ifeq "$(MTD_ENCRYPT_SUPPORT)" "true"
DEFINES += -DCC_MTD_ENCRYPT_SUPPORT
endif

#
# VOMX Support
#
ifeq "$(ANDROID)" "true"
ifeq "$(SUPPORT_TV_STAGEFRIGHT)" "true"
DEFINES += -DCC_ENABLE_VENCOMX
endif
endif

ifeq "$(MTD_ENCRYPT_SUPPORT)" "true"
DEFINES += -DCC_MTD_ENCRYPT_SUPPORT
endif

#
# FP10 Support
#
ifeq "$(ENABLE_FP10)" "true"
DEFINES += -DCC_FBM_TWO_FBP
#DEFINES += -DCC_FBM_INT_TWO_FBP
DEFINES += -DCC_FBM_TWO_FBP_SHARED_WITH_DFB
endif

###############################################
# Config PES Memory Filter.                   #
# In US Model, Only need one for MMP Subtitle #
###############################################
DEFINES += -DDMX_PES_MEM_COMP_NUM=1

############################
# PCMCIA Configuration     #
############################
ifeq "$(DISCARD_SUPPORT_PCMCIA)" "true"
DEFINES += -DCC_DISCARD_SUPPORT_PCMCIA
endif

ifeq "$(3_AUDIO_DECODER)" "true"
DEFINES += -DCC_MT5391_AUD_3_DECODER
DEFINES += -DCC_MT5391_AUD_MW_AUTO_CTRL
endif
ifeq "$(4_AUDIO_DECODER)" "true"
DEFINES += -DCC_AUD_4_DECODER_SUPPORT
endif

############################
# NAND Flash Configuration #
############################
ifeq "$(BOOT_TYPE)" "ROM2NAND"
DEFINES += -DCC_NAND_ENABLE
endif

##### Multimedia #####

ifeq "$(MMP_SUPPORT)" "basic"
DEFINES += -DJPG_ENABLE
DEFINES += -DENABLE_MULTIMEDIA
export ENABLE_MULTIMEDIA = true
endif

ifeq "$(MMP_SUPPORT)" "full"
    DEFINES += -DJPG_ENABLE
    DEFINES += -DCC_H264_SUPPORT
    #DEFINES += -DDIVX_PLUS_CER
    DEFINES += -DCC_B2R_CHAPTER_CHG
    # This ENABLE_MULTIMEDIA is used by mw_if/Makefile
    DEFINES += -DENABLE_MULTIMEDIA
    export ENABLE_MULTIMEDIA = true
    ifeq "$(TSHFT_CORE_LIB)" "true"
        export TIME_SHIFT_SUPPORT = true
        DEFINES += -DTIME_SHIFT_SUPPORT
        DEFINES += -DSYS_RECORD_SUPPORT
        DEFINES += -DCC_DUAL_PVR_SUPPORT
    endif
    DEFINES += -DCC_AUD_MMP_FULL_SUPPORT
endif

#
# Capture Logo
#
ifneq "$(CAPTURE_LOGO_SUPPORT)" "false"
DEFINES += -DCC_BOOT_VDEC_LOGO
endif

#Bypass setting
ifneq "$(AV_BYPASS)" "1"
### Only one DAC in mt5388 ###
#DEFINES += -DMW_TV_ENC_SCART_1=1
#DEFINES += -DMW_TV_ENC_SCART_2=0
else
#DEFINES += -DCC_SUPPORT_TVE_CTRL_BY_DRIVER
#DEFINES += -DCC_SUPPORT_TVE
endif

#DEFINES += -DDXX_HV_POS=1
#DEFINES += -DCC_CQAM

ifeq "$(ANDROID)" "true"
##### Video screenshot #####
DEFINES += -DCC_SUPPORT_VSS
export CC_SUPPORT_VSS = true
endif

###############################################
# Enable HDMI Fast Boot.                      #
# Note: It can't be applied in all PCBs       #
###############################################
DEFINES += -DLINUX_TURNKEY_SOLUTION
export LINUX_SOLUTION = true

DEFINES += -DKEY_FROM_DFB
export KEY_FROM_DFB = y

##### Video encoder #####
ifneq "$(HOME_CTV)" "true"
DEFINES += -DCC_SUPPORT_VENC
export CC_SUPPORT_VENC = true
endif

##### Video screenshot #####
ifeq "$(SUPPORT_VSS_FLINGO)" "true"
    DEFINES += -DCC_SUPPORT_VSS
    export CC_SUPPORT_VSS = true
endif

#DEFINES += -DCC_SCHED_RR_POLICY


ifeq "$(SUPPORT_KOREA_SPEC)" "true"
DEFINES += -DCC_SUPPORT_KOREA_A2
endif

DEFINES += -DMW_TSL_VER_7



ifeq "$(TMS_SUPPORT)" "true"
DEFINES += -DTIME_MEASUREMENT
DEFINES += -DTIME_MEASUREMENT_DEFAULT_OFF
endif
ifeq "$(CONTROL_MPKG_SPEAKER_VOL)" "true"
DEFINES += -DCC_CONTROL_MPKG_SPEAKER_VOL
endif

ifeq "$(BUILD_VARIANT)" "user"
DEFINES += -DCC_ANDROID_VARIANT_USER
endif

ifeq "$(TCON_ISR_DISABLE)" "true"
    DEFINES += -DCC_TCON_ISR_DISABLE
endif

## For IP Seamless
DEFINES += -DCC_FORCE_ITIMING_FRM251080

ifeq "$(ARIB_SUPPORT)" "true"
DEFINES += -DCC_ARIB_MODE_PRO
endif

ifeq "$(WIDEVINE_L1_SUPPORT)" "true"
DEFINES += -DCC_FBM_SECURE_FEEDER
DEFINES += -DCC_WIDEVINE_SUPPORT_USAGE_REPORT
ifeq "$(WIDEVINE_WITHOUT_RPMB)" "true"
DEFINES += -DPSUEDO_RPMB_DEV
endif
endif

ifeq "$(USB_ADB_DEFAULT_ENABLE)" "true"
DEFINES += -DCC_USB_ADB_DEFAULT_ENABLE
endif

###### Graphic Mode YUV444 ########
DEFINES += -DSUPPORT_HDMI_YCBCR444
DEFINES += -DSUPPORT_VGA_YCBCR444

ifeq "$(SUPPORT_TTY_USB)" "true"
DEFINES += -DCC_UBOOT_ADD_USB_LOG_MODE
endif

ifeq "$(SAKURA_4K)" "true"
DEFINES += -DCC_BSP_SW_RANDOM_ENTROPY
endif

DEFINES += -DCC_DYNAMIC_USB_ADB_CONFIG

ifeq "$(QUIET_HOT_BOOT)" "true"
DEFINES += -DCC_QUIET_HOT_BOOT_SUPPORT
endif

ifeq "$(PKG_ENCRYPT_MODE)" "AES"
DEFINES += -DDLM_USE_AES_MODE
else
ifeq "$(PKG_ENCRYPT_MODE)" "DLM_V2"
DEFINES += -DDLM_USE_AES_MODE
DEFINES += -DCC_DLM_V2
DEFINES += -DDLM_SHA_256
DEFINES += -DDLM_GCPU_SHA_256
DEFINES += -DDLM_USE_GCPU_AES
endif
endif

ifeq "$(DEMO_BOARD)" "true"
ifeq "$(SONY_IR)" "true"
DEFINES += -DCC_MAPLE_IR_DRV
endif
endif

ifneq "$(DEMO_BOARD)" "true"
DEFINES += -DCC_SAKURA_SERIAL_NUMBER
endif

# For CEC & MHL HAL layer
ifeq "$(ANDROID_TV_TIF_CEC_MHL)" "true"
DEFINES += -DSYS_ANDROID_TV_TIF_SUPPORT
endif

##### For Android M to set androidboot.hardware #####
DEFINES += -DCC_SUPPORT_CHIPID

####WIFI WOW development ####
ifeq "$(WIFI_DONGLE)" "MT7662U"
ifeq "$(WIFI_WOW_SUPPORT)" "true"
DEFINES += -DWIFI_WOWLAN_SUPPORT
endif
endif

ifeq "$(ENABLE_CMDLINE_BOOTREASON)" "true"
DEFINES += -DCC_CMDLINE_SUPPORT_BOOTREASON
endif

ifeq "$(USE_AOSP_MINIGZIP)" "true"
DEFINES += -DCC_UBOOT_MINIGUNZIP_SUPPORT
endif

ifeq "$(SECURE_BOOT_WO_RAMDISK)" "true"
DEFINES += -DCC_SECURE_BOOT_WO_RAMDISK
endif

DEFINES += -DCC_BL_DETFLOW_IN_UPG

ifeq "$(AUTO_TEST)" "true"
DEFINES += -DCC_MTK_AUTO_TEST
endif

# support FHD display on sub video path
DEFINES += -DCC_FBM_SUB_SUPPORT_FHD

ifeq "$(DYNAMIC_FBM_MAP)" "true"
DEFINES += -DCC_FBM_MAPPING_ONE_BY_ONE
DEFINES += -DCC_VDEC_FBM_DYNAMIC_MAPPING
DEFINES += -DCC_JPEG_FBM_DYNAMIC_MAPPING
endif
DEFINES += -DCC_B2R_SUPPORT_GAME_MODE
ifeq "$(MM_DRV_RM)" "true"
DEFINES += -DCC_VDEC_RM_SUPPORT
DEFINES += -DCC_SUPPORT_VDEC_PREPARSE
DEFINES += -DCC_B2R_RES_SUPPORT
DEFINES += -DCC_DUAL_CORE_DEC
endif

ifneq "$(BUILD_CFG)" "debug"
ifneq "$(MTK_AMAI_BUILD)" "true"
DEFINES += -DNOLOG
endif
endif

ifeq "$(SONY_MT7662_SUPPORT)" "true"
DEFINES += -DCC_SONY_MT7662
endif

ifeq "$(IMPROVE_LOGO_BOOT_TIME)" "true"
DEFINES += -DCC_SUPPORT_BL_DLYTIME_CUT
endif

ifeq "$(MUXER_SUPPORT)" "true"
##### Video encoder #####
DEFINES += -DCC_SUPPORT_VENC
export CC_SUPPORT_VENC = true

##### Muxer #####
DEFINES += -DCC_SUPPORT_MUXER
export CC_SUPPORT_MUXER = true
endif


ifeq "$(PKG_ENCRYPT_MODE)" "AES"
DEFINES += -DDLM_USE_AES_MODE
else
ifeq "$(PKG_ENCRYPT_MODE)" "DLM_V2"
DEFINES += -DDLM_USE_AES_MODE
DEFINES += -DCC_DLM_V2
endif
endif

ifeq "$(ENABLE_SMP_IC)" "true"
DEFINES += -DSUPPORT_SMP
endif

ifeq "$(SUPPORT_MULTI_DRAM_BANK)" "true"
DEFINES += -DCC_UBOOT_TWO_BANK
DEFINES += -DCC_SUPPORT_MULTI_DRAM_COMBINATION
endif

#
# HDMI2 port Debug configure
#
ifeq "$(ENABLE_HDMI_JTAG)" "true"
    ifneq "$(MHL_SUPPORT)" "true"
        DEFINES += -DCC_ENABLE_HDMI_JTAG
    endif
endif

ifeq "$(SUSPEND_TO_DRAM)" "true"
DEFINES += -DCC_SUPPORT_STR
DEFINES += -DCC_SUPPORT_STR_CORE_OFF
DEFINES += -DCC_SUPPORT_STR_TEMP
endif

ifeq "$(SUSPEND_TO_DRAM_DEBUG)" "true"
DEFINES += -DCC_SUPPORT_STR_DEBUG
endif

ifeq "$(TV_OMX_COEXIST)" "true"
DEFINES += -DCC_VOMX_TV_COEXIST
DEFINES += -DCC_SECOND_B2R_SUPPORT
else
DEFINES += -DCC_FBM_TWO_FBP_SHARED_WITH_DFB
endif

ifeq "$(SUPPORT_2STC)" "true"
DEFINES += -DCC_SUPPORT_2STC
endif

ifeq "$(ANDROID)" "true"
DEFINES += -DANDROID
DEFINES += -DCC_MIXSOUND_GAIN_NOT_SYNC_WITH_VOL
DEFINES += -DCC_EMMC_ERASE_SIZE_ALIGNMENT_1M
DEFINES += -DMTIMAGE_ANDROID
DEFINES += -DIMGDRV_ANDROID
endif

ifeq "$(ANDROID_TWO_WORLDS)" "true"
DEFINES += -DCC_ANDROID_TWO_WORLDS
DEFINES += -DCC_SUPPORT_DYNAMIC_ENABLE_DFB_INPUTEVENT
endif

#
# Android RM
#
ifeq "$(SUPPORT_MTK_ANDROID_RM)" "true"
    DEFINES += -DCC_SUPPORT_MTK_ANDROID_RM
endif

ifeq "true" "$(2T_FLASH_SUPPORT)"
DEFINES += -DCC_USE_2TB_EMMC
endif

ifeq "true" "$(FORCE_DRAM1G)"
DEFINES += -DCC_FORCE_DRAM1G
else
ifeq "true" "$(FORCE_DRAM768M)"
DEFINES += -DCC_FORCE_DRAM768M
endif
endif

ifneq "$(ANDROID)" "true"
#H.264 Level5.0 6 reference support
DEFINES += -DCC_H264_LV5_SUPPORT_SINGLE_POOL
endif

# SYSTEM EEPROM to NAND/NOR/EMMC
ifeq "$(EEPTOFLASH)" "true"
ifeq "$(BOOT_TYPE)" "ROM2EMMC"
DEFINES += -DREPLACE_EEPROM_WITH_EMMC
else
DEFINES += -DREPLACE_EEPROM_WITH_FLASH
endif
endif

# MHL
ifeq "$(MHL_SUPPORT)" "true"
DEFINES += -DSYS_MHL_SUPPORT
DEFINES += -DCC_MHL_CBUS_CMOS_CTRL
DEFINES += -DCC_MHL_3D_SUPPORT
endif

ifeq "$(NETFLIX_3D)" "true"
DEFINES += -DCC_ENABLE_SEAMLESS_FOR_MVC
endif

# app_driver_share table
ifeq "$(APP_DRV_TABLE_SHARE)" "true"
DEFINES += -DAPP_DRV_TABLE_SHARE
endif

# Loader logo
ifeq "$(LOADER_LOGO_SUPPORT)" "true"
DEFINES += -DCC_LOADER_LOGO_SUPPORT
endif

# Demo Board
ifeq "$(DEMO_BOARD)" "true"
DEFINES += -DDEMO_BOARD
endif

ifeq "$(TRUSTZONE)" "true"
    DEFINES += -DCC_TRUSTZONE_SUPPORT
    DEFINES += -DCC_TRUSTZONE_IN_CHB
    ifeq "$(SVP_SUPPORT)" "true"
    DEFINES += -DCC_SVP_SUPPORT
    endif
    ifeq "$(PACK_TZBIN_INDIVIDUAL_PARTITION)" "true"
    DEFINES += -DCC_TZBIN_INDIVIDUAL_PARTITION
    endif
    ifeq "$(CI_TZ_SUPPORT)" "true"
         DEFINES += -DCC_CI_PLUS_TZ_SUPPORT
    endif
endif
DEFINES += -DCC_UBOOT_ADD_FACT_MODE
DEFINES += -DCC_UBOOT_ADD_FACT_MODE_ADDR=0x6c8

ifeq "$(ENABLE_PLAYMGR)" "true"
DEFINES += -DCC_ENABLE_PLAYMGR
endif

ifeq "$(FAST_INIT_SUPPORT)" "true"
DEFINES += -DCC_FAST_INIT
endif

ifeq "$(SYM_SUPPORT)" "true"
NO_SYM_DEBUG := FALSE
else
NO_SYM_DEBUG := TRUE
endif
ifeq "$(BUILD_CFG)" "debug"
NO_SYM_DEBUG := FALSE
endif
DEFINES += -DCC_LOADER_UPGRADE_FORCE_DISABLE_SUPPORT

ifeq "$(MTD_ENCRYPT_SUPPORT)" "true"
DEFINES += -DCC_MTD_ENCRYPT_SUPPORT
endif

DEFINES += -DCC_MTD_SUPPORT_64_PARTITION

# Just for release version
ifeq "$(BUILD_CFG)" "rel"
DEFINES += -DCC_UBOOT_QUIET_BOOT
DEFINES += -DNDEBUG
endif

DEFINES += -DCC_ENABLE_REBOOT_REASON

DEFINES += -DOSAI_FOR_NUCLEUS
DEFINES += -DLINUX_TURNKEY_SOLUTION
ifneq "$(LOADER_USB_UPGRADE)" "false"
DEFINES += -DLOADER_USB_UPGRADE
DEFINES += -DAUTO_USB_UPGRADE_ENABLE=1
endif

ifeq "$(AUD_DATA_UPLOAD_SUPPORT)" "true"
    DEFINES += -DCC_AUD_DATA_UPLOAD_SUPPORT
endif

ifeq "$(SUPPORT_2G_DRAM)" "true"
DEFINES += -DCC_UBOOT_TWO_BANK
DEFINES += -DCC_MT53XX_SUPPORT_2G_DRAM
endif

##############################################
# For Customized header file (Driver)        #
##############################################
DEFINES += -DTARGET_SPEC_DRV_CUST_CUSTOMIZED_HDR_FILE=\"$(VM_LINUX_ROOT)/target/public/$(TARGET_IC)/d_inc/$(COMPANY)/d_maple_cust.h\"

##############################################
# General Options                            #
##############################################
ifeq "$(BUILD_CFG)" "debug"
DEFINES += -DCC_MEM_MID_DISABLE
DEFINES += -DIRRC_LOG
endif

#################################
# Panel & Model detection       #
#################################

#
# Load Panel table from flash & Panel default setting
#
ifneq "$(DEMO_BOARD)" "true"
    ifneq "$(PANEL_ON_FLASH)" "false"
        DEFINES += -DCC_PANEL_FROM_FLASH
        DEFINES += -DDEFAULT_PANEL_FHD_SELECT=52
        DEFINES += -DDEFAULT_PANEL_WXGA_SELECT=52
        DEFINES += -DDEFAULT_PANEL_FHD_10BIT_SELECT=52
        DEFINES += -DDEFAULT_PANEL_NONTCON_SELECT=52
        DEFINES += -DCC_FLIP_MIRROR_SUPPORT
        DEFINES += -DCC_FLIP_MIRROR_FROM_EEPROM
    else
        DEFINES += -DDEFAULT_PANEL_FHD_SELECT=PANEL_LG_42_WU5_SLB1
        DEFINES += -DDEFAULT_PANEL_WXGA_SELECT=PANEL_LG_42_WU5_SLB1
    endif
endif

#
# Power state control setting
#
ifneq "$(POWER_STATE_CTRL)" "false"
DEFINES += -DCUSTOM_POWER_STATE_CTRL_ENABLE
endif

#
# Model detect setting
#
ifneq "$(DEMO_BOARD)" "true"
    ifneq "$(MODEL_DETECT)" "false"
        DEFINES += -DCC_MODEL_DETECT_SUPPORT
        DEFINES += -DDEFAULT_PANEL_SELECT=DEFAULT_PANEL_WXGA_SELECT
    else
        #### CONFIGURE DDR CLOCK ####
        ifeq "$(FHD_PANEL)" "true"
            DEFINES += -DCC_FHD_PANEL_SUPPORT
            DEFINES += -DDEFAULT_PANEL_SELECT=DEFAULT_PANEL_FHD_SELECT
        else
            DEFINES += -DDEFAULT_PANEL_SELECT=DEFAULT_PANEL_WXGA_SELECT
        endif
    endif
endif

#################################
# Self-diagnostic               #
#################################

#
# Self Diagnostic & AC Detect setting
#
ifneq "$(DEMO_BOARD)" "true"
    ifneq "$(AC_DETECT)" "false"
        DEFINES += -DCC_AC_DETECT_ENABLE
        DEFINES += -DCC_SOEM_ACDET_PAA
    endif

    ifneq "$(SELF_DIAG_ENABLE)" "false"
        DEFINES += -DCUSTOM_SELF_DIAG_ENABLE
        ifeq "$(SELF_DIAG_ON)" "true"
            DEFINES += -DCC_SELF_DIAG_DEFAULT_ON
        endif
    endif
    DEFINES += -DCC_CUSTOMER_CLI
endif

##### 3D #####
ifeq "$(3D_SUPPORT)" "true"
DEFINES += -DCC_SCPOS_3DTV_SUPPORT
DEFINES += -DCC_REALD_3D_SUPPORT
DEFINES += -DCC_B2R_3D_SUPPROT
DEFINES += -DCC_3D_SUPPORT

ifeq "$(3D_MM_DS_SUPPORT)" "true"
DEFINES += -DCC_MVC_SUPPORT
DEFINES += -DCC_FBM_TWO_FBP
#DEFINES += -DCC_FBM_INT_TWO_FBP
DEFINES += -DCC_FBM_TWO_FBP_SHARED_WITH_DFB
DEFINES += -DCC_3D_MM_DS_SUPPORT

#
# VOMX Support
#
ifeq "$(ANDROID)" "true"
ifeq "$(SUPPORT_TV_STAGEFRIGHT)" "true"
DEFINES += -DCC_ENABLE_VDECOMX
DEFINES += -DCC_ENABLE_VENCOMX
DEFINES += -DVDEC_YUV_CVT_IMG
endif
endif

#### For Audio DSP decoder ####
ifeq "$(SUPPORT_ENHANCED_AOMX)" "true"
DEFINES += -DCC_ENABLE_ADECOMX
endif

ifeq "$(TV_OMX_COEXIST)" "true"
DEFINES += -DCC_VOMX_TV_COEXIST
else
#DEFINES += -DCC_FBM_INT_TWO_FBP
DEFINES += -DCC_FBM_TWO_FBP_SHARED_WITH_DFB
ifeq "$(WITH_8283)" "true"
DEFINES += -DCC_FBM_FULL_3D_SUPPORT
endif
endif
DEFINES += -DCC_SSIF_SUPPORT
DEFINES += -DCC_3D_MM_DS_SUPPORT
endif

ifeq "$(3D_SUPPORT_SG_PANEL)" "true"
DEFINES += -DSUPPORT_3D_EXT_COMP_TRL=1
else
DEFINES += -DSUPPORT_3D_EXT_COMP_TRL=0
endif
endif

ifeq "$(USE_256MB_NAND)" "true"
DEFINES += -DCC_USE_256MB_NAND
    ifeq "$(USE_256MB_NAND_SUPPORT_PKG_DOWNLOAD)" "true"
    DEFINES += -DCC_256MB_NAND_SUPPORT_PKG_DOWNLOAD
    endif
endif

ifneq "$(SDM_SUPPORT)" "false"
DEFINES += -DLINUX_NAND_USE_SDM
endif

ifeq "$(NETFLIX_CMPB)" "true"
DEFINES += -DCC_NETFLIX_CMPB_SUPPORT
DEFINES += -DCC_NETFLIX_CE3_SUPPORT
endif

ifeq "$(MULTI_MM_SUPPORT)" "true"
DEFINES += -DCC_FBM_TWO_FBP
DEFINES += -DCC_SKYPE_FINE_INSTANCE
DEFINES += -DCC_B2R_SKYPE_SUPPORT
endif

#
# 3D photo on VDP
#
ifeq "$(3D_PHOTO_ON_VDP)" "true"
DEFINES += -DIS_SUPPORT_3D_PHOTO
DEFINES += -DCC_FBM_3D_OSD
DEFINES += -DCC_DFB_SUPPORT_VDP_LAYER
endif

##### Network #####
ifneq ($(strip $(findstring -DDLNA_SUPPORT, $(DEFINES))),)
DEFINES += -DCC_DLNA_SUPPORT
#DEFINES += -DDMX_SUPPORT_NDDRM
#DEFINES += -DDMX_SUPPORT_DTCP
endif

ifeq "$(ENABLE_NAUTILUS_SUPPORT)" "true"
DEFINES += -DENABLE_NAUTILUS
endif

ifeq "$(ENABLE_NAUTILUS_ATK)" "true"
DEFINES += -DCC_ENABLE_NAUTILUS_ATK
endif

ifeq "$(ENABLE_NAUTILUS_NEW_KEYFORMAT)" "true"
DEFINES += -DCC_ENABLE_NAUTILUS_NEW_KEYFORMAT
endif

ifeq "$(ENABLE_SKB)" "true"
DEFINES += -DCC_ENABLE_SKB
endif

ifeq "$(ENABLE_HCI)" "true"
DEFINES += -DCC_ENABLE_HCI
endif

#IPv6
ifeq "$(IPV6_SUPPORT)" "true"
DEFINES += -DCC_IPV6_SUPPORT
endif

# EMMC - Drv option
ifeq "$(BOOT_TYPE)" "ROM2EMMC"
DEFINES += -DCC_MSDC_ENABLE
DEFINES += -DCC_EMMC_BOOT
ifeq "$(PART_WRITE_PROTECT)" "true"
DEFINES += -DCC_PARTITION_WP_SUPPORT
endif
ifeq "$(MSDC_ETT)" "true"
DEFINES += -DCC_MSDC_ETT
endif
endif
DEFINES += -DCC_3RD_KO_INSERTION

# SD card - Drv option
ifeq "$(SDMMC_SUPPORT)" "true"
DEFINES += -DCC_SDMMC_SUPPORT
DEFINES += -DCC_SDMMC_SUPPORT_USB_RECOVERY
endif

DEFINES += -DCC_OSD_USE_FBM

#Bypass setting
ifneq "$(AV_BYPASS)" "1"
DEFINES += -DCC_SUPPORT_TVE_CTRL_BY_MW
DEFINES += -DCC_SUPPORT_TVE
endif

#
#PIP/POP. target use this define.
#
ifeq "$(SUPPORT_PIP)" "true"
DEFINES += -DMW_PIP_POP_SUPPORT
endif

# Driver definitions
ifeq "$(BUILD_CFG)" "debug"
DEFINES += -DCC_PSEUDO_WATCHDOG_ASSERT=1
endif

#chip spec
DEFINES += -DCHIP_SPEC_SUPPORT

ifneq "$(FLASH_PQ)" "false"
	DEFINES += -DSUPPORT_FLASH_PQ
endif

ifneq "$(FLASH_AQ)" "false"
#DEFINES += -DSUPPORT_FLASH_AQ
endif


ifeq "$(FLASH_ADSP_BIN)" "true"
DEFINES += -DADSP_BIN_SUPPORT
endif

ifeq "$(BLUEANGEL)" "true"
DEFINES += -DAPP_BLUEANGEL_SUPPORT
endif

##### FLIP/MIRROR #####
ifeq "$(SYS_FLIP_SUPPORT)" "true"
DEFINES += -DCC_FLIP_MIRROR_SUPPORT
DEFINES += -DCC_FLIP_MIRROR_FROM_EEPROM
DEFINES += -DCC_FLIP_ENABLE
endif

ifeq "$(SYS_MIRROR_SUPPORT)" "true"
DEFINES += -DCC_FLIP_MIRROR_SUPPORT
DEFINES += -DCC_FLIP_MIRROR_FROM_EEPROM
DEFINES += -DCC_MIRROR_ENABLE
endif

##### 4K2K Support #####
ifeq "$(SUPPORT_4K2K)" "true"
DEFINES += -DCC_SUPPORT_4K2K
DEFINES += -DCC_SUPPORT_4KBE
DEFINES += -DCC_FBM_SUPPORT_4K2K
DEFINES += -DCC_FBM_TWO_FBP
DEFINES += -DCC_DFB_SUPPORT_VDP_LAYER
ifeq "$(SUPPORT_W2DR2R)" "true"
DEFINES += -DCC_SUPPORT_W2DR2R
endif
endif
ifeq "$(SUPPORT_COMBINE_4K_2K)" "true"
DEFINES += -DCC_COMBINE_4K_2K
endif

ifeq "$(SAKURA_CVT_SUPPORT)" "true"
DEFINES += -DCC_SAKURA_CVT_SUPPORT
endif

ifeq "$(SAKURA_MVT_SUPPORT)" "true"
DEFINES += -DCC_SAKURA_MVT_SUPPORT
endif

###############################################
# Enable HDMI Fast Boot.                      #
# Note: It can't be applied in all PCBs       #
###############################################
DEFINES += -DCC_SUPPORT_HDMI_FBOOTING

###############################################
#               cec arc ctrl                  #
###############################################
DEFINES += -DCC_HDMI_ARC_SPDIF_CTRL
DEFINES += -DCECNFY5VSTATUS

###############################################
#               android                       #
###############################################
ifeq "$(ANDROID)" "true"
DEFINES += -DANDROID
endif

ifeq "$(ANDROID_TOOLCHAIN)" "true"
DEFINES += -DANDROID_TOOLCHAIN
endif

ifeq "$(ANDROID_TWO_WORLDS)" "true"
DEFINES += -DANDROID_TWO_WORLDS
endif

###############################################
#               dmx                   #
###############################################
DEFINES += -DCC_FBM_SUPPORT_DMXPID
DEFINES += -DCC_FBM_SUPPORT_SWDMX

ifeq "$(GFX_MMU_SUPPORT)" "true"
DEFINES += -DCC_GFX_MMU
endif

#support wmv7/8
DEFINES += -DCC_ENABLE_WMV7
DEFINES += -DCC_ENABLE_WMV8

ifeq "$(BASIC_IN_ROOTFS)" "true"
DEFINES += -DCC_DISABLE_BASIC_PART
endif

ifeq "$(SYM_SUPPORT)" "true"
DEFINES += -DCC_SYM_SUPPORT
endif

ifeq "$(3RD_RO)" "true"
DEFINES += -DCC_3RD_RO
ifeq "$(3RD_RO_DBG)" "true"
DEFINES += -DCC_3RD_RO_DBG
endif
endif

#DEFINES += -DSYS_OVERRIDE_DISP_REGION_SUPPORT

ifeq "$(SECURE_BOOT_V2)" "true"
DEFINES += -DCC_SECURE_BOOT_V2
endif

ifeq "$(BOOT_NO_LZHS)" "true"
DEFINES += -DCC_BOOT_NO_LZHS
endif

ifeq "$(SECURE_BOOT_SCRAMBLE)" "true"
DEFINES += -DCC_SECURE_BOOT_SCRAMBLE
endif

ifeq "$(LOADER_ENABLE_CONSOLE_LOCK)" "true"
DEFINES += -DCC_CONSOLE_LOCK
endif

ifeq "$(LOADER_CONSOLE_KEY)" "true"
    DEFINES += -DCC_LOADER_CONSOLE_KEY_SUPPORT
endif

ifeq "$(LOADER_ENABLE_SECURE_STORAGE)" "true"
DEFINES += -DCC_SECURESTORAGE_SUPPORT
endif

# Seamless Support Option: DivX Cert, Netflix, Dash, Live_stream, YouTube
# HTML5 are seamless applications and need to enable CC_ENABLE_SEAMLESS_FOR_2D

ifeq "$(SEAMLESS_SUPPORT)" "true"
DEFINES += -DCC_ENABLE_SEAMLESS_FOR_MVC
DEFINES += -DCC_ENABLE_SEAMLESS_FOR_2D
endif
ifeq "$(SUPPORT_BOSTON_SWITCH)" "true"
DEFINES += -DCC_SUPPORT_BOSTON_SWITCH
endif
ifeq "$(DEMO_BOARD)" "true"
DEFINES += -DCC_HDMI_USE_DEMO_BOARD
endif

#Four WAY Playback
ifeq "$(SUPPORT_4WAY_PLAYER)" "true"
DEFINES += -DCC_FBM_TWO_FBP
DEFINES += -DCC_FBM_TWO_FBP_SHARED_WITH_DFB
DEFINES += -DCC_FBM_FOUR_INST_SUPPORT
DEFINES += -DCC_SUPPORT_H264_10BIT
endif

# Add security level notification to video path SECURITY_LEVEL_CAPTURE_CTRL
# - define CC_SYS_SUPPORT_SECURITY_LVL to driver in common.cfg
ifeq "$(SECURITY_LEVEL_CAPTURE_CTRL)" "true"
DEFINES += -DCC_SYS_SUPPORT_SECURITY_LVL
endif

#Open uart1 PIO mode
ifeq "$(DISABLE_UARTDMA_CTRL)" "true"
DEFINES += -DCC_DISABLE_UARTDMA
endif

