/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 * $RCSfile: x_fm_radio.h,v $
 * $Revision: #1 $
 * $Date: 2015/11/10 $
 * $Author: dtvbm11 $
 *
 * Description:
 *         This header file contains the FM Radio connection handler specific
 *         definitions that are exported.
 *---------------------------------------------------------------------------*/

#ifndef _C_BLUETOOTH_H_
#define _C_BLUETOOTH_H_

/*-----------------------------------------------------------------------------
                    include files
-----------------------------------------------------------------------------*/

#include "u_common.h"
#include "u_bluetooth.h"

/*-----------------------------------------------------------------------------
                    functions declarations
 ----------------------------------------------------------------------------*/

extern INT32 c_bluetooth_scan (
    VOID*                              pv_nfy_tag,
    x_bluetooth_scan_nfy_fct           pf_nfy
);

extern INT32 c_bluetooth_stop_scan (
    VOID
);

extern INT32 c_bluetooth_pair (
    CHAR*                              ps_remote_device_addr,
    VOID*                              pv_nfy_tag,
    x_bluetooth_pair_nfy_fct           pf_nfy,
    BLUETOOTH_PINCODE_T*               pt_pincode
);

extern INT32 c_bluetooth_unpair (
    CHAR*                              ps_remote_device_addr
);

extern INT32 c_bluetooth_get_paired_device_list (
    BLUETOOTH_DEVICE_PROPERTY_T*       pt_list,
    UINT8                              ui1_list_sz,
    UINT8*                             pui1_actual_num
);

extern INT32 c_bluetooth_set_audio_svc (
    BOOL                               b_on
);

extern INT32 c_bluetooth_get_audio_svc_status (
    UINT8*                             pui1_connected
);

extern INT32 c_bluetooth_pair_vur10 (
    CHAR*                              ps_remote_device_addr,
    VOID*                              pv_nfy_tag,
    x_bluetooth_pair_nfy_fct           pf_nfy
);

extern INT32 c_bluetooth_set_universal_remote (
    UINT8                              ui1_device_id,
    UINT16                             ui2_brand_id,
    UINT16                             ui2_codeset_id
);

extern INT32 c_bluetooth_shutdown (
    VOID
);

#endif /* _C_BLUETOOTH_H_ */

