/* SPDX-License-Identifier: LGPL-2.1-only OR BSD-3-Clause */
/******************************************************************************
 *
 * This file is provided under a dual license.  When you use or
 * distribute this software, you may choose to be licensed under
 * version 2.1 of the GNU Lesser General Public License
 * ("LGPLv2.1 License") or BSD License.
 *
 * LGPLv2.1 License
 *
 * Copyright(C) 2019 MediaTek Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of version 2.1 of the GNU Lesser General Public
 * License as published by the Free Software Foundation.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * See https://www.gnu.org/licenses/old-licenses/lgpl-2.1.html for more
 * details.
 *
 * BSD LICENSE
 *
 * Copyright(C) 2019 MediaTek Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in
 *    the documentation and/or other materials provided with the
 *    distribution.
 *  * Neither the name of the copyright holder nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
 * A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
 * HOLDER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
 * SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
 * LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
 * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
 * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
 * OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *****************************************************************************/

/*-----------------------------------------------------------------------------
 * $RCSfile: _sm_ttx_engine.h,v $
 * $Revision: #1 $
 * $Date: 2015/11/10 $
 * $Author: dtvbm11 $
 * $CCRevision: $
 * $SWAuthor: $
 * $MD5HEX: $
 *
 * Description: This file is for attributes of S/W use by Pibben
 *         
 *         
 *---------------------------------------------------------------------------*/

#ifndef _X_SM_TTX_COMMON_EX_H_
#define _X_SM_TTX_COMMON_EX_H_

#include "x_sm_ttx_common.h"

#if 0
/* SW Mosaics */
#define SM_TTX_WGL_CELL_HAS_SW_MOS(pt_cell)  \
    SM_TTX_WGL_CELL_HAS_B2(pt_cell, 0x00080000)
#define SM_TTX_WGL_CELL_SET_SW_MOS(pt_cell) \
    SM_TTX_WGL_CELL_SET_FLAG_B2(pt_cell, 0x00080000)
#define SM_TTX_WGL_CELL_CLR_SW_MOS(pt_cell) \
    SM_TTX_WGL_CELL_CLR_B2(pt_cell, 0x00080000)

/* G0 Select */
#define SM_TTX_WGL_CELL_HAS_G0_SEL(pt_cell)  \
    SM_TTX_WGL_CELL_HAS_B2(pt_cell, 0x00100000)
#define SM_TTX_WGL_CELL_SET_G0_SEL(pt_cell) \
    SM_TTX_WGL_CELL_SET_FLAG_B2(pt_cell, 0x00100000)
#define SM_TTX_WGL_CELL_CLR_G0_SEL(pt_cell) \
    SM_TTX_WGL_CELL_CLR_B2(pt_cell, 0x00100000)

/* SW Foreground Set */
#define SM_TTX_WGL_CELL_HAS_SW_FG(pt_cell)  \
    SM_TTX_WGL_CELL_HAS_B2(pt_cell, 0x00200000)
#define SM_TTX_WGL_CELL_SET_SW_FG(pt_cell) \
    SM_TTX_WGL_CELL_SET_FLAG_B2(pt_cell, 0x00200000)
#define SM_TTX_WGL_CELL_CLR_SW_FG(pt_cell) \
    SM_TTX_WGL_CELL_CLR_B2(pt_cell, 0x00200000)

/* SW Background Set */
#define SM_TTX_WGL_CELL_HAS_SW_BG(pt_cell)  \
    SM_TTX_WGL_CELL_HAS_B2(pt_cell, 0x00400000)
#define SM_TTX_WGL_CELL_SET_SW_BG(pt_cell) \
    SM_TTX_WGL_CELL_SET_FLAG_B2(pt_cell, 0x00400000)
#define SM_TTX_WGL_CELL_CLR_SW_BG(pt_cell) \
    SM_TTX_WGL_CELL_CLR_B2(pt_cell, 0x00400000)

/* SW Conceal */
#define SM_TTX_WGL_CELL_HAS_SW_CCL(pt_cell)  \
    SM_TTX_WGL_CELL_HAS_B2(pt_cell, 0x00800000)
#define SM_TTX_WGL_CELL_SET_SW_CCL(pt_cell) \
    SM_TTX_WGL_CELL_SET_FLAG_B2(pt_cell, 0x00800000)
#define SM_TTX_WGL_CELL_CLR_SW_CCL(pt_cell) \
    SM_TTX_WGL_CELL_CLR_B2(pt_cell, 0x00800000)

/* SW Invert */
#define SM_TTX_WGL_CELL_HAS_SW_INV(pt_cell)  \
    SM_TTX_WGL_CELL_HAS_B2(pt_cell, 0x01000000)
#define SM_TTX_WGL_CELL_SET_SW_INV(pt_cell) \
    SM_TTX_WGL_CELL_SET_FLAG_B2(pt_cell, 0x01000000)
#define SM_TTX_WGL_CELL_CLR_SW_INV(pt_cell) \
    SM_TTX_WGL_CELL_CLR_B2(pt_cell, 0x01000000)

/* SW Double-Height */
#define SM_TTX_WGL_CELL_HAS_SW_DH(pt_cell)  \
    SM_TTX_WGL_CELL_HAS_B2(pt_cell, 0x02000000)
#define SM_TTX_WGL_CELL_SET_SW_DH(pt_cell) \
    SM_TTX_WGL_CELL_SET_FLAG_B2(pt_cell, 0x02000000)
#define SM_TTX_WGL_CELL_CLR_SW_DH(pt_cell) \
    SM_TTX_WGL_CELL_CLR_B2(pt_cell, 0x02000000)

/* SW Double-Width */
#define SM_TTX_WGL_CELL_HAS_SW_DW(pt_cell)  \
    SM_TTX_WGL_CELL_HAS_B2(pt_cell, 0x04000000)
#define SM_TTX_WGL_CELL_SET_SW_DW(pt_cell) \
    SM_TTX_WGL_CELL_SET_FLAG_B2(pt_cell, 0x04000000)
#define SM_TTX_WGL_CELL_CLR_SW_DW(pt_cell) \
    SM_TTX_WGL_CELL_CLR_B2(pt_cell, 0x04000000)

/* SW Double-Height/Size Upper */
#define SM_TTX_WGL_CELL_HAS_SW_DHDS_UP(pt_cell)  \
    SM_TTX_WGL_CELL_HAS_B2(pt_cell, 0x08000000)
#define SM_TTX_WGL_CELL_SET_SW_DHDS_UP(pt_cell) \
    SM_TTX_WGL_CELL_SET_FLAG_B2(pt_cell, 0x08000000)
#define SM_TTX_WGL_CELL_CLR_SW_DHDS_UP(pt_cell) \
    SM_TTX_WGL_CELL_CLR_B2(pt_cell, 0x08000000)

/* SW Double-Height/Size Lower */
#define SM_TTX_WGL_CELL_HAS_SW_DHDS_LOW(pt_cell)  \
    SM_TTX_WGL_CELL_HAS_B2(pt_cell, 0x10000000)
#define SM_TTX_WGL_CELL_SET_SW_DHDS_LOW(pt_cell) \
    SM_TTX_WGL_CELL_SET_FLAG_B2(pt_cell, 0x10000000)
#define SM_TTX_WGL_CELL_CLR_SW_DHDS_LOW(pt_cell) \
    SM_TTX_WGL_CELL_CLR_B2(pt_cell, 0x10000000)

/* SW Newsflash Set */
#define SM_TTX_WGL_CELL_HAS_SW_NS(pt_cell)  \
    SM_TTX_WGL_CELL_HAS_B2(pt_cell, 0x20000000)
#define SM_TTX_WGL_CELL_SET_SW_NS(pt_cell) \
    SM_TTX_WGL_CELL_SET_FLAG_B2(pt_cell, 0x20000000)
#define SM_TTX_WGL_CELL_CLR_SW_NS(pt_cell) \
    SM_TTX_WGL_CELL_CLR_B2(pt_cell, 0x20000000)

/* SW Flash Set */
#define SM_TTX_WGL_CELL_HAS_SW_FLASH(pt_cell)  \
    SM_TTX_WGL_CELL_HAS_B2(pt_cell, 0x40000000)
#define SM_TTX_WGL_CELL_SET_SW_FLASH(pt_cell) \
    SM_TTX_WGL_CELL_SET_FLAG_B2(pt_cell, 0x40000000)
#define SM_TTX_WGL_CELL_CLR_SW_FLASH(pt_cell) \
    SM_TTX_WGL_CELL_CLR_B2(pt_cell, 0x40000000)

/* SW Separate under Set */
#define SM_TTX_WGL_CELL_HAS_SW_SEP_UNDER(pt_cell)  \
    SM_TTX_WGL_CELL_HAS_B2(pt_cell, 0x80000000)
#define SM_TTX_WGL_CELL_SET_SW_SEP_UNDER(pt_cell) \
    SM_TTX_WGL_CELL_SET_FLAG_B2(pt_cell, 0x80000000)
#define SM_TTX_WGL_CELL_CLR_SW_SEP_UNDER(pt_cell) \
    SM_TTX_WGL_CELL_CLR_B2(pt_cell, 0x80000000)


#else

/* SW Mosaics */
#define SM_TTX_WGL_CELL_HAS_SW_MOS(pt_cell)
#define SM_TTX_WGL_CELL_SET_SW_MOS(pt_cell)
#define SM_TTX_WGL_CELL_CLR_SW_MOS(pt_cell)

/* G0 Select */
#define SM_TTX_WGL_CELL_HAS_G0_SEL(pt_cell)
#define SM_TTX_WGL_CELL_SET_G0_SEL(pt_cell)
#define SM_TTX_WGL_CELL_CLR_G0_SEL(pt_cell)

/* SW Foreground Set */
#define SM_TTX_WGL_CELL_HAS_SW_FG(pt_cell)
#define SM_TTX_WGL_CELL_SET_SW_FG(pt_cell)
#define SM_TTX_WGL_CELL_CLR_SW_FG(pt_cell)

/* SW Background Set */
#define SM_TTX_WGL_CELL_HAS_SW_BG(pt_cell)
#define SM_TTX_WGL_CELL_SET_SW_BG(pt_cell)
#define SM_TTX_WGL_CELL_CLR_SW_BG(pt_cell)

/* SW Conceal */
#define SM_TTX_WGL_CELL_HAS_SW_CCL(pt_cell)
#define SM_TTX_WGL_CELL_SET_SW_CCL(pt_cell)
#define SM_TTX_WGL_CELL_CLR_SW_CCL(pt_cell)

/* SW Invert */
#define SM_TTX_WGL_CELL_HAS_SW_INV(pt_cell)
#define SM_TTX_WGL_CELL_SET_SW_INV(pt_cell)
#define SM_TTX_WGL_CELL_CLR_SW_INV(pt_cell)

/* SW Double-Height */
#define SM_TTX_WGL_CELL_HAS_SW_DH(pt_cell)
#define SM_TTX_WGL_CELL_SET_SW_DH(pt_cell)
#define SM_TTX_WGL_CELL_CLR_SW_DH(pt_cell)

/* SW Double-Width */
#define SM_TTX_WGL_CELL_HAS_SW_DW(pt_cell)
#define SM_TTX_WGL_CELL_SET_SW_DW(pt_cell)
#define SM_TTX_WGL_CELL_CLR_SW_DW(pt_cell)

/* SW Double-Height/Size Upper */
#define SM_TTX_WGL_CELL_HAS_SW_DHDS_UP(pt_cell)
#define SM_TTX_WGL_CELL_SET_SW_DHDS_UP(pt_cell)
#define SM_TTX_WGL_CELL_CLR_SW_DHDS_UP(pt_cell)

/* SW Double-Height/Size Lower */
#define SM_TTX_WGL_CELL_HAS_SW_DHDS_LOW(pt_cell)
#define SM_TTX_WGL_CELL_SET_SW_DHDS_LOW(pt_cell)
#define SM_TTX_WGL_CELL_CLR_SW_DHDS_LOW(pt_cell)

/* SW Newsflash Set */
#define SM_TTX_WGL_CELL_HAS_SW_NS(pt_cell)
#define SM_TTX_WGL_CELL_SET_SW_NS(pt_cell)
#define SM_TTX_WGL_CELL_CLR_SW_NS(pt_cell)

/* SW Flash Set */
#define SM_TTX_WGL_CELL_HAS_SW_FLASH(pt_cell)
#define SM_TTX_WGL_CELL_SET_SW_FLASH(pt_cell)
#define SM_TTX_WGL_CELL_CLR_SW_FLASH(pt_cell)

/* SW Separate under Set */
#define SM_TTX_WGL_CELL_HAS_SW_SEP_UNDER(pt_cell)
#define SM_TTX_WGL_CELL_SET_SW_SEP_UNDER(pt_cell)
#define SM_TTX_WGL_CELL_CLR_SW_SEP_UNDER(pt_cell)

#endif

#endif /* _X_SM_TTX_COMMON_EX_H_ */

