/******************************************************************************
 *
 * Copyright 2013, Silicon Image, Inc.  All rights reserved.
 * No part of this work may be reproduced, modified, distributed, transmitted,
 * transcribed, or translated into any language or computer format, in any form
 * or by any means without written permission of
 * Silicon Image, Inc., 1140 East Arques Avenue, Sunnyvale, California 94085
 *
 *****************************************************************************/
/**
 * @file si_drv_isp.h
 *
 * @brief ISP APIs
 *
 *****************************************************************************/

#ifndef SI_DRV_ISP_H
#define SI_DRV_ISP_H

/***** #include statements ***************************************************/

#include "si_datatypes.h"

/***** public constant definitions *******************************************/

#define FLASH_EDID_BASE_ADDR    0x5000

#define SII_DRV_SPI_BUSRT_WRITE_SIZE         256

/***** public functions ******************************************************/

void SiiDrvIspReadInit( SiiPlatformDevId_t devId );
void SiiDrvIspChipErase( SiiPlatformDevId_t devId );
void SiiDrvIspSectorErase( SiiPlatformDevId_t devId, uint32_t addr );
void SiiDrvIspBurstWrite( SiiPlatformDevId_t devId, uint32_t addr, const uint8_t* pData, uint16_t len );
void SiiDrvIspBurstRead( SiiPlatformDevId_t devId, uint32_t addr, const uint8_t* pData, uint16_t len );
bool_t SiiDrvIspOperationDone( SiiPlatformDevId_t devId );

#endif // SI_DRV_ISP_H

/***** end of file ***********************************************************/
