//CC_AUD_AQ_IN_DRVCUST
#define AUD_EXTERN_FILE


//=======================
//  [!!!!**CAUTION**!!!!]
// Please exclude Loader
//=======================
#if ((!defined(CC_MTK_PRELOADER)) && (!defined(CC_MTK_LOADER))) 


//---------------------------------------------------------------------------
// Include files
//---------------------------------------------------------------------------
/* =======================================================
 [!!!!**CAUTION**!!!!]
 You can only include header 
    files in \target\mtxxxx\xxxx_driver\drv_inc\
 or files in \vm_linux\output\sysbuild\xxxx\rel(or debug)\inc\drv_inc\
 or files in "the same directory."
========================================================= */
#include "x_typedef.h"
#include "x_os.h"
#include "x_bim.h"
#include "x_printf.h"
#include "x_assert.h"
#include "x_util.h"
#include "aud_if.h"
#include "drvcust_if.h"
#include "nor_if.h"
#include "nand_if.h"
#include "storage_if.h"

#include "sakura_aud_aq_data.h"
#include "aud_amp_5760.h"
#include "aud_amp_5760.c"


extern UINT32 _gu4BeDelay;
extern AUD_AOUT_PAD_CFG_T _grAOutPadCfg;
extern void AUD_AoutPADMux(AUD_CH_T ePAD_SDATA0, AUD_CH_T ePAD_SDATA1, AUD_CH_T ePAD_SDATA2,
                    AUD_CH_T ePAD_SDATA3, AUD_CH_T ePAD_SDATA4, AUD_CH_T ePAD_SDATA5,
                    UINT8 PAD_MCLK0);
extern BOOL AUD_DspIecChannel(AUD_IEC_CH_T eIecChannel);
#if defined(CC_AUD_ARM_SUPPORT) && defined(CC_AUD_ARM_RENDER)
extern void _vAprocSetRoutine (UINT32 u4Id);
#endif
#ifdef CUSTOM_SELF_DIAG_ENABLE
extern void SelfDiagSetAudAmpType(UINT8 u1ErrorDetectType);
#endif

#ifdef CC_AUD_SAKURA_RENDER
extern void _AUD_UpdateDspConfig(BOOL forceUpdateFlag);
#endif // CC_AUD_SAKURA_RENDER
//---------------------------------------------------------------------------
// Const defitions
//---------------------------------------------------------------------------
//#define CHANGE_ENDIAN       // Change MSB/LSB 
//#define AQ_DEBUG            // Print log
//#define AQ_KEY_DEBUG        // Print table key search log (many logs...)
//#define AQ_SELF_TEST        // For self test only (make some fake data to test...)

#ifdef AQ_DEBUG
#define aq_printf  printf
#else
#define aq_printf(...)  do {} while(0)
#endif
#ifdef AQ_KEY_DEBUG
#define aqkey_printf  printf
#else
#define aqkey_printf(a,b,...)  do {} while(0)
#endif


// Flash layout
#define AQ_LEN          (200*1024)  // In Bytes.
#define AQ_PARTITION    9          // AQ Partition on Flash.

// Data offset in AQ Table
#ifdef CC_AUD_SAKURA_RENDER
#define MM_SVT_SP_OFFSET            AQDATA_ADDRESS_MM_SVT_SP
#define MM_SVT_SPW_OFFSET           AQDATA_ADDRESS_MM_SVT_SPW
#define MM_SVT_HP_OFFSET            AQDATA_ADDRESS_MM_SVT_HP
#define MM_SVT_LO_OFFSET            AQDATA_ADDRESS_MM_SVT_LO
#define MM_SVT_LOH_OFFSET           AQDATA_ADDRESS_MM_SVT_LOH
#define MM_SVT_ASW_OFFSET           AQDATA_ADDRESS_MM_SVT_ASW
#define MM_SVT_DSW_OFFSET           AQDATA_ADDRESS_MM_SVT_DSW
#define MM_SVT_BT_OFFSET            AQDATA_ADDRESS_MM_SVT_BT
#define MM_DRCT_OFFSET              AQDATA_ADDRESS_MM_DRCT
#define MM_LIMT_OFFSET              AQDATA_ADDRESS_MM_LIMT
#define MM_FIR_OFFSET               AQDATA_ADDRESS_MM_FIR
#define MM_LOUDT_OFFSET             AQDATA_ADDRESS_MM_LOUDT
#define MM_SMT_OFFSET               AQDATA_ADDRESS_MM_SMT
#define MM_SWS_OFFSET               AQDATA_ADDRESS_MM_SWS
#define MM_SLT_OFFSET               AQDATA_ADDRESS_MM_SLT
#define MM_SPEQ_OFFSET              AQDATA_ADDRESS_MM_SPEQ
#define MM_AU_DLY_OFFSET            AQDATA_ADDRESS_MM_AU_DLY
#define MM_ADCT_OFFSET              AQDATA_ADDRESS_MM_ADCT
#define MM_ACT_OFFSET               AQDATA_ADDRESS_MM_ACT
#define MM_ADT_OFFSET               AQDATA_ADDRESS_MM_ADT
#define MM_RSV_OFFSET               AQDATA_ADDRESS_MM_RSV
#define DA_GENERAL_CONFIG_OFFSET    AQDATA_ADDRESS_DA_GENERAL_CONFIG
#define DA_5760_CONFIG1_OFFSET      AQDATA_ADDRESS_DA_5760_CONFIG1
#define DA_5760_CONFIG2_OFFSET      AQDATA_ADDRESS_DA_5760_CONFIG2
#define DA_5538_CONFIG_OFFSET       AQDATA_ADDRESS_DA_5538_CONFIG
#define DA_5538_BQ_OFFSET           AQDATA_ADDRESS_DA_5538_BQ
#define DA_5538_BT_OFFSET           AQDATA_ADDRESS_DA_5538_BT
#define DA_5538_LOUD_OFFSET         AQDATA_ADDRESS_DA_5538_LOUD
#define DA_5538_DRC_OFFSET          AQDATA_ADDRESS_DA_5538_DRC

// Data position in 32 bit Key.
// If add or modify these position, please check the definition of LOOP_OF_XX_KEY and NUM_OF_KEY.
#define FS_POS              0
#define MM_MODE_POS         4
#define WIRELESS_WOOFER_POS 8
#define TV_POSITION_POS     12
#define INPUT_POS           16
#define SOUND_MODE_POS      20
#define BT_TYPE_POS         24
#define PICTURE_MODE_POS    28

#define TYPE_ANY    0x0
#define AQ_MAKE_KEY(FS, MODE, WIRELESS, POS, INPUT, SND_MODE, BT_TYPE, PIC )  \ 
                   (((FS    << FS_POS)    | (MODE     << MM_MODE_POS)    | (WIRELESS << WIRELESS_WOOFER_POS) | (POS << TV_POSITION_POS) | \
                     (INPUT << INPUT_POS) | (SND_MODE << SOUND_MODE_POS) | (BT_TYPE  << BT_TYPE_POS)         | (PIC << PICTURE_MODE_POS)) \
                     & 0xFFFFFFFF)

#define LOOP_OF_INTPUT_KEY  (4)   // INPUT is in bit16~19, which is in the 4th loop when checking key.
#define LOOP_OF_S_MODE_KEY  (5)   // SOUND MODE is in bit20~23, which is in the 5th loop when checking key.
#define NUM_OF_KEY          (8)   // Key is 32 Bit, every item is 4 Bit, now we use 32 bit (0xFFFFFFFF)

#else

#define MM_SVT_SP_OFFSET 8 
#define MM_SVT_SPW_OFFSET 824 
#define MM_SVT_HP_OFFSET 1640 
#define MM_SVT_LO_OFFSET 2456 
#define MM_SVT_LOH_OFFSET 3272 
#define MM_SVT_ASW_OFFSET 4088 
#define MM_SVT_DSW_OFFSET 4904 
#define MM_SVT_BT_OFFSET 5720 
#define MM_DRCT_OFFSET 6536 
#define MM_LIMT_OFFSET 9128 
#define MM_FIR_OFFSET 10280 
#define MM_LOUDT_OFFSET         14408
#define MM_SMT_OFFSET   14792
#define MM_SWS_OFFSET   26792
#define MM_SLT_OFFSET   28232
#define MM_SPEQ_OFFSET  28360
#define MM_AU_DLY_OFFSET        28792
#define MM_ADCT_OFFSET  28888
#define MM_ACT_OFFSET   28904
#define MM_ADT_OFFSET   28928
#define MM_RSV_OFFSET   28960
#define DA_GENERAL_CONFIG_OFFSET        28976
#define DA_5760_CONFIG1_OFFSET  28984
#define DA_5760_CONFIG2_OFFSET  28992
#define DA_5538_CONFIG_OFFSET   29000
#define DA_5538_BQ_OFFSET       29124
#define DA_5538_BT_OFFSET       30244
#define DA_5538_LOUD_OFFSET     30284
#define DA_5538_DRC_OFFSET      30356


// Data position in 32 bit Key.
#define FS_POS              0
#define MM_MODE_POS         4
#define TV_POSITION_POS     8
#define INPUT_POS           12
#define SOUND_MODE_POS      16
#define SOUND_BOOSTER_POS   20
#define CLAER_AUD_POS       20
#define BT_TYPE_POS         20
#define WIRELESS_WOOFER_POS 24
#define PICTURE_MODE_POS    24

#define TYPE_ANY    0xF
#define AQ_MAKE_KEY(FS, MODE, POS, INPUT, SND_MODE, BOOSTER, WIRELESS)  \
                   (((FS <<FS_POS) | (MODE <<MM_MODE_POS) | (POS <<TV_POSITION_POS) | \
                    (INPUT <<INPUT_POS) | (SND_MODE <<SOUND_MODE_POS) | (BOOSTER <<SOUND_BOOSTER_POS) |  \
                    (WIRELESS <<WIRELESS_WOOFER_POS)) & 0x0FFFFFFF)


#define LOOP_OF_INTPUT_KEY  (3)     // INPUT is in bit12~15, which is in the 3rd loop when checking key.
#define NUM_OF_KEY          (8-1)   // Key is 32 Bit, every item is 4 Bit, now we use 28 bit (0x0FFFFFFF)

#endif /* CC_AUD_SAKURA_RENDER */

#define AQ_ADT_MODE_ON      0x99
#define AQ_SPKSEL_IS_ORIGNAL  0x99
#define AQ_SPKCFG_IS_ORIGNAL  0x99

#ifndef CC_AUD_SAKURA_RENDER
#define APROC_POSTBUF_BLOCK_SIZE 64 // samples in one block 
#endif /* CC_AUD_SAKURA_RENDER */

#ifdef CC_AUD_SAKURA_RENDER
//-----------------------------------------------------------------------------
// Grobal
//-----------------------------------------------------------------------------
AQDataDa5760Config1 gDa5760Cfg1Data;
AQDataDa5760Config2 gDa5760Cfg2Data;
AQDataDa5538Config gDa5538CfgData;
AQDataDa5538Bq gDa5538BqData;
AQDataDa5538Bt gDa5538BtData;
AQDataDa5538Loud gDa5538LoudData;
AQDataDa5538Drc gDa5538DrcData;
#endif /* CC_AUD_SAKURA_RENDER */
//-----------------------------------------------------------------------------
// Static variables
//-----------------------------------------------------------------------------
#ifndef CC_AUD_SAKURA_RENDER
typedef struct
{
    UINT32 u4DrvDly;           //ms,   Delay from MTK video driver
    UINT32 u4BeDly;            //ms,   Delay from SONY 4K/2K Ex-FRC
    INT32  i4MainAdj;          //ms,   (-128..127ms) caculate from MM_MAIN_ADJ of AQ 
    UINT32 u4MainDelay;        //bank, value set to APROC MainDelay
    UINT32 u4SpAdj;            //bank, value from AQ(m_MmSpAdj) and covert ms to bank.
    UINT32 u4SubWooferSync;    //0.24, UI value 0..24 means -12..12
    UINT32 u4USwDlyAdj;        //bank, from UI mapping to banks,
    UINT32 u4LSwDlyAdj;        //bank, from UI mapping to banks,
    UINT32 u4SpDiffDelay;      //bank, Value set to APROC speaker diff delay
    UINT32 u4AssistSpDiffDelay;//bank, Value set to APROC assist speaker diff delay
    UINT32 u4HoLoSwAdj;        //ms,   Value from AQ(m_MmHoloswAdj) and convert to ms.
    UINT32 u4HpDiffDelay;      //bank, Value set to APROC HP Diff Delay.
    UINT32 u4Spdif_Adj;        //ms,   Value from AQ(m_MmSpdifAdj) and convert to ms.
    UINT32 u4SpdifDiffDelay;   //bank, Value set to APROC SPDIF Diff Delay.
    UINT32 u4SpdifRawDelay;    //Frames, Value set to APROC SPDIF Raw Delay.    
} AQ_DLY_SETVAL_T;

AQ_DLY_SETVAL_T rAudDlySetValInfo;
#endif /* CC_AUD_SAKURA_RENDER */

typedef struct
{
    UINT32 u4Key;
    UINT32 u4ExceptKey;
    UINT32 u4Inputs;    
} AQ_TBL_KEY_T;
#ifndef CC_AUD_SAKURA_RENDER
AQ_TBL_KEY_T _ar_MmSvtSpTbl_Key[AQDATA_INDEX_MM_SVT_SP_MAX]= {0};
AQ_TBL_KEY_T _ar_MmSvtSpwTbl_Key[AQDATA_INDEX_MM_SVT_SPW_MAX]= {0};
AQ_TBL_KEY_T _ar_MmSvtHpTbl_Key[AQDATA_INDEX_MM_SVT_HP_MAX]= {0};
AQ_TBL_KEY_T _ar_MmSvtLoTbl_Key[AQDATA_INDEX_MM_SVT_LO_MAX]= {0};
AQ_TBL_KEY_T _ar_MmSvtLohTbl_Key[AQDATA_INDEX_MM_SVT_LOH_MAX]= {0};
AQ_TBL_KEY_T _ar_MmSvtAswTbl_Key[AQDATA_INDEX_MM_SVT_ASW_MAX]= {0};
AQ_TBL_KEY_T _ar_MmSvtDswTbl_Key[AQDATA_INDEX_MM_SVT_DSW_MAX]= {0};
AQ_TBL_KEY_T _ar_MmSvtBtTbl_Key[AQDATA_INDEX_MM_SVT_BT_MAX]= {0};
AQ_TBL_KEY_T _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_MAX]= {0};
AQ_TBL_KEY_T _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_MAX]= {0};
AQ_TBL_KEY_T _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_MAX]= {0};
AQ_TBL_KEY_T _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_MAX]= {0};
AQ_TBL_KEY_T _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_MAX]= {0};
AQ_TBL_KEY_T _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_MAX]= {0};
AQ_TBL_KEY_T _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_MAX]= {0};
AQ_TBL_KEY_T _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_MAX]= {0};
AQ_TBL_KEY_T _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_MAX]= {0};
AQ_TBL_KEY_T _ar_MmAdctTbl_Key[AQDATA_INDEX_MM_ADCT_MAX]= {0};
AQ_TBL_KEY_T _ar_MmActTbl_Key[AQDATA_INDEX_MM_ACT_MAX]= {0};
AQ_TBL_KEY_T _ar_MmAdtTbl_Key[AQDATA_INDEX_MM_ADT_MAX]= {0};
AQ_TBL_KEY_T _ar_MmRsvTbl_Key[AQDATA_INDEX_MM_RSV_MAX]= {0};
AQ_TBL_KEY_T _ar_DaGeneralConfigTbl_Key[AQDATA_INDEX_DA_GENERAL_CONFIG_MAX]= {0};
AQ_TBL_KEY_T _ar_Da5760Config1Tbl_Key[AQDATA_INDEX_DA_5760_CONFIG1_MAX]= {0};
AQ_TBL_KEY_T _ar_Da5760Config2Tbl_Key[AQDATA_INDEX_DA_5760_CONFIG2_MAX]= {0};
AQ_TBL_KEY_T _ar_Da5538ConfigTbl_Key[AQDATA_INDEX_DA_5538_CONFIG_MAX]= {0};
AQ_TBL_KEY_T _ar_Da5538BqTbl_Key[AQDATA_INDEX_DA_5538_BQ_MAX]= {0};
AQ_TBL_KEY_T _ar_Da5538BtTbl_Key[AQDATA_INDEX_DA_5538_BT_MAX]= {0};
AQ_TBL_KEY_T _ar_Da5538LoudTbl_Key[AQDATA_INDEX_DA_5538_LOUD_MAX]= {0};
AQ_TBL_KEY_T _ar_Da5538DrcTbl_Key[AQDATA_INDEX_DA_5538_DRC_MAX]= {0};

#else
AQ_TBL_KEY_T _ar_MmSvtSpTbl_Key[AQDATA_INDEX_MM_SVT_SP_MAX];
AQ_TBL_KEY_T _ar_MmSvtSpwTbl_Key[AQDATA_INDEX_MM_SVT_SPW_MAX];
AQ_TBL_KEY_T _ar_MmSvtHpTbl_Key[AQDATA_INDEX_MM_SVT_HP_MAX];
AQ_TBL_KEY_T _ar_MmSvtLoTbl_Key[AQDATA_INDEX_MM_SVT_LO_MAX];
AQ_TBL_KEY_T _ar_MmSvtLohTbl_Key[AQDATA_INDEX_MM_SVT_LOH_MAX];
AQ_TBL_KEY_T _ar_MmSvtAswTbl_Key[AQDATA_INDEX_MM_SVT_ASW_MAX];
AQ_TBL_KEY_T _ar_MmSvtDswTbl_Key[AQDATA_INDEX_MM_SVT_DSW_MAX];
AQ_TBL_KEY_T _ar_MmSvtBtTbl_Key[AQDATA_INDEX_MM_SVT_BT_MAX];
AQ_TBL_KEY_T _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_MAX];
AQ_TBL_KEY_T _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_MAX];
AQ_TBL_KEY_T _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_MAX];
AQ_TBL_KEY_T _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_MAX];
AQ_TBL_KEY_T _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_MAX];
AQ_TBL_KEY_T _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_MAX];
AQ_TBL_KEY_T _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_MAX];
AQ_TBL_KEY_T _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_MAX];
AQ_TBL_KEY_T _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_MAX];
AQ_TBL_KEY_T _ar_MmAdctTbl_Key[AQDATA_INDEX_MM_ADCT_MAX];
AQ_TBL_KEY_T _ar_MmActTbl_Key[AQDATA_INDEX_MM_ACT_MAX];
AQ_TBL_KEY_T _ar_MmAdtTbl_Key[AQDATA_INDEX_MM_ADT_MAX];
AQ_TBL_KEY_T _ar_MmRsvTbl_Key[AQDATA_INDEX_MM_RSV_MAX];
AQ_TBL_KEY_T _ar_DaGeneralConfigTbl_Key[AQDATA_INDEX_DA_GENERAL_CONFIG_MAX];
AQ_TBL_KEY_T _ar_Da5760Config1Tbl_Key[AQDATA_INDEX_DA_5760_CONFIG1_MAX];
AQ_TBL_KEY_T _ar_Da5760Config2Tbl_Key[AQDATA_INDEX_DA_5760_CONFIG2_MAX];
AQ_TBL_KEY_T _ar_Da5538ConfigTbl_Key[AQDATA_INDEX_DA_5538_CONFIG_MAX];
AQ_TBL_KEY_T _ar_Da5538BqTbl_Key[AQDATA_INDEX_DA_5538_BQ_MAX];
AQ_TBL_KEY_T _ar_Da5538BtTbl_Key[AQDATA_INDEX_DA_5538_BT_MAX];
AQ_TBL_KEY_T _ar_Da5538LoudTbl_Key[AQDATA_INDEX_DA_5538_LOUD_MAX];
AQ_TBL_KEY_T _ar_Da5538DrcTbl_Key[AQDATA_INDEX_DA_5538_DRC_MAX];
#endif /* CC_AUD_SAKURA_RENDER */
extern CUST_AUD_SOUND_SETTING_T gSoundSetting;

#ifndef CC_AUD_SAKURA_RENDER
#define VOL_STEP 1201 //from 0~-120 dB, in 0.1 dB steps.

//dB table for volume, 
UINT32 gu4DbTable[VOL_STEP] = {
0x7fffff, 0x7e88e7, 0x7d161b, 0x7ba78d, 0x7a3d31, 0x78d6fc, 0x7774e0, 0x7616d1, 
0x74bcc5, 0x7366ae, 0x721482, 0x70c635, 0x6f7bbb, 0x6e350a, 0x6cf217, 0x6bb2d5, 
0x6a773b, 0x693f3e, 0x680ad4, 0x66d9f1, 0x65ac8b, 0x648299, 0x635c10, 0x6238e6, 
0x611911, 0x5ffc88, 0x5ee340, 0x5dcd31, 0x5cba51, 0x5baa96, 0x5a9df7, 0x59946b, 
0x588dea, 0x578a6a, 0x5689e2, 0x558c4a, 0x54919a, 0x5399c8, 0x52a4cc, 0x51b29e, 
0x50c335, 0x4fd68a, 0x4eec95, 0x4e054d, 0x4d20ac, 0x4c3ea8, 0x4b5f3a, 0x4a825b, 
0x49a803, 0x48d02c, 0x47facc, 0x4727de, 0x46575a, 0x45893a, 0x44bd75, 0x43f405, 
0x432ce4, 0x42680a, 0x41a571, 0x40e512, 0x4026e7, 0x3f6ae9, 0x3eb112, 0x3df95c, 
0x3d43c0, 0x3c9038, 0x3bdebe, 0x3b2f4d, 0x3a81dd, 0x39d66a, 0x392ced, 0x388561, 
0x37dfc0, 0x373c04, 0x369a28, 0x35fa26, 0x355bf9, 0x34bf9c, 0x342509, 0x338c3b, 
0x32f52d, 0x325fd9, 0x31cc3b, 0x313a4d, 0x30aa0b, 0x301b70, 0x2f8e77, 0x2f031b, 
0x2e7957, 0x2df127, 0x2d6a86, 0x2ce570, 0x2c61df, 0x2bdfd0, 0x2b5f3e, 0x2ae025, 
0x2a6281, 0x29e64c, 0x296b84, 0x28f223, 0x287a26, 0x280389, 0x278e47, 0x271a5d, 
0x26a7c7, 0x263680, 0x25c685, 0x2557d3, 0x24ea65, 0x247e37, 0x241347, 0x23a990, 
0x23410e, 0x22d9bf, 0x22739f, 0x220eaa, 0x21aadc, 0x214834, 0x20e6ac, 0x208642, 
0x2026f3, 0x1fc8bb, 0x1f6b97, 0x1f0f84, 0x1eb47f, 0x1e5a84, 0x1e0191, 0x1da9a3, 
0x1d52b7, 0x1cfcc9, 0x1ca7d7, 0x1c53de, 0x1c00db, 0x1baecc, 0x1b5dac, 0x1b0d7b, 
0x1abe34, 0x1a6fd6, 0x1a225e, 0x19d5c8, 0x198a13, 0x193f3c, 0x18f540, 0x18ac1d, 
0x1863d0, 0x181c57, 0x17d5b0, 0x178fd7, 0x174acc, 0x17068a, 0x16c311, 0x16805d, 
0x163e6d, 0x15fd3e, 0x15bcce, 0x157d1b, 0x153e22, 0x14ffe2, 0x14c259, 0x148584, 
0x144961, 0x140dee, 0x13d329, 0x139911, 0x135fa3, 0x1326dd, 0x12eebe, 0x12b743, 
0x12806b, 0x124a33, 0x12149a, 0x11df9f, 0x11ab3e, 0x117777, 0x114448, 0x1111af, 
0x10dfaa, 0x10ae37, 0x107d56, 0x104d04, 0x101d3f, 0x0fee06, 0x0fbf58, 0x0f9133, 
0x0f6394, 0x0f367c, 0x0f09e7, 0x0eddd6, 0x0eb245, 0x0e8734, 0x0e5ca1, 0x0e328b, 
0x0e08f0, 0x0ddfd0, 0x0db727, 0x0d8ef6, 0x0d673b, 0x0d3ff4, 0x0d1920, 0x0cf2be, 
0x0ccccd, 0x0ca74a, 0x0c8236, 0x0c5d8e, 0x0c3952, 0x0c1580, 0x0bf216, 0x0bcf15, 
0x0bac7a, 0x0b8a45, 0x0b6873, 0x0b4705, 0x0b25f9, 0x0b054e, 0x0ae502, 0x0ac515, 
0x0aa586, 0x0a8653, 0x0a677c, 0x0a48fe, 0x0a2adb, 0x0a0d0f, 0x09ef9b, 0x09d27d, 
0x09b5b5, 0x099941, 0x097d20, 0x096152, 0x0945d5, 0x092aa9, 0x090fcc, 0x08f53e, 
0x08dafe, 0x08c10b, 0x08a763, 0x088e07, 0x0874f6, 0x085c2e, 0x0843ae, 0x082b76, 
0x081385, 0x07fbdb, 0x07e475, 0x07cd55, 0x07b678, 0x079fde, 0x078986, 0x077370, 
0x075d9a, 0x074804, 0x0732ae, 0x071d96, 0x0708bc, 0x06f41f, 0x06dfbf, 0x06cb9a, 
0x06b7b0, 0x06a401, 0x06908b, 0x067d4f, 0x066a4a, 0x06577e, 0x0644e8, 0x063289, 
0x062060, 0x060e6c, 0x05fcad, 0x05eb21, 0x05d9c9, 0x05c8a4, 0x05b7b1, 0x05a6f0, 
0x059660, 0x058600, 0x0575d1, 0x0565d1, 0x0555ff, 0x05465c, 0x0536e7, 0x05279f, 
0x051884, 0x050996, 0x04fad3, 0x04ec3b, 0x04ddce, 0x04cf8b, 0x04c172, 0x04b383, 
0x04a5bc, 0x04981e, 0x048aa7, 0x047d58, 0x047030, 0x04632e, 0x045653, 0x04499d, 
0x043d0d, 0x0430a1, 0x04245a, 0x041837, 0x040c37, 0x04005b, 0x03f4a1, 0x03e909, 
0x03dd94, 0x03d240, 0x03c70d, 0x03bbfb, 0x03b10a, 0x03a639, 0x039b87, 0x0390f5, 
0x038681, 0x037c2d, 0x0371f6, 0x0367de, 0x035de3, 0x035405, 0x034a44, 0x0340a0, 
0x033718, 0x032dac, 0x03245c, 0x031b27, 0x03120d, 0x03090d, 0x030028, 0x02f75d, 
0x02eeac, 0x02e614, 0x02dd96, 0x02d530, 0x02cce3, 0x02c4ae, 0x02bc91, 0x02b48c, 
0x02ac9f, 0x02a4c9, 0x029d09, 0x029561, 0x028dcf, 0x028653, 0x027eed, 0x02779c, 
0x027062, 0x02693c, 0x02622b, 0x025b2f, 0x025448, 0x024d74, 0x0246b5, 0x024009, 
0x023971, 0x0232ed, 0x022c7b, 0x02261c, 0x021fd0, 0x021997, 0x02136f, 0x020d5a, 
0x020756, 0x020165, 0x01fb84, 0x01f5b5, 0x01eff7, 0x01ea49, 0x01e4ad, 0x01df20, 
0x01d9a4, 0x01d438, 0x01cedc, 0x01c990, 0x01c453, 0x01bf26, 0x01ba07, 0x01b4f8, 
0x01aff7, 0x01ab06, 0x01a622, 0x01a14d, 0x019c86, 0x0197cd, 0x019322, 0x018e85, 
0x0189f5, 0x018573, 0x0180fe, 0x017c95, 0x01783a, 0x0173ec, 0x016faa, 0x016b74, 
0x01674b, 0x01632e, 0x015f1e, 0x015b19, 0x01571f, 0x015332, 0x014f50, 0x014b79, 
0x0147ae, 0x0143ee, 0x014039, 0x013c8e, 0x0138ef, 0x01355a, 0x0131cf, 0x012e4f, 
0x012ad9, 0x01276d, 0x01240c, 0x0120b4, 0x011d66, 0x011a21, 0x0116e7, 0x0113b5, 
0x01108d, 0x010d6f, 0x010a59, 0x01074d, 0x010449, 0x01014e, 0x00fe5c, 0x00fb73, 
0x00f892, 0x00f5ba, 0x00f2ea, 0x00f022, 0x00ed62, 0x00eaaa, 0x00e7fb, 0x00e553, 
0x00e2b3, 0x00e01b, 0x00dd8a, 0x00db01, 0x00d87f, 0x00d605, 0x00d391, 0x00d125, 
0x00cec1, 0x00cc63, 0x00ca0c, 0x00c7bc, 0x00c572, 0x00c330, 0x00c0f4, 0x00bebe, 
0x00bc8f, 0x00ba67, 0x00b845, 0x00b629, 0x00b413, 0x00b203, 0x00aff9, 0x00adf6, 
0x00abf8, 0x00aa00, 0x00a80e, 0x00a621, 0x00a43b, 0x00a259, 0x00a07e, 0x009ea7, 
0x009cd6, 0x009b0b, 0x009944, 0x009783, 0x0095c7, 0x009410, 0x00925f, 0x0090b2, 
0x008f0a, 0x008d66, 0x008bc8, 0x008a2e, 0x00889a, 0x008709, 0x00857e, 0x0083f6, 
0x008274, 0x0080f5, 0x007f7b, 0x007e06, 0x007c95, 0x007b28, 0x0079bf, 0x00785a, 
0x0076f9, 0x00759d, 0x007444, 0x0072ef, 0x00719e, 0x007051, 0x006f08, 0x006dc3, 
0x006c81, 0x006b43, 0x006a09, 0x0068d2, 0x00679f, 0x00666f, 0x006543, 0x00641b, 
0x0062f5, 0x0061d3, 0x0060b5, 0x005f99, 0x005e81, 0x005d6c, 0x005c5a, 0x005b4c, 
0x005a40, 0x005938, 0x005832, 0x005730, 0x005630, 0x005534, 0x00543a, 0x005343, 
0x00524f, 0x00515e, 0x005070, 0x004f84, 0x004e9b, 0x004db5, 0x004cd1, 0x004bf0, 
0x004b11, 0x004a35, 0x00495c, 0x004885, 0x0047b0, 0x0046de, 0x00460f, 0x004541, 
0x004476, 0x0043ae, 0x0042e7, 0x004223, 0x004161, 0x0040a2, 0x003fe4, 0x003f29, 
0x003e70, 0x003db9, 0x003d04, 0x003c52, 0x003ba1, 0x003af2, 0x003a45, 0x00399b, 
0x0038f2, 0x00384b, 0x0037a6, 0x003703, 0x003662, 0x0035c2, 0x003525, 0x003489, 
0x0033ef, 0x003357, 0x0032c0, 0x00322c, 0x003199, 0x003107, 0x003078, 0x002fea, 
0x002f5d, 0x002ed2, 0x002e49, 0x002dc2, 0x002d3c, 0x002cb7, 0x002c34, 0x002bb2, 
0x002b32, 0x002ab4, 0x002a37, 0x0029bb, 0x002941, 0x0028c8, 0x002850, 0x0027da, 
0x002765, 0x0026f2, 0x002680, 0x00260f, 0x00259f, 0x002531, 0x0024c4, 0x002458, 
0x0023ee, 0x002385, 0x00231d, 0x0022b6, 0x002250, 0x0021eb, 0x002188, 0x002126, 
0x0020c5, 0x002065, 0x002006, 0x001fa8, 0x001f4b, 0x001eef, 0x001e95, 0x001e3b, 
0x001de3, 0x001d8b, 0x001d34, 0x001cdf, 0x001c8a, 0x001c37, 0x001be4, 0x001b92, 
0x001b41, 0x001af1, 0x001aa3, 0x001a54, 0x001a07, 0x0019bb, 0x001970, 0x001925, 
0x0018db, 0x001893, 0x00184b, 0x001803, 0x0017bd, 0x001777, 0x001733, 0x0016ef, 
0x0016ab, 0x001669, 0x001627, 0x0015e6, 0x0015a6, 0x001567, 0x001528, 0x0014ea, 
0x0014ad, 0x001470, 0x001434, 0x0013f9, 0x0013bf, 0x001385, 0x00134c, 0x001313, 
0x0012db, 0x0012a4, 0x00126d, 0x001237, 0x001202, 0x0011cd, 0x001199, 0x001165, 
0x001132, 0x001100, 0x0010ce, 0x00109d, 0x00106c, 0x00103c, 0x00100d, 0x000fde, 
0x000faf, 0x000f81, 0x000f54, 0x000f27, 0x000efa, 0x000ece, 0x000ea3, 0x000e78, 
0x000e4e, 0x000e24, 0x000dfa, 0x000dd1, 0x000da9, 0x000d81, 0x000d59, 0x000d32, 
0x000d0c, 0x000ce5, 0x000cc0, 0x000c9a, 0x000c75, 0x000c51, 0x000c2d, 0x000c09, 
0x000be6, 0x000bc3, 0x000ba0, 0x000b7e, 0x000b5d, 0x000b3b, 0x000b1a, 0x000afa, 
0x000ada, 0x000aba, 0x000a9b, 0x000a7b, 0x000a5d, 0x000a3e, 0x000a20, 0x000a03, 
0x0009e5, 0x0009c8, 0x0009ac, 0x00098f, 0x000973, 0x000958, 0x00093c, 0x000921, 
0x000906, 0x0008ec, 0x0008d2, 0x0008b8, 0x00089e, 0x000885, 0x00086c, 0x000854, 
0x00083b, 0x000823, 0x00080b, 0x0007f4, 0x0007dc, 0x0007c5, 0x0007ae, 0x000798, 
0x000782, 0x00076c, 0x000756, 0x000740, 0x00072b, 0x000716, 0x000701, 0x0006ed, 
0x0006d9, 0x0006c5, 0x0006b1, 0x00069d, 0x00068a, 0x000677, 0x000664, 0x000651, 
0x00063e, 0x00062c, 0x00061a, 0x000608, 0x0005f6, 0x0005e5, 0x0005d4, 0x0005c3, 
0x0005b2, 0x0005a1, 0x000591, 0x000580, 0x000570, 0x000560, 0x000550, 0x000541, 
0x000532, 0x000522, 0x000513, 0x000504, 0x0004f6, 0x0004e7, 0x0004d9, 0x0004cb, 
0x0004bd, 0x0004af, 0x0004a1, 0x000493, 0x000486, 0x000479, 0x00046c, 0x00045f, 
0x000452, 0x000445, 0x000439, 0x00042c, 0x000420, 0x000414, 0x000408, 0x0003fc, 
0x0003f1, 0x0003e5, 0x0003da, 0x0003ce, 0x0003c3, 0x0003b8, 0x0003ad, 0x0003a2, 
0x000398, 0x00038d, 0x000383, 0x000379, 0x00036e, 0x000364, 0x00035a, 0x000351, 
0x000347, 0x00033d, 0x000334, 0x00032a, 0x000321, 0x000318, 0x00030f, 0x000306, 
0x0002fd, 0x0002f4, 0x0002ec, 0x0002e3, 0x0002db, 0x0002d2, 0x0002ca, 0x0002c2, 
0x0002ba, 0x0002b2, 0x0002aa, 0x0002a2, 0x00029a, 0x000293, 0x00028b, 0x000284, 
0x00027c, 0x000275, 0x00026e, 0x000267, 0x000260, 0x000259, 0x000252, 0x00024b, 
0x000244, 0x00023e, 0x000237, 0x000231, 0x00022a, 0x000224, 0x00021e, 0x000217, 
0x000211, 0x00020b, 0x000205, 0x0001ff, 0x0001f9, 0x0001f4, 0x0001ee, 0x0001e8, 
0x0001e3, 0x0001dd, 0x0001d8, 0x0001d2, 0x0001cd, 0x0001c8, 0x0001c2, 0x0001bd, 
0x0001b8, 0x0001b3, 0x0001ae, 0x0001a9, 0x0001a4, 0x0001a0, 0x00019b, 0x000196, 
0x000192, 0x00018d, 0x000188, 0x000184, 0x00017f, 0x00017b, 0x000177, 0x000172, 
0x00016e, 0x00016a, 0x000166, 0x000162, 0x00015e, 0x00015a, 0x000156, 0x000152, 
0x00014e, 0x00014a, 0x000146, 0x000143, 0x00013f, 0x00013b, 0x000138, 0x000134, 
0x000131, 0x00012d, 0x00012a, 0x000126, 0x000123, 0x000120, 0x00011c, 0x000119, 
0x000116, 0x000113, 0x00010f, 0x00010c, 0x000109, 0x000106, 0x000103, 0x000100, 
0x0000fd, 0x0000fa, 0x0000f8, 0x0000f5, 0x0000f2, 0x0000ef, 0x0000ec, 0x0000ea, 
0x0000e7, 0x0000e4, 0x0000e2, 0x0000df, 0x0000dd, 0x0000da, 0x0000d8, 0x0000d5, 
0x0000d3, 0x0000d0, 0x0000ce, 0x0000cc, 0x0000c9, 0x0000c7, 0x0000c5, 0x0000c2, 
0x0000c0, 0x0000be, 0x0000bc, 0x0000ba, 0x0000b8, 0x0000b5, 0x0000b3, 0x0000b1, 
0x0000af, 0x0000ad, 0x0000ab, 0x0000a9, 0x0000a7, 0x0000a5, 0x0000a4, 0x0000a2, 
0x0000a0, 0x00009e, 0x00009c, 0x00009a, 0x000099, 0x000097, 0x000095, 0x000093, 
0x000092, 0x000090, 0x00008e, 0x00008d, 0x00008b, 0x00008a, 0x000088, 0x000086, 
0x000085, 0x000083, 0x000082, 0x000080, 0x00007f, 0x00007e, 0x00007c, 0x00007b, 
0x000079, 0x000078, 0x000076, 0x000075, 0x000074, 0x000072, 0x000071, 0x000070, 
0x00006f, 0x00006d, 0x00006c, 0x00006b, 0x00006a, 0x000068, 0x000067, 0x000066, 
0x000065, 0x000064, 0x000063, 0x000061, 0x000060, 0x00005f, 0x00005e, 0x00005d, 
0x00005c, 0x00005b, 0x00005a, 0x000059, 0x000058, 0x000057, 0x000056, 0x000055, 
0x000054, 0x000053, 0x000052, 0x000051, 0x000050, 0x00004f, 0x00004e, 0x00004d, 
0x00004d, 0x00004c, 0x00004b, 0x00004a, 0x000049, 0x000048, 0x000047, 0x000047, 
0x000046, 0x000045, 0x000044, 0x000043, 0x000043, 0x000042, 0x000041, 0x000040, 
0x000040, 0x00003f, 0x00003e, 0x00003d, 0x00003d, 0x00003c, 0x00003b, 0x00003b, 
0x00003a, 0x000039, 0x000039, 0x000038, 0x000037, 0x000037, 0x000036, 0x000036, 
0x000035, 0x000034, 0x000034, 0x000033, 0x000033, 0x000032, 0x000031, 0x000031, 
0x000030, 0x000030, 0x00002f, 0x00002f, 0x00002e, 0x00002e, 0x00002d, 0x00002d, 
0x00002c, 0x00002c, 0x00002b, 0x00002b, 0x00002a, 0x00002a, 0x000029, 0x000029, 
0x000028, 0x000028, 0x000027, 0x000027, 0x000026, 0x000026, 0x000025, 0x000025, 
0x000025, 0x000024, 0x000024, 0x000023, 0x000023, 0x000023, 0x000022, 0x000022, 
0x000021, 0x000021, 0x000021, 0x000020, 0x000020, 0x000020, 0x00001f, 0x00001f, 
0x00001e, 0x00001e, 0x00001e, 0x00001d, 0x00001d, 0x00001d, 0x00001c, 0x00001c, 
0x00001c, 0x00001b, 0x00001b, 0x00001b, 0x00001b, 0x00001a, 0x00001a, 0x00001a, 
0x000019, 0x000019, 0x000019, 0x000018, 0x000018, 0x000018, 0x000018, 0x000017, 
0x000017, 0x000017, 0x000017, 0x000016, 0x000016, 0x000016, 0x000016, 0x000015, 
0x000015, 0x000015, 0x000015, 0x000014, 0x000014, 0x000014, 0x000014, 0x000013, 
0x000013, 0x000013, 0x000013, 0x000013, 0x000012, 0x000012, 0x000012, 0x000012, 
0x000012, 0x000011, 0x000011, 0x000011, 0x000011, 0x000011, 0x000010, 0x000010, 
0x000010, 0x000010, 0x000010, 0x00000f, 0x00000f, 0x00000f, 0x00000f, 0x00000f, 
0x00000f, 0x00000e, 0x00000e, 0x00000e, 0x00000e, 0x00000e, 0x00000e, 0x00000d, 
0x00000d, 0x00000d, 0x00000d, 0x00000d, 0x00000d, 0x00000d, 0x00000c, 0x00000c, 
0x00000c, 0x00000c, 0x00000c, 0x00000c, 0x00000c, 0x00000b, 0x00000b, 0x00000b, 
0x00000b, 0x00000b, 0x00000b, 0x00000b, 0x00000b, 0x00000a, 0x00000a, 0x00000a, 
0x00000a, 0x00000a, 0x00000a, 0x00000a, 0x00000a, 0x00000a, 0x000009, 0x000009, 
0x000009, 0x000009, 0x000009, 0x000009, 0x000009, 0x000009, 0x000009, 0x000008, 
0x000008, 
};
#endif // CC_AUD_SAKURA_RENDER

//---------------------------------------------------------------------------
// Static functions
//---------------------------------------------------------------------------
INT32 DrvCust_AQ_Init(void);
INT32 DrvCust_AQ_SetVal(UINT32 u4Offset, UINT8 u1Value);
INT32 DrvCust_AQ_List(UINT32 u4Offset, UINT32 Length);
UINT32 DrvCust_AQ_GenKey(AUD_DrvCust_AQ_Key_T rAqKey);

#ifdef CC_AUD_SAKURA_RENDER
INT32 DrvCust_AQ_Get_SVTSP(AQDataMmSvtSp* pGetSvtSpData, UINT32 u4InputKey, UINT32 u4Type);
INT32 DrvCust_AQ_Get_SVTSPW(AQDataMmSvtSpw* pGetSvtSpwData, UINT32 u4InputKey, UINT32 u4Type);
INT32 DrvCust_AQ_Get_SVT_HP(AQDataMmSvtHp* pGetSvtHpData, UINT32 u4InputKey, UINT32 u4Type);
INT32 DrvCust_AQ_Get_SVT_LO(AQDataMmSvtLo* pGetSvtLoData, UINT32 u4InputKey, UINT32 u4Type);
INT32 DrvCust_AQ_Get_SVT_LOH(AQDataMmSvtLoh* pGetSvtLohData, UINT32 u4InputKey, UINT32 u4Type);
INT32 DrvCust_AQ_Get_SVT_ASW(AQDataMmSvtAsw* pGetSvtAswData, UINT32 u4InputKey, UINT32 u4Type);
INT32 DrvCust_AQ_Get_SVT_DSW(AQDataMmSvtDsw* pGetSvtDswData, UINT32 u4InputKey, UINT32 u4Type);
INT32 DrvCust_AQ_Get_SVT_BT(AQDataMmSvtBt* pGetSvtBtData, UINT32 u4InputKey, UINT32 u4Type);
INT32 DrvCust_AQ_Get_SLT(AQDataMmSlt* pGetSltData, UINT32 u4InputKey, UINT32 u4Type);
INT32 DrvCust_AQ_Get_FIR(AQDataMmFir* pGetFirData, UINT32* pGetFirIdx, UINT32 u4InputKey, UINT32 u4Type);
INT32 DrvCust_AQ_Get_DLY(AQDataMmAuDly* pDlyData, UINT32* pGetDlyIdx, UINT32 u4InputKey, UINT32 u4Type);
INT32 DrvCust_AQ_Get_LIMT(AQDataMmLimt* pGetLimtData, UINT32 u4InputKey, UINT32 u4Type);
INT32 DrvCust_AQ_Get_RSV(AQDataMmRsv* pGetRsvData, UINT32 u4InputKey, UINT32 u4Type);
INT32 DrvCust_AQ_Get_DA_5760_CONFIG1(UINT32 u4InputKey, UINT32 u4Type);
INT32 DrvCust_AQ_Get_DA_5760_CONFIG2(UINT32 u4InputKey, UINT32 u4Type);
INT32 DrvCust_AQ_Get_DA_5538_CONFIG(UINT32 u4InputKey, UINT32 u4Type);
INT32 DrvCust_AQ_Get_DA_5538_BQ(UINT32 u4InputKey, UINT32 u4Type);
INT32 DrvCust_AQ_Get_DA_5538_BT(UINT32 u4InputKey, UINT32 u4Type);
INT32 DrvCust_AQ_Get_DA_5538_LOUD(UINT32 u4InputKey, UINT32 u4Type);
INT32 DrvCust_AQ_Get_DA_5538_DRC(UINT32 u4InputKey, UINT32 u4Type);
INT32 DrvCust_AQ_Get_DA_GEN_CFG_INIT(UINT32 u4InputKey);
BOOL  DrvCust_AQ_IsSurround(AUD_DrvCust_AQ_Key_T rAqKey);
#else
INT32 DrvCust_AQ_Get_SVTSP(AUD_DrvCust_Qry_T* prQryVol, UINT32 u4InputKey, UINT32 u4VolTbIdx);
INT32 DrvCust_AQ_Get_SVTSPW(AUD_DrvCust_Qry_T* prQryVol, UINT32 u4InputKey, UINT32 u4VolTbIdx);
INT32 DrvCust_AQ_Get_SVT_HP(AUD_DrvCust_Qry_T* prQryVol, UINT32 u4InputKey, UINT32 u4VolTbIdx);
INT32 DrvCust_AQ_Get_SVT_LO(AUD_DrvCust_Qry_T* prQryVol, UINT32 u4InputKey, UINT32 u4VolTbIdx);
INT32 DrvCust_AQ_Get_SVT_LOH(AUD_DrvCust_Qry_T* prQryVol, UINT32 u4InputKey, UINT32 u4VolTbIdx);
INT32 DrvCust_AQ_Get_SVT_ASW(AUD_DrvCust_Qry_T* prQryVol, UINT32 u4InputKey, UINT32 u4VolTbIdx);
INT32 DrvCust_AQ_Get_SVT_DSW(AUD_DrvCust_Qry_T* prQryVol, UINT32 u4InputKey, UINT32 u4VolTbIdx);
INT32 DrvCust_AQ_Get_SVT_BT(AUD_DrvCust_Qry_T* prQryVol, UINT32 u4InputKey, UINT32 u4VolTbIdx);
INT32 DrvCust_AQ_Get_SLT(UINT32 u4InputKey);
INT32 DrvCust_AQ_Get_FIR(UINT32 u4InputKey);
INT32 DrvCust_AQ_Get_DLY(AUD_DLY_INFO_T* rAudDlyInfo, UINT32 u4InputKey, BOOL fgSetValue);
INT32 DrvCust_AQ_Get_LIMT(UINT32 u4InputKey);
INT32 DrvCust_AQ_Get_RSV(UINT32 u4InputKey);
INT32 DrvCust_AQ_Get_DA_5760_CONFIG1(UINT32 u4InputKey);
INT32 DrvCust_AQ_Get_DA_5760_CONFIG2(UINT32 u4InputKey);
INT32 DrvCust_AQ_Get_DA_5538_CONFIG(UINT32 u4InputKey);
INT32 DrvCust_AQ_Get_DA_5538_BQ(UINT32 u4InputKey);
INT32 DrvCust_AQ_Get_DA_5538_BT(UINT32 u4InputKey);
INT32 DrvCust_AQ_Get_DA_5538_LOUD(UINT32 u4InputKey);
INT32 DrvCust_AQ_Get_DA_5538_DRC(UINT32 u4InputKey);
INT32 DrvCust_AQ_Get_DA_GEN_CFG_INIT(UINT32 u4InputKey, AMP_T* _vAmpTbl1 ,AMP_T* _vAmpTbl2);
#endif // CC_AUD_SAKURA_RENDER
INT32 DrvCust_AQ_Get_DRC(UINT32 u4InputKey);
INT32 DrvCust_AQ_Get_SMT(AQDataMmSmt* pGetSmtData, UINT32 u4InputKey, UINT32 u4Type);
INT32 DrvCust_AQ_Get_SPEQ(UINT32 u4InputKey);
INT32 DrvCust_AQ_Get_SWS(AQDataMmSws* pGetSwsData, UINT32 u4InputKey, UINT32 u4Type);
INT32 DrvCust_AQ_Get_LOUDT(UINT32 u4InputKey);
INT32 DrvCust_AQ_Get_ADCT(AQDataMmAdct* pGetAdctData, UINT32 u4InputKey, UINT32 u4Type);
INT32 DrvCust_AQ_Get_ACT(AQDataMmAct* pGetActData, UINT32 u4InputKey, UINT32 u4Type);
INT32 DrvCust_AQ_Get_ADT(UINT32 u4InputKey, BOOL fgExecute);
INT32 DrvCust_AQ_Get_DA_GEN_CFG(UINT32 u4InputKey);

#ifdef CC_COMBINE_4K_2K	
extern UINT32 DRVCUST_Get_2K_Model(void);
#endif
// =================================================
// [!!!!**CAUTION**!!!!]
// 1. Use printf, not LOG
// 2. You can only call public functions in xxx_if.c
//==================================================
INT32 DrvCust_AQ_InitKeys(void)
{
#ifdef CC_AUD_SAKURA_RENDER

// _ar_MmSvtSpTbl_KeyMM_SVT_SP
    _ar_MmSvtSpTbl_Key[AQDATA_INDEX_MM_SVT_SP_0].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSvtSpTbl_Key[AQDATA_INDEX_MM_SVT_SP_1].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmSvtSpwTbl_KeyMM_SVT_SPW
    _ar_MmSvtSpwTbl_Key[AQDATA_INDEX_MM_SVT_SPW_0].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSvtSpwTbl_Key[AQDATA_INDEX_MM_SVT_SPW_1].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmSvtHpTbl_KeyMM_SVT_HP
    _ar_MmSvtHpTbl_Key[AQDATA_INDEX_MM_SVT_HP_0].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSvtHpTbl_Key[AQDATA_INDEX_MM_SVT_HP_1].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmSvtLoTbl_KeyMM_SVT_LO
    _ar_MmSvtLoTbl_Key[AQDATA_INDEX_MM_SVT_LO_0].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSvtLoTbl_Key[AQDATA_INDEX_MM_SVT_LO_1].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmSvtLohTbl_KeyMM_SVT_LOH
    _ar_MmSvtLohTbl_Key[AQDATA_INDEX_MM_SVT_LOH_0].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSvtLohTbl_Key[AQDATA_INDEX_MM_SVT_LOH_1].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmSvtAswTbl_KeyMM_SVT_ASW
    _ar_MmSvtAswTbl_Key[AQDATA_INDEX_MM_SVT_ASW_0].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSvtAswTbl_Key[AQDATA_INDEX_MM_SVT_ASW_1].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmSvtDswTbl_KeyMM_SVT_DSW
    _ar_MmSvtDswTbl_Key[AQDATA_INDEX_MM_SVT_DSW_0].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSvtDswTbl_Key[AQDATA_INDEX_MM_SVT_DSW_1].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmSvtBtTbl_KeyMM_SVT_BT
    _ar_MmSvtBtTbl_Key[AQDATA_INDEX_MM_SVT_BT_0].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSvtBtTbl_Key[AQDATA_INDEX_MM_SVT_BT_1].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmDrctTbl_KeyMM_DRCT
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_0].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_1].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_2].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_3].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_4].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_5].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_1 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_6].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_7].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_8].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_9].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_10].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_11].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_1 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmLimtTbl_KeyMM_LIMT
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_0].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_1].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_2].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_3].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_4].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_5].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_1 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_6].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_7].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_8].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_9].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_10].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_11].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_1 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmFirTbl_KeyMM_FIR
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_0].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_1].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_2].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_3].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_1 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_4].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_5].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_6].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_7].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_1 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmLoudtTbl_KeyMM_LOUDT
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_0].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_1].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_2].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_3].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_4].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_5].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_1 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_6].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_7].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_8].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_9].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_10].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_11].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_1 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmSmtTbl_KeyMM_SMT
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_0].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_OFF , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_STANDARD_SUR_OFF , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_1].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_OFF , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_STANDARD_SUR_ON , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_2].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_OFF , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_CINEMA , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_3].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_OFF , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_MUSIC , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_4].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_OFF , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_FOOTBALL , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_5].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_OFF , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO_SUR_OFF , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_6].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_OFF , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO_SUR_ON , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_7].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_OFF , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_STANDARD_SUR_OFF , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_8].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_OFF , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_STANDARD_SUR_ON , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_9].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_OFF , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_CINEMA , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_10].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_OFF , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_MUSIC , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_11].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_OFF , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_FOOTBALL , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_12].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_OFF , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO_SUR_OFF , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_13].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_OFF , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO_SUR_ON , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_14].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_15].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_ON , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_STANDARD_SUR_OFF , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_16].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_ON , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_STANDARD_SUR_ON , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_17].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_ON , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_CINEMA , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_18].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_ON , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_MUSIC , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_19].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_ON , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_FOOTBALL , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_20].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_ON , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO_SUR_OFF , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_21].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_ON , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO_SUR_ON , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_22].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_ON , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_STANDARD_SUR_OFF , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_23].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_ON , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_STANDARD_SUR_ON , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_24].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_ON , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_CINEMA , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_25].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_ON , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_MUSIC , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_26].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_ON , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_FOOTBALL , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_27].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_ON , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO_SUR_OFF , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_28].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_ON , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO_SUR_ON , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_29].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_1 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_30].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_OFF , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_STANDARD_SUR_OFF , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_31].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_OFF , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_STANDARD_SUR_ON , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_32].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_OFF , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_CINEMA , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_33].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_OFF , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_MUSIC , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_34].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_OFF , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_FOOTBALL , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_35].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_OFF , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO_SUR_OFF , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_36].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_OFF , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO_SUR_ON , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_37].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_OFF , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_STANDARD_SUR_OFF , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_38].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_OFF , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_STANDARD_SUR_ON , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_39].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_OFF , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_CINEMA , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_40].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_OFF , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_MUSIC , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_41].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_OFF , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_FOOTBALL , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_42].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_OFF , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO_SUR_OFF , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_43].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_OFF , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO_SUR_ON , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_44].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_45].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_ON , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_STANDARD_SUR_OFF , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_46].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_ON , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_STANDARD_SUR_ON , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_47].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_ON , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_CINEMA , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_48].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_ON , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_MUSIC , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_49].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_ON , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_FOOTBALL , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_50].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_ON , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO_SUR_OFF , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_51].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_ON , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO_SUR_ON , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_52].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_ON , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_STANDARD_SUR_OFF , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_53].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_ON , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_STANDARD_SUR_ON , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_54].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_ON , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_CINEMA , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_55].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_ON , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_MUSIC , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_56].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_ON , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_FOOTBALL , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_57].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_ON , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO_SUR_OFF , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_58].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_ON , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO_SUR_ON , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_59].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_1 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmSwsTbl_KeyMM_SWS
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_0].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_STANDARD_SUR_OFF , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_1].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_STANDARD_SUR_ON , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_2].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_CINEMA , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_3].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_MUSIC , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_4].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_FOOTBALL , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_5].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO_SUR_OFF , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_6].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO_SUR_ON , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_7].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_STANDARD_SUR_OFF , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_8].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_STANDARD_SUR_ON , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_9].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_CINEMA , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_10].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_MUSIC , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_11].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_FOOTBALL , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_12].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO_SUR_OFF , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_13].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO_SUR_ON , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_14].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_15].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_STANDARD_SUR_OFF , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_16].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_STANDARD_SUR_ON , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_17].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_CINEMA , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_18].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_MUSIC , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_19].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_FOOTBALL , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_20].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO_SUR_OFF , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_21].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO_SUR_ON , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_22].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_STANDARD_SUR_OFF , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_23].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_STANDARD_SUR_ON , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_24].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_CINEMA , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_25].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_MUSIC , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_26].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_FOOTBALL , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_27].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO_SUR_OFF , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_28].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO_SUR_ON , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_29].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmSltTbl_KeyMM_SLT
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_0].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_ANALOG_RF , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_1].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_2].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_3].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_ANALOG_RF , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_4].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_5].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_6].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_7].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_1 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_8].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_ANALOG_RF , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_9].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_10].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_TABLE_STAND , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_11].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_ANALOG_RF , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_12].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_13].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_WALL_MOUNT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_14].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_15].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_1 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_1].u4Inputs = (1<<AQ_INPUT_DIGITAL_RF)|(1<<AQ_INPUT_HDMI)|(1<<AQ_INPUT_VIDEO_APP)|(1<<AQ_INPUT_PHOTO)|(1<<AQ_INPUT_JELLYFISH)|(1<<AQ_INPUT_MIRACAST)|(1<<AQ_INPUT_GENERAL_APP)|(1<<AQ_INPUT_RESERVED1)|(1<<AQ_INPUT_RESERVED2)|(1<<AQ_INPUT_RESERVED3);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_2].u4Inputs = (1<<AQ_INPUT_COMPOSITE)|(1<<AQ_INPUT_COMPONENT)|(1<<AQ_INPUT_PC);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_4].u4Inputs = (1<<AQ_INPUT_DIGITAL_RF)|(1<<AQ_INPUT_HDMI)|(1<<AQ_INPUT_VIDEO_APP)|(1<<AQ_INPUT_PHOTO)|(1<<AQ_INPUT_JELLYFISH)|(1<<AQ_INPUT_MIRACAST)|(1<<AQ_INPUT_GENERAL_APP)|(1<<AQ_INPUT_RESERVED1)|(1<<AQ_INPUT_RESERVED2)|(1<<AQ_INPUT_RESERVED3);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_5].u4Inputs = (1<<AQ_INPUT_COMPOSITE)|(1<<AQ_INPUT_COMPONENT)|(1<<AQ_INPUT_PC);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_9].u4Inputs = (1<<AQ_INPUT_DIGITAL_RF)|(1<<AQ_INPUT_HDMI)|(1<<AQ_INPUT_VIDEO_APP)|(1<<AQ_INPUT_PHOTO)|(1<<AQ_INPUT_JELLYFISH)|(1<<AQ_INPUT_MIRACAST)|(1<<AQ_INPUT_GENERAL_APP)|(1<<AQ_INPUT_RESERVED1)|(1<<AQ_INPUT_RESERVED2)|(1<<AQ_INPUT_RESERVED3);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_10].u4Inputs = (1<<AQ_INPUT_COMPOSITE)|(1<<AQ_INPUT_COMPONENT)|(1<<AQ_INPUT_PC);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_12].u4Inputs = (1<<AQ_INPUT_DIGITAL_RF)|(1<<AQ_INPUT_HDMI)|(1<<AQ_INPUT_VIDEO_APP)|(1<<AQ_INPUT_PHOTO)|(1<<AQ_INPUT_JELLYFISH)|(1<<AQ_INPUT_MIRACAST)|(1<<AQ_INPUT_GENERAL_APP)|(1<<AQ_INPUT_RESERVED1)|(1<<AQ_INPUT_RESERVED2)|(1<<AQ_INPUT_RESERVED3);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_13].u4Inputs = (1<<AQ_INPUT_COMPOSITE)|(1<<AQ_INPUT_COMPONENT)|(1<<AQ_INPUT_PC);

// _ar_MmSpeqTbl_KeyMM_SPEQ
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_0].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_STANDARD_SUR_OFF , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_1].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_STANDARD_SUR_ON , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_2].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_CINEMA , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_3].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_MUSIC , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_4].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_FOOTBALL , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_5].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO_SUR_OFF , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_6].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO_SUR_ON , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_7].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_8].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_1 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_9].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_STANDARD_SUR_OFF , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_10].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_STANDARD_SUR_ON , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_11].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_CINEMA , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_12].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_MUSIC , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_13].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_FOOTBALL , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_14].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO_SUR_OFF , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_15].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DEMO_SUR_ON , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_16].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_0 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_17].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_1 , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmAuDlyTbl_KeyMM_AU_DLY
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_0].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_NOT_CONNECTED , AQ_PICTURE_MODE_DONT );
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_1].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_NOT_CONNECTED , AQ_PICTURE_MODE_GAME_GRAPHICS );
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_2].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_CONNECTED , AQ_PICTURE_MODE_DONT );
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_3].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_CONNECTED , AQ_PICTURE_MODE_GAME_GRAPHICS );
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_4].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_NOT_CONNECTED , AQ_PICTURE_MODE_DONT );
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_5].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_NOT_CONNECTED , AQ_PICTURE_MODE_GAME_GRAPHICS );
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_6].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_CONNECTED , AQ_PICTURE_MODE_DONT );
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_7].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_CONNECTED , AQ_PICTURE_MODE_GAME_GRAPHICS );

// _ar_MmAdctTbl_KeyMM_ADCT
    _ar_MmAdctTbl_Key[AQDATA_INDEX_MM_ADCT_0].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmAdctTbl_Key[AQDATA_INDEX_MM_ADCT_1].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmActTbl_KeyMM_ACT
    _ar_MmActTbl_Key[AQDATA_INDEX_MM_ACT_0].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmActTbl_Key[AQDATA_INDEX_MM_ACT_1].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmAdtTbl_KeyMM_ADT
    _ar_MmAdtTbl_Key[AQDATA_INDEX_MM_ADT_0].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmAdtTbl_Key[AQDATA_INDEX_MM_ADT_1].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmRsvTbl_KeyMM_RSV
    _ar_MmRsvTbl_Key[AQDATA_INDEX_MM_RSV_0].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmRsvTbl_Key[AQDATA_INDEX_MM_RSV_1].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_DaGeneralConfigTbl_KeyDA_GENERAL_CONFIG
    _ar_DaGeneralConfigTbl_Key[AQDATA_INDEX_DA_GENERAL_CONFIG_0].u4Key = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_Da5760Config1Tbl_KeyDA_5760_CONFIG1
    _ar_Da5760Config1Tbl_Key[AQDATA_INDEX_DA_5760_CONFIG1_0].u4Key = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_Da5760Config2Tbl_KeyDA_5760_CONFIG2
    _ar_Da5760Config2Tbl_Key[AQDATA_INDEX_DA_5760_CONFIG2_0].u4Key = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_Da5538ConfigTbl_KeyDA_5538_CONFIG
    _ar_Da5538ConfigTbl_Key[AQDATA_INDEX_DA_5538_CONFIG_0].u4Key = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_Da5538BqTbl_KeyDA_5538_BQ
    _ar_Da5538BqTbl_Key[AQDATA_INDEX_DA_5538_BQ_0].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_Da5538BqTbl_Key[AQDATA_INDEX_DA_5538_BQ_1].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_Da5538BtTbl_KeyDA_5538_BT
    _ar_Da5538BtTbl_Key[AQDATA_INDEX_DA_5538_BT_0].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_Da5538BtTbl_Key[AQDATA_INDEX_DA_5538_BT_1].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_Da5538LoudTbl_KeyDA_5538_LOUD
    _ar_Da5538LoudTbl_Key[AQDATA_INDEX_DA_5538_LOUD_0].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_Da5538LoudTbl_Key[AQDATA_INDEX_DA_5538_LOUD_1].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_Da5538DrcTbl_KeyDA_5538_DRC
    _ar_Da5538DrcTbl_Key[AQDATA_INDEX_DA_5538_DRC_0].u4Key = AQ_MAKE_KEY( AQ_FS_48KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_Da5538DrcTbl_Key[AQDATA_INDEX_DA_5538_DRC_1].u4Key = AQ_MAKE_KEY( AQ_FS_96KHZ , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );



// _ar_MmSvtSpTbl_KeyMM_SVT_SP
    _ar_MmSvtSpTbl_Key[AQDATA_INDEX_MM_SVT_SP_0].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSvtSpTbl_Key[AQDATA_INDEX_MM_SVT_SP_1].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmSvtSpwTbl_KeyMM_SVT_SPW
    _ar_MmSvtSpwTbl_Key[AQDATA_INDEX_MM_SVT_SPW_0].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSvtSpwTbl_Key[AQDATA_INDEX_MM_SVT_SPW_1].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmSvtHpTbl_KeyMM_SVT_HP
    _ar_MmSvtHpTbl_Key[AQDATA_INDEX_MM_SVT_HP_0].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSvtHpTbl_Key[AQDATA_INDEX_MM_SVT_HP_1].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmSvtLoTbl_KeyMM_SVT_LO
    _ar_MmSvtLoTbl_Key[AQDATA_INDEX_MM_SVT_LO_0].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSvtLoTbl_Key[AQDATA_INDEX_MM_SVT_LO_1].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmSvtLohTbl_KeyMM_SVT_LOH
    _ar_MmSvtLohTbl_Key[AQDATA_INDEX_MM_SVT_LOH_0].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSvtLohTbl_Key[AQDATA_INDEX_MM_SVT_LOH_1].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmSvtAswTbl_KeyMM_SVT_ASW
    _ar_MmSvtAswTbl_Key[AQDATA_INDEX_MM_SVT_ASW_0].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSvtAswTbl_Key[AQDATA_INDEX_MM_SVT_ASW_1].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmSvtDswTbl_KeyMM_SVT_DSW
    _ar_MmSvtDswTbl_Key[AQDATA_INDEX_MM_SVT_DSW_0].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSvtDswTbl_Key[AQDATA_INDEX_MM_SVT_DSW_1].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmSvtBtTbl_KeyMM_SVT_BT
    _ar_MmSvtBtTbl_Key[AQDATA_INDEX_MM_SVT_BT_0].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSvtBtTbl_Key[AQDATA_INDEX_MM_SVT_BT_1].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmDrctTbl_KeyMM_DRCT
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_0].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DEMO , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_1].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_2].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DEMO , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_3].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_4].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_5].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_6].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DEMO , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_7].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_8].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DEMO , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_9].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_10].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_11].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmLimtTbl_KeyMM_LIMT
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_0].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DEMO , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_1].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_2].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DEMO , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_3].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_4].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_5].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_6].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DEMO , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_7].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_8].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DEMO , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_9].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_10].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_11].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmFirTbl_KeyMM_FIR
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_0].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_1].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_2].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_3].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_4].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_5].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_6].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_7].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmLoudtTbl_KeyMM_LOUDT
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_0].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DEMO , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_1].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_2].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DEMO , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_3].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_4].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_5].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_6].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DEMO , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_7].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_8].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DEMO , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_9].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_10].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_11].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmSmtTbl_KeyMM_SMT
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_0].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_1].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_2].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_3].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_4].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_5].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_6].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_7].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_8].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_9].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_10].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_11].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_12].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_13].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_14].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_15].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_16].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_17].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_18].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_19].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_20].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_21].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_22].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_23].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_24].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_25].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_26].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_27].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_28].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_29].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_30].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_31].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_32].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_33].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_34].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_35].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_36].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_37].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_38].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_39].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_40].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_41].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_42].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_43].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_44].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_45].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_46].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_47].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_48].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_49].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_50].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_51].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_52].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_53].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_54].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_55].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_56].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_57].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_58].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_59].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmSwsTbl_KeyMM_SWS
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_0].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_1].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_2].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_3].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_4].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_5].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_6].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_7].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_8].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_9].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_10].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_11].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_12].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_13].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_14].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_15].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_16].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_17].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_18].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_19].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_20].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_21].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_22].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_23].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_24].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_25].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_26].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_27].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_28].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_29].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmSltTbl_KeyMM_SLT
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_0].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_1].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_2].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_3].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_4].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_5].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_6].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_7].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_8].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_9].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_10].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_11].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_12].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_13].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_14].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_15].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmSpeqTbl_KeyMM_SPEQ
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_0].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_1].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_2].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_3].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_4].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_5].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_6].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_7].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_8].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_9].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_10].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_11].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_12].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_13].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_14].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_15].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_SKYPE , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_16].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_17].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmAuDlyTbl_KeyMM_AU_DLY
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_0].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_GAME_GRAPHICS );
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_1].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_2].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_GAME_GRAPHICS );
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_3].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_4].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_GAME_GRAPHICS );
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_5].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_6].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_GAME_GRAPHICS );
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_7].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmAdctTbl_KeyMM_ADCT
    _ar_MmAdctTbl_Key[AQDATA_INDEX_MM_ADCT_0].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmAdctTbl_Key[AQDATA_INDEX_MM_ADCT_1].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmActTbl_KeyMM_ACT
    _ar_MmActTbl_Key[AQDATA_INDEX_MM_ACT_0].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmActTbl_Key[AQDATA_INDEX_MM_ACT_1].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmAdtTbl_KeyMM_ADT
    _ar_MmAdtTbl_Key[AQDATA_INDEX_MM_ADT_0].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmAdtTbl_Key[AQDATA_INDEX_MM_ADT_1].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_MmRsvTbl_KeyMM_RSV
    _ar_MmRsvTbl_Key[AQDATA_INDEX_MM_RSV_0].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_MmRsvTbl_Key[AQDATA_INDEX_MM_RSV_1].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_DaGeneralConfigTbl_KeyDA_GENERAL_CONFIG
    _ar_DaGeneralConfigTbl_Key[AQDATA_INDEX_DA_GENERAL_CONFIG_0].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_Da5760Config1Tbl_KeyDA_5760_CONFIG1
    _ar_Da5760Config1Tbl_Key[AQDATA_INDEX_DA_5760_CONFIG1_0].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_Da5760Config2Tbl_KeyDA_5760_CONFIG2
    _ar_Da5760Config2Tbl_Key[AQDATA_INDEX_DA_5760_CONFIG2_0].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_Da5538ConfigTbl_KeyDA_5538_CONFIG
    _ar_Da5538ConfigTbl_Key[AQDATA_INDEX_DA_5538_CONFIG_0].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_Da5538BqTbl_KeyDA_5538_BQ
    _ar_Da5538BqTbl_Key[AQDATA_INDEX_DA_5538_BQ_0].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_Da5538BqTbl_Key[AQDATA_INDEX_DA_5538_BQ_1].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_Da5538BtTbl_KeyDA_5538_BT
    _ar_Da5538BtTbl_Key[AQDATA_INDEX_DA_5538_BT_0].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_Da5538BtTbl_Key[AQDATA_INDEX_DA_5538_BT_1].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_Da5538LoudTbl_KeyDA_5538_LOUD
    _ar_Da5538LoudTbl_Key[AQDATA_INDEX_DA_5538_LOUD_0].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_Da5538LoudTbl_Key[AQDATA_INDEX_DA_5538_LOUD_1].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

// _ar_Da5538DrcTbl_KeyDA_5538_DRC
    _ar_Da5538DrcTbl_Key[AQDATA_INDEX_DA_5538_DRC_0].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );
    _ar_Da5538DrcTbl_Key[AQDATA_INDEX_DA_5538_DRC_1].u4ExceptKey = AQ_MAKE_KEY( AQ_FS_DONT , AQ_MM_MEASURE_MODE_DONT , AQ_WIRELESS_SUBWOOFER_MODE_DONT , AQ_TV_POSITION_DONT , AQ_INPUT_DONT , AQ_SOUND_MODE_DONT , AQ_BT_AUDIO_DONT , AQ_PICTURE_MODE_DONT );

#else
    //_ar_MmSvtSpTbl_KeyMM_SVT_SP
    
    
    _ar_MmSvtSpTbl_Key[AQDATA_INDEX_MM_SVT_SP_0].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSvtSpTbl_Key[AQDATA_INDEX_MM_SVT_SP_1].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmSvtSpwTbl_KeyMM_SVT_SPW
    
    
    _ar_MmSvtSpwTbl_Key[AQDATA_INDEX_MM_SVT_SPW_0].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSvtSpwTbl_Key[AQDATA_INDEX_MM_SVT_SPW_1].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmSvtHpTbl_KeyMM_SVT_HP
    
    
    _ar_MmSvtHpTbl_Key[AQDATA_INDEX_MM_SVT_HP_0].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSvtHpTbl_Key[AQDATA_INDEX_MM_SVT_HP_1].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmSvtLoTbl_KeyMM_SVT_LO
    
    
    _ar_MmSvtLoTbl_Key[AQDATA_INDEX_MM_SVT_LO_0].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSvtLoTbl_Key[AQDATA_INDEX_MM_SVT_LO_1].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmSvtLohTbl_KeyMM_SVT_LOH
    
    
    _ar_MmSvtLohTbl_Key[AQDATA_INDEX_MM_SVT_LOH_0].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSvtLohTbl_Key[AQDATA_INDEX_MM_SVT_LOH_1].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmSvtAswTbl_KeyMM_SVT_ASW
    
    
    _ar_MmSvtAswTbl_Key[AQDATA_INDEX_MM_SVT_ASW_0].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSvtAswTbl_Key[AQDATA_INDEX_MM_SVT_ASW_1].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmSvtDswTbl_KeyMM_SVT_DSW
    
    
    _ar_MmSvtDswTbl_Key[AQDATA_INDEX_MM_SVT_DSW_0].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSvtDswTbl_Key[AQDATA_INDEX_MM_SVT_DSW_1].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmSvtBtTbl_KeyMM_SVT_BT
    
    
    _ar_MmSvtBtTbl_Key[AQDATA_INDEX_MM_SVT_BT_0].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSvtBtTbl_Key[AQDATA_INDEX_MM_SVT_BT_1].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmDrctTbl_KeyMM_DRCT
    
    
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_0].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_BOOSTER_ON,AQ_PARAM_ANY);
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_1].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_BOOSTER_OFF,AQ_PARAM_ANY);
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_2].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_3].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_BOOSTER_ON,AQ_PARAM_ANY);
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_4].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_BOOSTER_OFF,AQ_PARAM_ANY);
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_5].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_6].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_PARAM_ANY,AQ_INPUT_SKYPE, AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_7].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_1,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_8].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_BOOSTER_ON,AQ_PARAM_ANY);
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_9].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_BOOSTER_OFF,AQ_PARAM_ANY);
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_10].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_11].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_BOOSTER_ON,AQ_PARAM_ANY);
    //_ar_MmLimtTbl_KeyMM_LIMT
    
    
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_0].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_1].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_2].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_3].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_4].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_5].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_1,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_6].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_7].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_8].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_9].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_10].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_11].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_1,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmFirTbl_KeyMM_FIR
    
    
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_0].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_1].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_2].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_3].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_1,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_4].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_5].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_6].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_7].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_1,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmLoudtTbl_KeyMM_LOUDT
    
    
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_0].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_1].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_2].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_3].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_4].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_5].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_1,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_6].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_7].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_8].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_9].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_10].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_11].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_1,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmSmtTbl_KeyMM_SMT
    
    
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_0].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_STANDARD_S0A0,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_1].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_STANDARD_S1A1,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_2].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_CINEMA,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_3].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_MUSIC,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_4].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_FOOTBALL,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_5].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO_S0A0,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_6].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO_S1A1,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_7].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_STANDARD_S0A0,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_8].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_STANDARD_S1A1,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_9].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_CINEMA,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_10].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_MUSIC,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_11].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_FOOTBALL,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_12].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO_S0A0,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_13].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO_S1A1,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_14].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_15].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_STANDARD_S0A0,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_16].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_STANDARD_S1A1,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_17].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_CINEMA,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_18].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_MUSIC,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_19].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_FOOTBALL,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_20].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO_S0A0,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_21].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO_S1A1,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_22].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_STANDARD_S0A0,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_23].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_STANDARD_S1A1,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_24].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_CINEMA,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_25].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_MUSIC,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_26].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_FOOTBALL,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_27].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO_S0A0,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_28].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO_S1A1,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_29].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_1,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_30].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_STANDARD_S0A0,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_31].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_STANDARD_S1A1,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_32].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_CINEMA,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_33].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_MUSIC,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_34].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_FOOTBALL,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_35].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO_S0A0,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_36].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO_S1A1,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_37].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_STANDARD_S0A0,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_38].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_STANDARD_S1A1,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_39].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_CINEMA,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_40].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_MUSIC,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_41].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_FOOTBALL,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_42].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO_S0A0,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_43].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO_S1A1,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_44].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_45].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_STANDARD_S0A0,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_46].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_STANDARD_S1A1,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_47].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_CINEMA,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_48].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_MUSIC,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_49].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_FOOTBALL,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_50].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO_S0A0,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_51].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO_S1A1,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_52].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_STANDARD_S0A0,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_53].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_STANDARD_S1A1,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_54].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_CINEMA,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_55].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_MUSIC,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_56].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_FOOTBALL,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_57].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO_S0A0,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_58].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO_S1A1,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_59].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_1,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmSwsTbl_KeyMM_SWS
    
    
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_0].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_STANDARD_S0A0,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_1].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_STANDARD_S1A1,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_2].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_CINEMA,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_3].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_MUSIC,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_4].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_FOOTBALL,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_5].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO_S0A0,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_6].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO_S1A1,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_7].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_STANDARD_S0A0,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_8].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_STANDARD_S1A1,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_9].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_CINEMA,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_10].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_MUSIC,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_11].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_FOOTBALL,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_12].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO_S0A0,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_13].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO_S1A1,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_14].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_15].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_STANDARD_S0A0,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_16].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_STANDARD_S1A1,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_17].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_CINEMA,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_18].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_MUSIC,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_19].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_FOOTBALL,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_20].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO_S0A0,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_21].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO_S1A1,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_22].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_STANDARD_S0A0,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_23].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_STANDARD_S1A1,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_24].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_CINEMA,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_25].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_MUSIC,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_26].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_FOOTBALL,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_27].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO_S0A0,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_28].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO_S1A1,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_29].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmSltTbl_KeyMM_SLT
    
    
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_0].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_INPUT_ANALOG_RF,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);

    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_1].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_1].u4Inputs = (1<<AQ_INPUT_DIGITAL_RF)|(1<<AQ_INPUT_HDMI)|(1<<AQ_INPUT_VIDEO_APP)|(1<<AQ_INPUT_PHOTO)|(1<<AQ_INPUT_JELLYFISH)|(1<<AQ_INPUT_SKYPE)|(1<<AQ_INPUT_MIRACAST)|(1<<AQ_INPUT_GENERAL_APP)|(1<<AQ_INPUT_RESERVED1)|(1<<AQ_INPUT_RESERVED2)|(1<<AQ_INPUT_RESERVED3);

    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_2].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_2].u4Inputs = (1<<AQ_INPUT_COMPOSITE)|(1<<AQ_INPUT_COMPONENT)|(1<<AQ_INPUT_PC);

    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_3].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_INPUT_ANALOG_RF,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);

    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_4].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_4].u4Inputs = (1<<AQ_INPUT_DIGITAL_RF)|(1<<AQ_INPUT_HDMI)|(1<<AQ_INPUT_VIDEO_APP)|(1<<AQ_INPUT_PHOTO)|(1<<AQ_INPUT_JELLYFISH)|(1<<AQ_INPUT_SKYPE)|(1<<AQ_INPUT_MIRACAST)|(1<<AQ_INPUT_GENERAL_APP)|(1<<AQ_INPUT_RESERVED1)|(1<<AQ_INPUT_RESERVED2)|(1<<AQ_INPUT_RESERVED3);

    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_5].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_5].u4Inputs = (1<<AQ_INPUT_COMPOSITE)|(1<<AQ_INPUT_COMPONENT)|(1<<AQ_INPUT_PC);

    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_6].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_7].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_1,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_8].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_INPUT_ANALOG_RF,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);

    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_9].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_9].u4Inputs = (1<<AQ_INPUT_DIGITAL_RF)|(1<<AQ_INPUT_HDMI)|(1<<AQ_INPUT_VIDEO_APP)|(1<<AQ_INPUT_PHOTO)|(1<<AQ_INPUT_JELLYFISH)|(1<<AQ_INPUT_SKYPE)|(1<<AQ_INPUT_MIRACAST)|(1<<AQ_INPUT_GENERAL_APP)|(1<<AQ_INPUT_RESERVED1)|(1<<AQ_INPUT_RESERVED2)|(1<<AQ_INPUT_RESERVED3);

    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_10].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_TABLE_STAND,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_10].u4Inputs = (1<<AQ_INPUT_COMPOSITE)|(1<<AQ_INPUT_COMPONENT)|(1<<AQ_INPUT_PC);

    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_11].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_INPUT_ANALOG_RF,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);

    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_12].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_12].u4Inputs = (1<<AQ_INPUT_DIGITAL_RF)|(1<<AQ_INPUT_HDMI)|(1<<AQ_INPUT_VIDEO_APP)|(1<<AQ_INPUT_PHOTO)|(1<<AQ_INPUT_JELLYFISH)|(1<<AQ_INPUT_SKYPE)|(1<<AQ_INPUT_MIRACAST)|(1<<AQ_INPUT_GENERAL_APP)|(1<<AQ_INPUT_RESERVED1)|(1<<AQ_INPUT_RESERVED2)|(1<<AQ_INPUT_RESERVED3);

    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_13].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_TV_POSITION_WALL_MOUNT,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_13].u4Inputs = (1<<AQ_INPUT_COMPOSITE)|(1<<AQ_INPUT_COMPONENT)|(1<<AQ_INPUT_PC);

    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_14].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_15].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_1,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
        
    //_ar_MmSpeqTbl_KeyMM_SPEQ
    
    
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_0].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_SOUND_MODE_STANDARD_S0A0,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_1].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_SOUND_MODE_STANDARD_S1A1,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_2].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_SOUND_MODE_CINEMA,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_3].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_SOUND_MODE_MUSIC,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_4].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_SOUND_MODE_FOOTBALL,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_5].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO_S0A0,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_6].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO_S1A1,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_7].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_0,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_8].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_MM_MEASURE_MODE_1,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_9].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_SOUND_MODE_STANDARD_S0A0,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_10].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_SOUND_MODE_STANDARD_S1A1,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_11].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_SOUND_MODE_CINEMA,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_12].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_SOUND_MODE_MUSIC,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_13].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_SOUND_MODE_FOOTBALL,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_14].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO_S0A0,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_15].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_SOUND_MODE_DEMO_S1A1,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_16].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_0,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_17].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_MM_MEASURE_MODE_1,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmAuDlyTbl_KeyMM_AU_DLY
    
    
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_0].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_1].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PICTURE_MODE_GAME_GRAPHICS);
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_2].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_BT_TYPE_SPEAKER,AQ_PARAM_ANY);
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_3].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_BT_TYPE_HEADPHONE,AQ_PARAM_ANY);
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_4].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_5].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PICTURE_MODE_GAME_GRAPHICS);
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_6].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_BT_TYPE_SPEAKER,AQ_PARAM_ANY);
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_7].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_BT_TYPE_HEADPHONE,AQ_PARAM_ANY);
    
    //_ar_MmAdctTbl_KeyMM_ADCT
    
    
    _ar_MmAdctTbl_Key[AQDATA_INDEX_MM_ADCT_0].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmAdctTbl_Key[AQDATA_INDEX_MM_ADCT_1].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmActTbl_KeyMM_ACT
    
    
    _ar_MmActTbl_Key[AQDATA_INDEX_MM_ACT_0].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmActTbl_Key[AQDATA_INDEX_MM_ACT_1].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmAdtTbl_KeyMM_ADT
    
    
    _ar_MmAdtTbl_Key[AQDATA_INDEX_MM_ADT_0].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmAdtTbl_Key[AQDATA_INDEX_MM_ADT_1].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmRsvTbl_KeyMM_RSV
    
    
    _ar_MmRsvTbl_Key[AQDATA_INDEX_MM_RSV_0].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmRsvTbl_Key[AQDATA_INDEX_MM_RSV_1].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_DaGeneralConfigTbl_KeyDA_GENERAL_CONFIG
    
    
    _ar_DaGeneralConfigTbl_Key[AQDATA_INDEX_DA_GENERAL_CONFIG_0].u4Key = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_Da5760Config1Tbl_KeyDA_5760_CONFIG1
    
    
    _ar_Da5760Config1Tbl_Key[AQDATA_INDEX_DA_5760_CONFIG1_0].u4Key = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_Da5760Config2Tbl_KeyDA_5760_CONFIG2
    
    
    _ar_Da5760Config2Tbl_Key[AQDATA_INDEX_DA_5760_CONFIG2_0].u4Key = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_Da5538ConfigTbl_KeyDA_5538_CONFIG
    
    
    _ar_Da5538ConfigTbl_Key[AQDATA_INDEX_DA_5538_CONFIG_0].u4Key = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_Da5538BqTbl_KeyDA_5538_BQ
    
    
    _ar_Da5538BqTbl_Key[AQDATA_INDEX_DA_5538_BQ_0].u4Key = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_Da5538BtTbl_KeyDA_5538_BT
    
    
    _ar_Da5538BtTbl_Key[AQDATA_INDEX_DA_5538_BT_0].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_Da5538BtTbl_Key[AQDATA_INDEX_DA_5538_BT_1].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_Da5538LoudTbl_KeyDA_5538_LOUD
    
    
    _ar_Da5538LoudTbl_Key[AQDATA_INDEX_DA_5538_LOUD_0].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_Da5538LoudTbl_Key[AQDATA_INDEX_DA_5538_LOUD_1].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_Da5538DrcTbl_KeyDA_5538_DRC
    
    
    _ar_Da5538DrcTbl_Key[AQDATA_INDEX_DA_5538_DRC_0].u4Key = AQ_MAKE_KEY(AQ_FS_48KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_Da5538DrcTbl_Key[AQDATA_INDEX_DA_5538_DRC_1].u4Key = AQ_MAKE_KEY(AQ_FS_96KHZ,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);


    //_ar_MmSvtSpTbl_KeyMM_SVT_SP
    _ar_MmSvtSpTbl_Key[AQDATA_INDEX_MM_SVT_SP_0].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSvtSpTbl_Key[AQDATA_INDEX_MM_SVT_SP_1].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmSvtSpwTbl_KeyMM_SVT_SPW
    
    
    _ar_MmSvtSpwTbl_Key[AQDATA_INDEX_MM_SVT_SPW_0].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSvtSpwTbl_Key[AQDATA_INDEX_MM_SVT_SPW_1].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmSvtHpTbl_KeyMM_SVT_HP
    
    
    _ar_MmSvtHpTbl_Key[AQDATA_INDEX_MM_SVT_HP_0].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSvtHpTbl_Key[AQDATA_INDEX_MM_SVT_HP_1].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmSvtLoTbl_KeyMM_SVT_LO
    
    
    _ar_MmSvtLoTbl_Key[AQDATA_INDEX_MM_SVT_LO_0].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSvtLoTbl_Key[AQDATA_INDEX_MM_SVT_LO_1].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmSvtLohTbl_KeyMM_SVT_LOH
    
    
    _ar_MmSvtLohTbl_Key[AQDATA_INDEX_MM_SVT_LOH_0].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSvtLohTbl_Key[AQDATA_INDEX_MM_SVT_LOH_0].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmSvtAswTbl_KeyMM_SVT_ASW
    
    
    _ar_MmSvtAswTbl_Key[AQDATA_INDEX_MM_SVT_ASW_0].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSvtAswTbl_Key[AQDATA_INDEX_MM_SVT_ASW_1].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmSvtDswTbl_KeyMM_SVT_DSW
    
    
    _ar_MmSvtDswTbl_Key[AQDATA_INDEX_MM_SVT_DSW_0].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSvtDswTbl_Key[AQDATA_INDEX_MM_SVT_DSW_1].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmSvtBtTbl_KeyMM_SVT_BT
    
    
    _ar_MmSvtBtTbl_Key[AQDATA_INDEX_MM_SVT_BT_0].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSvtBtTbl_Key[AQDATA_INDEX_MM_SVT_BT_1].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmDrctTbl_KeyMM_DRCT
    
    
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_0].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_SOUND_MODE_DEMO,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_1].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_SOUND_MODE_DEMO,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_2].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_3].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_SOUND_MODE_DEMO,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_4].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_SOUND_MODE_DEMO,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_5].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_6].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_7].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_8].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_SOUND_MODE_DEMO,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_9].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_SOUND_MODE_DEMO,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_10].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmDrctTbl_Key[AQDATA_INDEX_MM_DRCT_11].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_SOUND_MODE_DEMO,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmLimtTbl_KeyMM_LIMT
    
    
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_0].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_SOUND_MODE_DEMO,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_1].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_2].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_SOUND_MODE_DEMO,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_3].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_4].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_5].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_6].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_SOUND_MODE_DEMO,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_7].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_8].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_SOUND_MODE_DEMO,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_9].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_10].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLimtTbl_Key[AQDATA_INDEX_MM_LIMT_11].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmFirTbl_KeyMM_FIR
    
    
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_0].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_1].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_2].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_3].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_4].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_5].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_6].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmFirTbl_Key[AQDATA_INDEX_MM_FIR_7].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmLoudtTbl_KeyMM_LOUDT
    
    
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_0].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_SOUND_MODE_DEMO,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_1].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_2].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_SOUND_MODE_DEMO,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_3].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_4].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_5].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_6].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_SOUND_MODE_DEMO,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_7].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_8].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_SOUND_MODE_DEMO,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_9].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_10].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmLoudtTbl_Key[AQDATA_INDEX_MM_LOUDT_11].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmSmtTbl_KeyMM_SMT
    
    
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_0].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_1].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_2].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_3].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_4].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_5].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_6].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_7].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_8].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_9].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_10].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_11].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_12].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_13].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_14].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_15].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_16].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_17].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_18].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_19].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_20].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_21].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_22].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_23].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_24].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_25].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_26].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_27].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_28].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_29].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_30].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_31].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_32].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_33].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_34].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_35].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_36].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_37].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_38].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_39].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_40].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_41].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_42].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_43].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_44].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_45].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_46].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_47].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_48].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_49].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_50].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_51].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_52].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_53].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_54].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_55].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_56].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_57].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_58].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSmtTbl_Key[AQDATA_INDEX_MM_SMT_59].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmSwsTbl_KeyMM_SWS
    
    
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_0].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_1].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_2].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_3].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_4].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_5].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_6].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_7].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_8].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_9].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_10].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_11].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_12].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_13].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_14].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_15].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_16].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_17].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_18].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_19].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_20].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_21].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_22].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_23].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_24].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_25].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_26].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_27].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_28].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSwsTbl_Key[AQDATA_INDEX_MM_SWS_29].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmSltTbl_KeyMM_SLT
    
    
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_0].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_1].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_2].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_3].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_4].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_5].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_6].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_7].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_8].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_9].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_10].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_11].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_12].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_13].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_14].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSltTbl_Key[AQDATA_INDEX_MM_SLT_15].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmSpeqTbl_KeyMM_SPEQ
    
    
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_0].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_1].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_2].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_3].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_4].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_5].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_6].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_7].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_8].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_9].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_10].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_11].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_12].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_13].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_14].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_15].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_INPUT_SKYPE,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_16].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmSpeqTbl_Key[AQDATA_INDEX_MM_SPEQ_17].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmAuDlyTbl_KeyMM_AU_DLY
    
    
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_0].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PICTURE_MODE_GAME_GRAPHICS);
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_1].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_2].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_3].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_4].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PICTURE_MODE_GAME_GRAPHICS);
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_5].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_6].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmAuDlyTbl_Key[AQDATA_INDEX_MM_AU_DLY_7].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmAdctTbl_KeyMM_ADCT
    
    
    _ar_MmAdctTbl_Key[AQDATA_INDEX_MM_ADCT_0].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmAdctTbl_Key[AQDATA_INDEX_MM_ADCT_1].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmActTbl_KeyMM_ACT
    
    
    _ar_MmActTbl_Key[AQDATA_INDEX_MM_ACT_0].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmActTbl_Key[AQDATA_INDEX_MM_ACT_1].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmAdtTbl_KeyMM_ADT
    
    
    _ar_MmAdtTbl_Key[AQDATA_INDEX_MM_ADT_0].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmAdtTbl_Key[AQDATA_INDEX_MM_ADT_1].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_MmRsvTbl_KeyMM_RSV
    
    
    _ar_MmRsvTbl_Key[AQDATA_INDEX_MM_RSV_0].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_MmRsvTbl_Key[AQDATA_INDEX_MM_RSV_1].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_DaGeneralConfigTbl_KeyDA_GENERAL_CONFIG
    
    
    _ar_DaGeneralConfigTbl_Key[AQDATA_INDEX_DA_GENERAL_CONFIG_0].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_Da5760Config1Tbl_KeyDA_5760_CONFIG1
    
    
    _ar_Da5760Config1Tbl_Key[AQDATA_INDEX_DA_5760_CONFIG1_0].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_Da5760Config2Tbl_KeyDA_5760_CONFIG2
    
    
    _ar_Da5760Config2Tbl_Key[AQDATA_INDEX_DA_5760_CONFIG2_0].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_Da5538ConfigTbl_KeyDA_5538_CONFIG
    
    
    _ar_Da5538ConfigTbl_Key[AQDATA_INDEX_DA_5538_CONFIG_0].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_Da5538BqTbl_KeyDA_5538_BQ
    
    
    _ar_Da5538BqTbl_Key[AQDATA_INDEX_DA_5538_BQ_0].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_Da5538BtTbl_KeyDA_5538_BT
    
    
    _ar_Da5538BtTbl_Key[AQDATA_INDEX_DA_5538_BT_0].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_Da5538BtTbl_Key[AQDATA_INDEX_DA_5538_BT_1].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_Da5538LoudTbl_KeyDA_5538_LOUD
    
    
    _ar_Da5538LoudTbl_Key[AQDATA_INDEX_DA_5538_LOUD_0].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_Da5538LoudTbl_Key[AQDATA_INDEX_DA_5538_LOUD_1].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
    //_ar_Da5538DrcTbl_KeyDA_5538_DRC
    
    
    _ar_Da5538DrcTbl_Key[AQDATA_INDEX_DA_5538_DRC_0].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    _ar_Da5538DrcTbl_Key[AQDATA_INDEX_DA_5538_DRC_1].u4ExceptKey = AQ_MAKE_KEY(AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY,AQ_PARAM_ANY);
    
#endif /* CC_AUD_SAKURA_RENDER */
    
    
    
    
    return 0;
}



INT32 DrvCust_AQ_SetGet(AUD_DrvCust_AQ_OP_T eType, void* arg1, void* arg2, UINT32 arg3, UINT32 arg4)
{
    UNUSED(DrvCust_AQ_SetGet);
    UNUSED(eType);
    UNUSED(arg1);
    UNUSED(arg3);
    UNUSED(arg4);    

#ifdef CC_AUD_SAKURA_RENDER
    switch (eType)
    {
    case AUD_DrvCust_AQ_Set_Init:
        DrvCust_AQ_Init();
        break;
    case AUD_DrvCust_AQ_Set_Val:
        DrvCust_AQ_SetVal(arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_List:
        DrvCust_AQ_List(arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Gen_Key:        
        *(UINT32*)arg2 = DrvCust_AQ_GenKey(*(AUD_DrvCust_AQ_Key_T*)arg1);
        break;
    case AUD_DrvCust_AQ_Get_SVT_SP:        
        DrvCust_AQ_Get_SVTSP(arg1, arg3, arg4);
        break;        
    case AUD_DrvCust_AQ_Get_SVT_SPW:
        DrvCust_AQ_Get_SVTSPW(arg1, arg3, arg4);
        break;        
    case AUD_DrvCust_AQ_Get_SVT_HP:
        DrvCust_AQ_Get_SVT_HP(arg1, arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_SVT_LO:
        DrvCust_AQ_Get_SVT_LO(arg1, arg3, arg4);
        break;        
    case AUD_DrvCust_AQ_Get_SVT_LOH:
        DrvCust_AQ_Get_SVT_LOH(arg1, arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_SVT_ASW:
        DrvCust_AQ_Get_SVT_ASW(arg1, arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_SVT_DSW:
        DrvCust_AQ_Get_SVT_DSW(arg1, arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_SVT_BT:
        DrvCust_AQ_Get_SVT_BT(arg1, arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_DRC:
        DrvCust_AQ_Get_DRC(arg3);
        break;
    case AUD_DrvCust_AQ_Get_LIMT:
        DrvCust_AQ_Get_LIMT(arg1, arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_SMT:
        DrvCust_AQ_Get_SMT(arg1, arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_SPEQ:
        DrvCust_AQ_Get_SPEQ(arg3);
        break;
    case AUD_DrvCust_AQ_Get_SLT:
        DrvCust_AQ_Get_SLT(arg1, arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_SWS:
        DrvCust_AQ_Get_SWS(arg1, arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_LOUDT:
        DrvCust_AQ_Get_LOUDT(arg3);
        break;
    case AUD_DrvCust_AQ_Get_FIR:
        DrvCust_AQ_Get_FIR(arg1, arg2, arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_DLY:
        DrvCust_AQ_Get_DLY(arg1, arg2, arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_ADCT:
        DrvCust_AQ_Get_ADCT(arg1, arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_ACT:
        DrvCust_AQ_Get_ACT(arg1, arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_ADT:
        DrvCust_AQ_Get_ADT(arg3, (BOOL)arg4);
        break;
    case AUD_DrvCust_AQ_Get_RSV:
        DrvCust_AQ_Get_RSV(arg1, arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_DA_GEN_CFG:
        DrvCust_AQ_Get_DA_GEN_CFG(arg3);
        break;
    case AUD_DrvCust_AQ_Get_DA_5760_CFG1:
        DrvCust_AQ_Get_DA_5760_CONFIG1(arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_DA_5760_CFG2:
        DrvCust_AQ_Get_DA_5760_CONFIG2(arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_DA_5538_CFG:
        DrvCust_AQ_Get_DA_5538_CONFIG(arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_DA_5538_BQ:
        DrvCust_AQ_Get_DA_5538_BQ(arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_DA_5538_BT:
        DrvCust_AQ_Get_DA_5538_BT(arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_DA_5538_LOUD:
        DrvCust_AQ_Get_DA_5538_LOUD(arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_DA_5538_DRC:
        DrvCust_AQ_Get_DA_5538_DRC(arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_DA_5760_SET:        
        DrvCust_AQ_Get_DA_GEN_CFG_INIT(arg3);
        break;        
    default:
        return -1;
    }

#else /*CC_AUD_SAKURA_RENDER*/

#if 1 // Develope your code here.
    switch (eType)
    {
    case AUD_DrvCust_AQ_Set_Init:
        DrvCust_AQ_Init();
        break;
    case AUD_DrvCust_AQ_Set_Val:
        DrvCust_AQ_SetVal(arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_List:
        DrvCust_AQ_List(arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Gen_Key:        
        *(UINT32*)arg2 = DrvCust_AQ_GenKey(*(AUD_DrvCust_AQ_Key_T*)arg1);
        break;
    case AUD_DrvCust_AQ_Get_SVT_SP:        
        DrvCust_AQ_Get_SVTSP(arg1, arg3, arg4);
        break;        
    case AUD_DrvCust_AQ_Get_SVT_SPW:
        DrvCust_AQ_Get_SVTSPW(arg1, arg3, arg4);
        break;        
    case AUD_DrvCust_AQ_Get_SVT_HP:
        DrvCust_AQ_Get_SVT_HP(arg1, arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_SVT_LO:
        DrvCust_AQ_Get_SVT_LO(arg1, arg3, arg4);
        break;        
    case AUD_DrvCust_AQ_Get_SVT_LOH:
        DrvCust_AQ_Get_SVT_LOH(arg1, arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_SVT_ASW:
        DrvCust_AQ_Get_SVT_ASW(arg1, arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_SVT_DSW:
        DrvCust_AQ_Get_SVT_DSW(arg1, arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_SVT_BT:
        DrvCust_AQ_Get_SVT_BT(arg1, arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_DRC:
        DrvCust_AQ_Get_DRC(arg3);
        break;
    case AUD_DrvCust_AQ_Get_LIMT:
        DrvCust_AQ_Get_LIMT(arg3);
        break;
    case AUD_DrvCust_AQ_Get_SMT:
        DrvCust_AQ_Get_SMT(arg1, arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_SPEQ:
        DrvCust_AQ_Get_SPEQ(arg3);
        break;
    case AUD_DrvCust_AQ_Get_SLT:
        DrvCust_AQ_Get_SLT(arg3);
        break;
    case AUD_DrvCust_AQ_Get_SWS:
        DrvCust_AQ_Get_SWS(arg1, arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_LOUDT:
        DrvCust_AQ_Get_LOUDT(arg3);
        break;
    case AUD_DrvCust_AQ_Get_FIR:
        DrvCust_AQ_Get_FIR(arg3);
        break;
    case AUD_DrvCust_AQ_Get_DLY:
        DrvCust_AQ_Get_DLY(arg1, arg3, (BOOL)arg4);
        break;
    case AUD_DrvCust_AQ_Get_ADCT:
        DrvCust_AQ_Get_ADCT(arg3);
        break;
    case AUD_DrvCust_AQ_Get_ACT:
        DrvCust_AQ_Get_ACT(arg1, arg3, arg4);
        break;
    case AUD_DrvCust_AQ_Get_ADT:
        DrvCust_AQ_Get_ADT(arg3, (BOOL)arg4);
        break;
    case AUD_DrvCust_AQ_Get_RSV:
        DrvCust_AQ_Get_RSV(arg3);
        break;
    case AUD_DrvCust_AQ_Get_DA_GEN_CFG:
        DrvCust_AQ_Get_DA_GEN_CFG(arg3);
        break;
    case AUD_DrvCust_AQ_Get_DA_5760_CFG1:
        DrvCust_AQ_Get_DA_5760_CONFIG1(arg3);
        break;
    case AUD_DrvCust_AQ_Get_DA_5760_CFG2:
        DrvCust_AQ_Get_DA_5760_CONFIG2(arg3);
        break;
    case AUD_DrvCust_AQ_Get_DA_5538_CFG:
        DrvCust_AQ_Get_DA_5538_CONFIG(arg3);
        break;
    case AUD_DrvCust_AQ_Get_DA_5538_BQ:
        DrvCust_AQ_Get_DA_5538_BQ(arg3);
        break;
    case AUD_DrvCust_AQ_Get_DA_5538_BT:
        DrvCust_AQ_Get_DA_5538_BT(arg3);
        break;
    case AUD_DrvCust_AQ_Get_DA_5538_LOUD:
        DrvCust_AQ_Get_DA_5538_LOUD(arg3);
        break;
    case AUD_DrvCust_AQ_Get_DA_5538_DRC:
        DrvCust_AQ_Get_DA_5538_DRC(arg3);
        break;
    case AUD_DrvCust_AQ_Get_DA_5760_SET:        
        DrvCust_AQ_Get_DA_GEN_CFG_INIT(arg3, (AMP_T*)arg1, (AMP_T*)arg2);
        break;
    default:
        return -1;
    }
#endif

#endif /*CC_AUD_SAKURA_RENDER*/

    return 0;    
}



//-----------------------------------------------------------------------------
// [Example 1] DrvCust_AQ_Init
//
//    Get AQ data from flash, and put data to DRAM.
// 
//  Return 0  : OK
//         -1 : NG
//-----------------------------------------------------------------------------

INT32 DrvCust_AQ_Init(void)
{

    UINT32 i;
    static UINT8* pu1DataAddr = NULL;
    UINT8 u1AQPartition;    
    static BOOL _bAqTmpBufAllocated = FALSE;
    UNUSED(DrvCust_AQ_Init);
    UNUSED(i);

    // Load AQ table from Flash to Dram
    u1AQPartition = AQ_PARTITION;
    printf("AQ! - u1AQPartition = %d, %d\n", u1AQPartition, _bAqTmpBufAllocated);
    
    if (_bAqTmpBufAllocated == FALSE)
    {
        pu1DataAddr = (UINT8*)x_mem_alloc(AQ_LEN);
        _bAqTmpBufAllocated = TRUE;
    }
    printf("AQ! - pu1DataAddr = 0x%x, %d\n", pu1DataAddr, _bAqTmpBufAllocated);
    if (pu1DataAddr == NULL)
    {
        printf("AQ! - memory allocate failed!! (Size=%d Bytes)\n", AQ_LEN);
        _bAqTmpBufAllocated = FALSE;
        return -1; 
    }
    
    STORG_SyncRead(u1AQPartition, 0, (VOID*)pu1DataAddr, AQ_LEN);
    vAprocAqData_Write(0, pu1DataAddr, AQ_LEN);    
    //x_mem_free(pu1DataAddr); //Allocate once, and not release. (after long time pause/resume, may allocate fail!)

    //Initial Index 
    DrvCust_AQ_InitKeys();

    return 0;
}

INT32 DrvCust_AQ_SetVal(UINT32 u4Offset, UINT8 u1Value)
{
    UINT8 u1Val; 

    u1Val = u1Value;
    vAprocAqData_Write (u4Offset, &u1Val, 1);

    aq_printf("Write u4Offset 0x%x data to 0x%x\n", u4Offset, u1Val);

    return 0;
}

INT32 DrvCust_AQ_List(UINT32 u4Offset, UINT32 Length)
{
    UINT32 i;
    UINT8* pu1DataAddr; 

    pu1DataAddr = (UINT8*)x_mem_alloc(Length);
    if (pu1DataAddr == NULL)
    {
        aq_printf("AQ! - memory allocate failed!! (Size=%d Bytes)\n", Length);
        return -1; 
    }
    
    vAprocAqData_Read(u4Offset, (UINT8*)pu1DataAddr, Length);    
    for (i=0; i<Length; i++)
    {
        if ((i%16) ==0)
        {
            aq_printf("\n");
        }
        aq_printf("0x%02x ", pu1DataAddr[i]);
    }        
    aq_printf("\n");    
    x_mem_free(pu1DataAddr);

    return 0;
}

UINT32 DrvCust_AQ_GenKey(AUD_DrvCust_AQ_Key_T rAqKey)
{
    UINT32 u4Key;

#ifdef CC_AUD_SAKURA_RENDER
    if (rAqKey.u1SoundMode == AQ_SOUND_MODE_STANDARD)
    {
        if(DrvCust_AQ_IsSurround(rAqKey))
        {
            rAqKey.u1SoundMode = AQ_SOUND_MODE_STANDARD_SUR_ON;
        }
        else
        {
            rAqKey.u1SoundMode = AQ_SOUND_MODE_STANDARD_SUR_OFF;
        }
    }
    else if (rAqKey.u1SoundMode == AQ_SOUND_MODE_DEMO)
    {
        if(DrvCust_AQ_IsSurround(rAqKey))
        {
            rAqKey.u1SoundMode = AQ_SOUND_MODE_DEMO_SUR_ON;
        }
        else
        {
            rAqKey.u1SoundMode = AQ_SOUND_MODE_DEMO_SUR_OFF;
        }
    }
    
    u4Key = AQ_MAKE_KEY(rAqKey.u1Fs, rAqKey.u1MmMode, rAqKey.u1WirelessWoofer, rAqKey.u1TvPos, rAqKey.u1Input, 
                  rAqKey.u1SoundMode, rAqKey.u1BtConnect, rAqKey.u1PictureMode);
#else
    if (rAqKey.u1SoundMode == AQ_SOUND_MODE_STANDARD)
    {
        rAqKey.u1SoundMode = AQ_SOUND_MODE_STANDARD_S0A0 + (rAqKey.u1SurroundOnOff<<1)+ (rAqKey.u1AutoOnOff);
    }
    else if (rAqKey.u1SoundMode == AQ_SOUND_MODE_DEMO)
    {
        rAqKey.u1SoundMode = AQ_SOUND_MODE_DEMO_S0A0 + (rAqKey.u1SurroundOnOff<<1)+ (rAqKey.u1AutoOnOff);
    }

    u4Key = AQ_MAKE_KEY(rAqKey.u1Fs, rAqKey.u1MmMode, rAqKey.u1TvPos, rAqKey.u1Input, 
                  rAqKey.u1SoundMode, rAqKey.u1SoundBooster, rAqKey.u1WirelessWoofer);
#endif
    return u4Key;
}
UINT32 DrvCust_AQ_Get_SpecificTable(UINT32 u4TableNum, UINT32 u4InputKey, AQ_TBL_KEY_T* prAQTbl)
{
    UINT32 u4Idx;
    UINT32 j;
    BOOL fgFindKey = FALSE;
    UINT32 u4Size;
    UINT32 u4TmpKey, u4TmpInput, u4TmpExcept;
    UINT8 u1CurKeyByte, u1CurInByte, u1CurExceptByte;

    UNUSED(u4Size);

    for (u4Idx=0; u4Idx<u4TableNum; u4Idx++)
    {
        aqkey_printf("key   [%d]= 0x%08x\n", u4Idx,prAQTbl[u4Idx].u4Key);
        aqkey_printf("except[%d]= 0x%08x\n", u4Idx,prAQTbl[u4Idx].u4ExceptKey);

        u4TmpKey = prAQTbl[u4Idx].u4Key;     
        u4TmpExcept = prAQTbl[u4Idx].u4ExceptKey;
        u4TmpInput = u4InputKey;
        for (j=0; j<NUM_OF_KEY; j++)
        {
            u1CurKeyByte = (u4TmpKey & 0xF);
            u1CurInByte = (u4TmpInput & 0xF);
            u1CurExceptByte = (u4TmpExcept& 0xF);
            //aq_printf("(%d)In=0x%x, Key=0x%x, Ex=0x%x\n", j, u1CurInByte, u1CurKeyByte, u1CurExceptByte);
#ifdef CC_AUD_SAKURA_RENDER
            if ((((u1CurKeyByte == TYPE_ANY) || (u1CurKeyByte == u1CurInByte)) && (u1CurInByte != u1CurExceptByte)) || (j == LOOP_OF_S_MODE_KEY))
            {
                // If target is Input key
                if (j == LOOP_OF_INTPUT_KEY)
                {
                    // Inputs may contain many items. (e.x. DTV|ATV|HDMI| .....)
                    // Need a special case for it.
                    if ( (prAQTbl[u4Idx].u4Inputs                     == AQ_INPUT_DONT ) ||
                        ((prAQTbl[u4Idx].u4Inputs & (1<<u1CurInByte)) == (1<<u1CurInByte)))
                    {
                        // Input source condtion is OK
                        u4TmpKey = u4TmpKey >> 4;
                        u4TmpExcept = u4TmpExcept >> 4;
                        u4TmpInput = u4TmpInput >> 4;
                        //aq_printf("input ok, go next char in this key\n");
                    }
                    else
                    {
                        // Input source condtion is NG
                        //aq_printf("input NG, jump to next key\n");
                        break;
                    }
                }
                // If target is sound mode key
                else if(j == LOOP_OF_S_MODE_KEY){
                    if(((u1CurKeyByte == TYPE_ANY) || (u1CurKeyByte == u1CurInByte)) && (u1CurInByte != u1CurExceptByte)){
                        if((u1CurExceptByte == AQ_SOUND_MODE_DEMO) &&
                           ((u1CurInByte == AQ_SOUND_MODE_DEMO_SUR_OFF) || (u1CurInByte == AQ_SOUND_MODE_DEMO_SUR_ON))){
                            //aq_printf("sound mode NG-chk1, jump to next key\n");
                            break;
                        }
                    }
                    else if (u1CurKeyByte == AQ_SOUND_MODE_DEMO){
                        if((u1CurInByte != AQ_SOUND_MODE_DEMO_SUR_OFF) && (u1CurInByte != AQ_SOUND_MODE_DEMO_SUR_ON)){
                            //aq_printf("sound mode NG-chk2, jump to next key\n");
                            break;
                        }
                    }
                    else {
                        //aq_printf("sound mode NG-chk2, jump to next key\n");
                        break;
                    }
                    // sound mode condtion is OK
                    u4TmpKey = u4TmpKey >> 4;
                    u4TmpExcept = u4TmpExcept >> 4;
                    u4TmpInput = u4TmpInput >> 4;
                    //aq_printf("sound mode ok, go next char in this key\n");
                }
                else{
                    // If current condition is ANY and is NOT except.
                    u4TmpKey = u4TmpKey >> 4;
                    u4TmpExcept = u4TmpExcept >> 4;
                    u4TmpInput = u4TmpInput >> 4;
                    //aq_printf("ok, go next char in this key\n");
                }
            }
            else
            {
                //aq_printf("NG, jump to next key\n");
                break;
                // One condition is not match, just go to next table.
            }
#else
            if (j == LOOP_OF_INTPUT_KEY)  
            {
                // Inputs may contain many items. (e.x. DTV|ATV|HDMI| .....)
                // Need a special case for it.
                if ((prAQTbl[u4Idx].u4Inputs & (1<<u1CurInByte)) == (1<<u1CurInByte))
                {
                    // Input source condtion is OK
                    u4TmpKey = u4TmpKey >> 4;
                    u4TmpExcept = u4TmpExcept >> 4;
                    u4TmpInput = u4TmpInput >> 4;                
                }
                else
                {
                    // Input source condtion is NG
                    break;
                }
            }
            else if (((u1CurKeyByte == 0xF) || (u1CurKeyByte == u1CurInByte)) && (u1CurInByte != u1CurExceptByte))
            {
                // If current condition is ANY and is NOT except.
                u4TmpKey = u4TmpKey >> 4;
                u4TmpExcept = u4TmpExcept >> 4;
                u4TmpInput = u4TmpInput >> 4;
                //aq_printf("ok, go next char in this key\n"); 
            }
            else
            {
                //aq_printf("NG, jump to next key\n");
                break;
                // One condition is not match, just go to next table.
            }    
#endif /* CC_AUD_SAKURA_RENDER */
        }
        if (j == NUM_OF_KEY)
        {
            aq_printf("Good!! find Table Idx = %d!!!\n", u4Idx);
            fgFindKey = TRUE;
            break;
        }
    }

    if (!fgFindKey)
    {
        u4Idx = 0; 
    }
    aqkey_printf("Input key is 0x%x\n", u4InputKey);
    aqkey_printf("Table index is %d, (Find=%d)\n", u4Idx, fgFindKey);

    return u4Idx;
}

#if defined(AQ_SELF_TEST) && !defined(CC_MAPLE_CUST_DRV)
CUST_AUD_SOUND_SETTING_T gSoundSetting;
#endif

void AQ_Dump_Table(INT32* pi4Table, UINT32 u4Size)
{
    UINT32 j;
       
    for (j=0; j<(u4Size/4); j++)
    {
        if (j%4 == 0)
        {
            aq_printf("\n");
        }
        aq_printf ("0x%08x ", pi4Table[j]);
    }   
}

#ifdef CC_AUD_SAKURA_RENDER
void AQ_Dump_Byte(UINT8* pu1Byte, UINT32 u4Size)
{
    UINT32 j;
    
    for (j=0; j<u4Size; j++)
    {
        if (j%16 == 0)
        {
            aq_printf("\n");
        }
        aq_printf ("0x%02x ", pu1Byte[j]);
    }
}
#endif /* CC_AUD_SAKURA_RENDER */

#ifdef CC_AUD_SAKURA_RENDER
INT32 DrvCust_AQ_Get_SVTSP(AQDataMmSvtSp* pGetSvtSpData, UINT32 u4InputKey, UINT32 u4Type)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmSvtSp rSvtSpData;
    INT32* pi1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_SVT_SP_MAX, u4InputKey, _ar_MmSvtSpTbl_Key);
    u4Size = sizeof(rSvtSpData); 
    vAprocAqData_Read(MM_SVT_SP_OFFSET+u4Idx*u4Size, (UINT8*)&rSvtSpData, u4Size);
    pi1Tmp = (INT32*)&rSvtSpData;

    if (u4Type == AQ_NOT_SPECIFIC) /* Just query table */
    {
        AQ_Dump_Table(pi1Tmp, u4Size);
    }
    else
    {
        if (pGetSvtSpData!=NULL)
        {
            x_memcpy((VOID*)VIRTUAL((UINT32)pGetSvtSpData), (VOID*)VIRTUAL((UINT32)&rSvtSpData), sizeof(AQDataMmSvtSp));
        }
    }

    return 0;
}

INT32 DrvCust_AQ_Get_SVTSPW(AQDataMmSvtSpw* pGetSvtSpwData, UINT32 u4InputKey, UINT32 u4Type)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmSvtSpw rSvtSpWData;
    INT32* pi1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_SVT_SPW_MAX, u4InputKey, _ar_MmSvtSpwTbl_Key);
    u4Size = sizeof(rSvtSpWData); 
    vAprocAqData_Read(MM_SVT_SPW_OFFSET+u4Idx*u4Size, (UINT8*)&rSvtSpWData, u4Size);
    pi1Tmp = (INT32*)&rSvtSpWData;
    
    if (u4Type == AQ_NOT_SPECIFIC) /* Just query table */
    {
        AQ_Dump_Table(pi1Tmp, u4Size);
    }
    else
    {
        if (pGetSvtSpwData!=NULL)
        {
            x_memcpy((VOID*)VIRTUAL((UINT32)pGetSvtSpwData), (VOID*)VIRTUAL((UINT32)&rSvtSpWData), sizeof(AQDataMmSvtSpw));
        }
    }

    return 0;
}

INT32 DrvCust_AQ_Get_SVT_HP(AQDataMmSvtHp* pGetSvtHpData, UINT32 u4InputKey, UINT32 u4Type)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmSvtHp rSvtHpData;
    INT32* pi1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_SVT_HP_MAX, u4InputKey, _ar_MmSvtHpTbl_Key);
    u4Size = sizeof(rSvtHpData); 
    vAprocAqData_Read(MM_SVT_HP_OFFSET+u4Idx*u4Size, (UINT8*)&rSvtHpData, u4Size);
    pi1Tmp = (INT32*)&rSvtHpData;
    
    if (u4Type == AQ_NOT_SPECIFIC) /* Just query table */
    {
        AQ_Dump_Table(pi1Tmp, u4Size);
    }
    else
    {
        if (pGetSvtHpData!=NULL)
        {
            x_memcpy((VOID*)VIRTUAL((UINT32)pGetSvtHpData), (VOID*)VIRTUAL((UINT32)&rSvtHpData), sizeof(AQDataMmSvtHp));
        }
    }

    return 0;
}

INT32 DrvCust_AQ_Get_SVT_LO(AQDataMmSvtLo* pGetSvtLoData, UINT32 u4InputKey, UINT32 u4Type)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmSvtLo rSvtLoData;
    INT32* pi1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_SVT_LO_MAX, u4InputKey, _ar_MmSvtLoTbl_Key);
    u4Size = sizeof(rSvtLoData); 
    vAprocAqData_Read(MM_SVT_LO_OFFSET+u4Idx*u4Size, (UINT8*)&rSvtLoData, u4Size);
    pi1Tmp = (INT32*)&rSvtLoData;
    
    if (u4Type == AQ_NOT_SPECIFIC) /* Just query table */
    {
        AQ_Dump_Table(pi1Tmp, u4Size);
    }
    else
    {
        if (pGetSvtLoData!=NULL)
        {
            x_memcpy((VOID*)VIRTUAL((UINT32)pGetSvtLoData), (VOID*)VIRTUAL((UINT32)&rSvtLoData), sizeof(AQDataMmSvtLo));
        }
    }

    return 0;
}

INT32 DrvCust_AQ_Get_SVT_LOH(AQDataMmSvtLoh* pGetSvtLohData, UINT32 u4InputKey, UINT32 u4Type)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmSvtLoh rSvtLoHData;
    INT32* pi1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_SVT_LOH_MAX, u4InputKey, _ar_MmSvtLohTbl_Key);
    u4Size = sizeof(rSvtLoHData); 
    vAprocAqData_Read(MM_SVT_LOH_OFFSET+u4Idx*u4Size, (UINT8*)&rSvtLoHData, u4Size);
    pi1Tmp = (INT32*)&rSvtLoHData;
    
    if (u4Type == AQ_NOT_SPECIFIC) /* Just query table */
    {
        AQ_Dump_Table(pi1Tmp, u4Size);
    }
    else
    {
        if (pGetSvtLohData!=NULL)
        {
            x_memcpy((VOID*)VIRTUAL((UINT32)pGetSvtLohData), (VOID*)VIRTUAL((UINT32)&rSvtLoHData), sizeof(AQDataMmSvtLoh));
        }
    }

    return 0;

}

INT32 DrvCust_AQ_Get_SVT_ASW(AQDataMmSvtAsw* pGetSvtAswData, UINT32 u4InputKey, UINT32 u4Type)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmSvtAsw rSvtAswData;
    INT32* pi1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_SVT_ASW_MAX, u4InputKey, _ar_MmSvtAswTbl_Key);
    u4Size = sizeof(rSvtAswData); 
    vAprocAqData_Read(MM_SVT_ASW_OFFSET+u4Idx*u4Size, (UINT8*)&rSvtAswData, u4Size);
    pi1Tmp = (INT32*)&rSvtAswData;
    
    if (u4Type == AQ_NOT_SPECIFIC) /* Just query table */
    {
        AQ_Dump_Table(pi1Tmp, u4Size);
    }
    else
    {
        if (pGetSvtAswData!=NULL)
        {
            x_memcpy((VOID*)VIRTUAL((UINT32)pGetSvtAswData), (VOID*)VIRTUAL((UINT32)&rSvtAswData), sizeof(AQDataMmSvtAsw));
        }
    }

    return 0;
}

INT32 DrvCust_AQ_Get_SVT_DSW(AQDataMmSvtDsw* pGetSvtDswData, UINT32 u4InputKey, UINT32 u4Type)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmSvtDsw rSvtDswData;
    INT32* pi1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_SVT_DSW_MAX, u4InputKey, _ar_MmSvtDswTbl_Key);
    u4Size = sizeof(rSvtDswData); 
    vAprocAqData_Read(MM_SVT_DSW_OFFSET+u4Idx*u4Size, (UINT8*)&rSvtDswData, u4Size);
    pi1Tmp = (INT32*)&rSvtDswData;
    
    if (u4Type == AQ_NOT_SPECIFIC) /* Just query table */
    {
        AQ_Dump_Table(pi1Tmp, u4Size);
    }
    else
    {
        if (pGetSvtDswData!=NULL)
        {
            x_memcpy((VOID*)VIRTUAL((UINT32)pGetSvtDswData), (VOID*)VIRTUAL((UINT32)&rSvtDswData), sizeof(AQDataMmSvtDsw));
        }
    }

    return 0;

}

INT32 DrvCust_AQ_Get_SVT_BT(AQDataMmSvtBt* pGetSvtBtData, UINT32 u4InputKey, UINT32 u4Type)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmSvtBt rSvtBtData;
    INT32* pi1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_SVT_BT_MAX, u4InputKey, _ar_MmSvtBtTbl_Key);
    u4Size = sizeof(rSvtBtData); 
    vAprocAqData_Read(MM_SVT_BT_OFFSET+u4Idx*u4Size, (UINT8*)&rSvtBtData, u4Size);
    pi1Tmp = (INT32*)&rSvtBtData;
    
    if (u4Type == AQ_NOT_SPECIFIC) /* Just query table */
    {
        AQ_Dump_Table(pi1Tmp, u4Size);
    }
    else
    {
        if (pGetSvtBtData!=NULL)
        {
            x_memcpy((VOID*)VIRTUAL((UINT32)pGetSvtBtData), (VOID*)VIRTUAL((UINT32)&rSvtBtData), sizeof(AQDataMmSvtBt));
        }
    }

    return 0;

}

#else // CC_AUD_SAKURA_RENDER

INT32 AQ_VolTable_Offset(UINT8 u1DecId, UINT32 u4InputKey, INT32 i4CurVol, INT32 i4TblVol100 ,INT32 i4LimitOffset, INT32 i4ChOffset, BOOL fgUIOffset)
{
    AQDataMmAct rGetActData;
    AQDataMmSmt rGetSmtData;
    AUD_DEC_STREAM_FROM_T eStreamFrom;
    AUD_FMT_T eDecType;    
    INT32 i4OffsetGain;    
    BOOL b2kModel = TRUE;
    INT32 i4Value;
    INT32 i4Vol100;
    INT32 i4VolLimit;

    UNUSED(eStreamFrom);
            
    /*Volume Offset*/
    DrvCust_AQ_Get_ACT(&rGetActData, u4InputKey, AQ_QRY_ANY_IDX);
    DrvCust_AQ_Get_SMT(&rGetSmtData, u4InputKey, AQ_QRY_ANY_IDX);      
    aq_printf("eStreamFrom=%d, eDecType=%d, m_MmVolOffsetStep=%d, m_MmAacStep=%d, m_MmMpegStep=%d, m_MmDdRfModeOfst=%d\n",
           eStreamFrom, eDecType, rGetActData.m_MmVolOffsetStep, rGetActData.m_MmAacStep, 
           rGetActData.m_MmMpegStep, rGetActData.m_MmDdRfModeOfst);

    /*
    offset_gain = CH_OFFSET_GAIN + CODEC_OFFSET_GAIN + UI_OFFSET_GAIN
    - CODEC_OFFSET_GAIN = user_mpeg_audio_level * MM_MPEG_STEP * 0.1
                         + user_aac_audio_level * MM_AAC_STEP * 0.1
                         - MM_DD_RF_MODE_OFST * 0.1 [dB]
    - UI_OFFSET_GAIN    = user_volume_offset * MM_VOL_OFFSET_STEP * 0.1 [dB]
   */ 
    i4OffsetGain = 0;
#ifdef AQ_SELF_TEST //For Test Only
    /* rGetActData.m_MmMpegStep      (1~30, 0.1dB/Step)
      gSoundSetting.i1MpegAudioLevel (-12~0) */
    gSoundSetting.i1MpegAudioLevel = -12;
    eDecType=AUD_FMT_MPEG;
#endif
            
#if defined (CC_MAPLE_CUST_DRV) || defined(AQ_SELF_TEST)
    aq_printf("From UI, mpg=%d, aac=%d, offset=%d\n",gSoundSetting.i1MpegAudioLevel,gSoundSetting.i1HeAacAudioLevel,gSoundSetting.i1InputLevelOffset);

    #ifdef CC_COMBINE_4K_2K
    if((DRVCUST_Get_2K_Model()&0x01)!=0x00) //2K model
    {
        b2kModel = FALSE;
    }        
    #endif //CC_COMBINE_4K_2K
    if (b2kModel) /* CODEC and UI offset only for 2K models */
    {
        /* 1. CODEC Offset is Here !!!!! */
        if ((eDecType==AUD_FMT_AC3) && (AUD_DspGetAC3CompMode(u1DecId)==3) ) //2:Line, 3:RF Mode
        {
            i4OffsetGain -= rGetActData.m_MmDdRfModeOfst;
            aq_printf("After Codec AC3, m_MmDdRfModeOfst=%d, i4OffsetGain=%d\n", rGetActData.m_MmDdRfModeOfst, i4OffsetGain);
            
        }
        else if ((eDecType==AUD_FMT_MPEG)||(eDecType==AUD_FMT_MP3))
        {
            i4OffsetGain += (rGetActData.m_MmMpegStep * gSoundSetting.i1MpegAudioLevel);
            aq_printf("After Codec MPEG/MP3, m_MmMpegStep=%d, i1MpegAudioLevel=%d, i4OffsetGain=%d\n", rGetActData.m_MmDdRfModeOfst, gSoundSetting.i1MpegAudioLevel, i4OffsetGain);
        }
        else if ((eDecType==AUD_FMT_AAC)&&(AUD_DspGetDdtDmxRfMode(u1DecId,FALSE)==3)) // 2:DMX_MS10_LINE, 3:DMX_MS10_RF
        {
            i4OffsetGain += (rGetActData.m_MmAacStep * gSoundSetting.i1HeAacAudioLevel);
            aq_printf("After Codec AAC, m_MmAacStep=%d, i1HeAacAudioLevel=%, i4OffsetGain=%d\n", rGetActData.m_MmAacStep, gSoundSetting.i1HeAacAudioLevel, i4OffsetGain);
        }            
        /* 2. UI Offset is here !!!!*/
        if (fgUIOffset)
        {
            i4OffsetGain += (rGetActData.m_MmVolOffsetStep * gSoundSetting.i1InputLevelOffset);
        }
    }            
#endif //CC_MAPLE_CUST_DRV

    /*3. CH_OFFSET_GAIN is here !!!!!*/
    i4OffsetGain += i4ChOffset;
    i4Value = i4CurVol + i4OffsetGain;
    aq_printf("After CH_OFFSET_GAIN(=%d), i4OffsetGain=%d, i4Value=%d\n", i4ChOffset, i4OffsetGain, i4Value);

    /* 4. To Check Limit!!!!
        If volume_gain_setting > ( MM_VOL_100 + CH_OFFSET_GAIN + LIMIT_OFFSET ) [dB], 
        volume_gain_setting shall be limited to ( MM_VOL_100 + CH_OFFSET_GAIN + LIMIT_OFFSET ) [dB].
   */         
    /* VOl Step100 */
    i4Vol100 = i4TblVol100;
#ifdef CHANGE_ENDIAN /*MSB, LSB*/
    i4Vol100 = ((i4Vol100>>24)&0xFF) | ((i4Vol100>>16)&0xFF)<<8 | ((i4Vol100>>8)&0xFF)<<16 | (i4Vol100&0xFF)<<24;
#endif
    /* Limit Offset */            
    i4VolLimit = i4LimitOffset;
    aq_printf("i4Vol100=0x%x,%d, i4LimitOffset=%d, CH_Offset=%d, Total_Limit=%d\n", 
               i4Vol100,i4Vol100, i4VolLimit, i4ChOffset, i4VolLimit+i4Vol100+i4ChOffset);
    i4VolLimit = i4VolLimit + i4Vol100 + i4ChOffset;

    if (i4Value > i4VolLimit)
    {
        i4Value = i4VolLimit;
    }
    /*Get item (dB, e.x.1195 means -119.5 dB) in dB table.*/
    i4Value = i4Value*(-1);
    aq_printf("Final, i4Value=%d", i4Value);

    if ((i4Value >= 0) && (i4Value < VOL_STEP))
    {
        aq_printf(", gu4DbTable[%d]=0x%x\n", i4Value, gu4DbTable[i4Value]);
        i4Value = gu4DbTable[i4Value];
    }
    else
    {
        i4Value = AQ_NOT_SPECIFIC;
        aq_printf(", Invalid value !! set to 0x%x\n", i4Value);
    }
    
    return i4Value;
}

INT32 DrvCust_AQ_Get_SVTSP(AUD_DrvCust_Qry_T* prQryVol, UINT32 u4InputKey, UINT32 u4VolTbIdx)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmSvtSp rSvtSpData;
    INT32* pi1Tmp;
    INT32 i4Value, i4Vol100, i4VolLimit, i4ChOffset;
    UINT8 u1DecId = AUD_DEC_MAIN;
    AQDataMmSmt rGetSmtData;    

    if (prQryVol!=NULL)
    {
        u1DecId = (UINT8)prQryVol->u4DecId;
    }       
    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_SVT_SP_MAX, u4InputKey, _ar_MmSvtSpTbl_Key);
    u4Size = sizeof(AQDataMmSvtSp); 
    vAprocAqData_Read(MM_SVT_SP_OFFSET+u4Idx*u4Size, (UINT8*)&rSvtSpData, u4Size);
    pi1Tmp = (INT32*)&rSvtSpData;
    
    if (u4VolTbIdx == AQ_NOT_SPECIFIC) /* Just query table */
    {
        AQ_Dump_Table(pi1Tmp, u4Size);
    }
    else
    {
        prQryVol->u4ReturnVal = AQ_NOT_SPECIFIC;  /*default is invalid value, aud_dsp_cfg.c will check range*/
        if (u4VolTbIdx <= 100)
        {
            /*data in SONY AQ table is dB (e.x. -119.5 dB, SONY will put -1195 in AQ table)*/
            i4Value = pi1Tmp[u4VolTbIdx];  
#ifdef CHANGE_ENDIAN /*MSB, LSB*/
            i4Value = ((i4Value>>24)&0xFF) | ((i4Value>>16)&0xFF)<<8 | ((i4Value>>8)&0xFF)<<16 | (i4Value&0xFF)<<24;
#endif
            aq_printf("u4VolTbIdx=%d, pi1Tmp=0x%x(0~-120), i4Value=0x%x,%d(0~-120)\n", u4VolTbIdx, pi1Tmp[u4VolTbIdx], i4Value,i4Value);

            DrvCust_AQ_Get_SMT(&rGetSmtData, u4InputKey, AQ_QRY_ANY_IDX);
#ifdef AQ_SELF_TEST //For Test Only
            rSvtSpData.m_MmSpLimitOffset = 6; // 6 dB for test
            rGetSmtData.m_MmWonda = 130;      // 0.2 dB for test
#endif              
            i4VolLimit = rSvtSpData.m_MmSpLimitOffset * 10; //Other items are 0.1 dB unit, this item is 0~6 dB, so * 10
            i4Vol100 = rSvtSpData.m_MmSpVol100;
            i4ChOffset = rGetSmtData.m_MmWonda-128;
            prQryVol->u4ReturnVal = AQ_VolTable_Offset(u1DecId, u4InputKey, i4Value, i4Vol100 ,i4VolLimit, i4ChOffset, TRUE);
        }
    }

    return 0;
}

INT32 DrvCust_AQ_Get_SVTSPW(AUD_DrvCust_Qry_T* prQryVol, UINT32 u4InputKey, UINT32 u4VolTbIdx)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmSvtSpw rSvtSpW_Data;
    INT32* pi1Tmp;
    INT32 i4Value, i4Vol100, i4VolLimit, i4ChOffset;
    UINT8 u1DecId = AUD_DEC_MAIN;
    AQDataMmSmt rGetSmtData;    

    if (prQryVol!=NULL)
    {
        u1DecId = (UINT8)prQryVol->u4DecId;
    }       
    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_SVT_SPW_MAX, u4InputKey, _ar_MmSvtSpwTbl_Key);
    u4Size = sizeof(rSvtSpW_Data); 
    vAprocAqData_Read(MM_SVT_SPW_OFFSET+u4Idx*u4Size, (UINT8*)&rSvtSpW_Data, u4Size);
    pi1Tmp = (INT32*)&rSvtSpW_Data;
    
    if (u4VolTbIdx == AQ_NOT_SPECIFIC) /* Just query table */
    {
        AQ_Dump_Table(pi1Tmp, u4Size);
    }
    else
    {
        prQryVol->u4ReturnVal = AQ_NOT_SPECIFIC;  /*default is invalid value, aud_dsp_cfg.c will check range*/
        if (u4VolTbIdx <= 100)
        {
            /*data in SONY AQ table is dB (e.x. -119.5 dB, SONY will put -1195 in AQ table)*/
            i4Value = pi1Tmp[u4VolTbIdx];  
#ifdef CHANGE_ENDIAN /*MSB, LSB*/
            i4Value = ((i4Value>>24)&0xFF) | ((i4Value>>16)&0xFF)<<8 | ((i4Value>>8)&0xFF)<<16 | (i4Value&0xFF)<<24;
#endif
            aq_printf("u4VolTbIdx=%d, pi1Tmp=0x%x, i4Value=0x%x(%d)\n", u4VolTbIdx, pi1Tmp[u4VolTbIdx], i4Value,i4Value);

            DrvCust_AQ_Get_SMT(&rGetSmtData, u4InputKey, AQ_QRY_ANY_IDX);
#ifdef AQ_SELF_TEST //For Test Only
            rSvtSpW_Data.m_MmSpwLimitOffset = 6;
            rGetSmtData.m_MmCaramelMacchiato = 130;
#endif              
            i4VolLimit = rSvtSpW_Data.m_MmSpwLimitOffset * 10; //Other items are 0.1 dB unit, this item is 0~6 dB, so * 10
            i4Vol100 = rSvtSpW_Data.m_MmSpwVol100;
            i4ChOffset = rGetSmtData.m_MmCaramelMacchiato-128;
            prQryVol->u4ReturnVal = AQ_VolTable_Offset(u1DecId, u4InputKey, i4Value, i4Vol100 ,i4VolLimit, i4ChOffset, TRUE);            
        }
    }

    return 0;
}

INT32 DrvCust_AQ_Get_SVT_HP(AUD_DrvCust_Qry_T* prQryVol, UINT32 u4InputKey, UINT32 u4VolTbIdx)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmSvtHp rSvtHp_Data;
    INT32* pi1Tmp;
    INT32 i4Value, i4Vol100, i4VolLimit, i4ChOffset;
    UINT8 u1DecId = AUD_DEC_MAIN;
    AQDataMmSmt rGetSmtData;    

    if (prQryVol!=NULL)
    {
        u1DecId = (UINT8)prQryVol->u4DecId;
    }       
    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_SVT_HP_MAX, u4InputKey, _ar_MmSvtHpTbl_Key);
    u4Size = sizeof(rSvtHp_Data); 
    vAprocAqData_Read(MM_SVT_HP_OFFSET+u4Idx*u4Size, (UINT8*)&rSvtHp_Data, u4Size);
    pi1Tmp = (INT32*)&rSvtHp_Data;
    
    if (u4VolTbIdx == AQ_NOT_SPECIFIC) /* Just query table */
    {
        AQ_Dump_Table(pi1Tmp, u4Size);
    }
    else
    {
        prQryVol->u4ReturnVal = AQ_NOT_SPECIFIC;  /*default is invalid value, aud_dsp_cfg.c will check range*/
        if (u4VolTbIdx <= 100)
        {
            /*data in SONY AQ table is dB (e.x. -119.5 dB, SONY will put -1195 in AQ table)*/
            i4Value = pi1Tmp[u4VolTbIdx];  
#ifdef CHANGE_ENDIAN /*MSB, LSB*/
            i4Value = ((i4Value>>24)&0xFF) | ((i4Value>>16)&0xFF)<<8 | ((i4Value>>8)&0xFF)<<16 | (i4Value&0xFF)<<24;
#endif
            aq_printf("u4VolTbIdx=%d, pi1Tmp=0x%x, i4Value=0x%x(%d)\n", u4VolTbIdx, pi1Tmp[u4VolTbIdx], i4Value,i4Value);

            DrvCust_AQ_Get_SMT(&rGetSmtData, u4InputKey, AQ_QRY_ANY_IDX);
#ifdef AQ_SELF_TEST //For Test Only
            rSvtHp_Data.m_MmHpLimitOffset = 6;
#endif              
            i4VolLimit = rSvtHp_Data.m_MmHpLimitOffset * 10; //Other items are 0.1 dB unit, this item is 0~6 dB, so * 10
            i4Vol100 = rSvtHp_Data.m_MmHpVol100;
            i4ChOffset = 0;     //Hp doesn't have ch offset!
            prQryVol->u4ReturnVal = AQ_VolTable_Offset(u1DecId, u4InputKey, i4Value, i4Vol100 ,i4VolLimit, i4ChOffset, TRUE);
        }
    }

    return 0;
}

INT32 DrvCust_AQ_Get_SVT_LO(AUD_DrvCust_Qry_T* prQryVol, UINT32 u4InputKey, UINT32 u4VolTbIdx)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmSvtLo rSvtLo_Data;
    INT32* pi1Tmp;
    INT32 i4Value, i4Vol100, i4VolLimit, i4ChOffset;
    UINT8 u1DecId = AUD_DEC_MAIN;
    AQDataMmSmt rGetSmtData;    
//    AQDataMmSlt rGetSltData;

    if (prQryVol!=NULL)
    {
        u1DecId = (UINT8)prQryVol->u4DecId;
    }       
    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_SVT_LO_MAX, u4InputKey, _ar_MmSvtLoTbl_Key);
    u4Size = sizeof(rSvtLo_Data); 
    vAprocAqData_Read(MM_SVT_LO_OFFSET+u4Idx*u4Size, (UINT8*)&rSvtLo_Data, u4Size);
    pi1Tmp = (INT32*)&rSvtLo_Data;
    
    if (u4VolTbIdx == AQ_NOT_SPECIFIC) /* Just query table */
    {
        AQ_Dump_Table(pi1Tmp, u4Size);
    }
    else
    {
        prQryVol->u4ReturnVal = AQ_NOT_SPECIFIC;  /*default is invalid value, aud_dsp_cfg.c will check range*/
        if (u4VolTbIdx <= 100)
        {
            /*data in SONY AQ table is dB (e.x. -119.5 dB, SONY will put -1195 in AQ table)*/
            i4Value = pi1Tmp[u4VolTbIdx];  
#ifdef CHANGE_ENDIAN /*MSB, LSB*/
            i4Value = ((i4Value>>24)&0xFF) | ((i4Value>>16)&0xFF)<<8 | ((i4Value>>8)&0xFF)<<16 | (i4Value&0xFF)<<24;
#endif
            aq_printf("u4VolTbIdx=%d, pi1Tmp=0x%x, i4Value=0x%x(%d)\n", u4VolTbIdx, pi1Tmp[u4VolTbIdx], i4Value,i4Value);

            DrvCust_AQ_Get_SMT(&rGetSmtData, u4InputKey, AQ_QRY_ANY_IDX);
#ifdef AQ_SELF_TEST //For Test Only
            rSvtLo_Data.m_MmLoLimitOffset = 6;
#endif              
            if (1) //Variable Mode
            {
                i4VolLimit = rSvtLo_Data.m_MmLoLimitOffset * 10; //Other items are 0.1 dB unit, this item is 0~6 dB, so * 10
                i4Vol100 = rSvtLo_Data.m_MmLoVol100;
                i4ChOffset = 0;
                i4Value = AQ_VolTable_Offset(u1DecId, u4InputKey, i4Value, i4Vol100 ,i4VolLimit, i4ChOffset, TRUE);
            }
            else //Fixed Mode,
            {
                /* LineOut( FIXED ) = (MM_LO_FIX_LV - 214) * 0.5 + CODEC_OFFSET_GAIN [dB]
                 No upper limit */
#if 0 //todo, DrvCust_AQ_Get_SLT is not ready yey!!
                i4VolLimit = 100; //No upper bound for fixed lineout. I set it to 100 dB, vert large number.
                i4Vol100 = 0;
                
                DrvCust_AQ_Get_ACT(&rGetSltData, u4InputKey, AQ_QRY_ANY_IDX);                
                ===> Shoule be DrvCust_AQ_Get_SLT !!!!
                    
                i4Value = (rGetSltData.m_MmLoFixLv - 214)*5;
                aq_printf("Fixed Lineout, i4Value=0x%x(%d)\n", i4Value,i4Value);
                i4ChOffset = 0;   //No Channel offset
                i4Value = AQ_VolTable_Offset(u1DecId, u4InputKey, i4Value, i4Vol100 ,i4VolLimit, i4ChOffset, FALSE);
#endif                
            }
            prQryVol->u4ReturnVal = i4Value;
        }
    }

    return 0;
}

INT32 DrvCust_AQ_Get_SVT_LOH(AUD_DrvCust_Qry_T* prQryVol, UINT32 u4InputKey, UINT32 u4VolTbIdx)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmSvtLoh rSvtLoH_Data;
    INT32* pi1Tmp;
    INT32 i4Value, i4Vol100, i4VolLimit, i4ChOffset;
    UINT8 u1DecId = AUD_DEC_MAIN;
    AQDataMmSmt rGetSmtData;  
    AQDataMmAct rGetActData;    

    if (prQryVol!=NULL)
    {
        u1DecId = (UINT8)prQryVol->u4DecId;
    }       
    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_SVT_LOH_MAX, u4InputKey, _ar_MmSvtLohTbl_Key);
    u4Size = sizeof(rSvtLoH_Data); 
    vAprocAqData_Read(MM_SVT_LOH_OFFSET+u4Idx*u4Size, (UINT8*)&rSvtLoH_Data, u4Size);
    pi1Tmp = (INT32*)&rSvtLoH_Data;
    
    if (u4VolTbIdx == AQ_NOT_SPECIFIC) /* Just query table */
    {
        AQ_Dump_Table(pi1Tmp, u4Size);
    }
    else
    {
        prQryVol->u4ReturnVal = AQ_NOT_SPECIFIC;  /*default is invalid value, aud_dsp_cfg.c will check range*/
        if (u4VolTbIdx <= 100)
        {
            /*data in SONY AQ table is dB (e.x. -119.5 dB, SONY will put -1195 in AQ table)*/
            i4Value = pi1Tmp[u4VolTbIdx];  
#ifdef CHANGE_ENDIAN /*MSB, LSB*/
            i4Value = ((i4Value>>24)&0xFF) | ((i4Value>>16)&0xFF)<<8 | ((i4Value>>8)&0xFF)<<16 | (i4Value&0xFF)<<24;
#endif
            aq_printf("u4VolTbIdx=%d, pi1Tmp=0x%x, i4Value=0x%x(%d)\n", u4VolTbIdx, pi1Tmp[u4VolTbIdx], i4Value,i4Value);

            DrvCust_AQ_Get_SMT(&rGetSmtData, u4InputKey, AQ_QRY_ANY_IDX);
            DrvCust_AQ_Get_ACT(&rGetActData, u4InputKey, AQ_QRY_ANY_IDX);            
#ifdef AQ_SELF_TEST //For Test Only
            rSvtLoH_Data.m_MmLohLimitOffset = 6;
            rGetActData.m_MmHotelLoOffset = 80; //0~80, 0.5 dB/Step
            rGetActData.m_MmMixAtt = 240;
            rGetSmtData.m_MmInputAtt = 30;
#endif              
            /*
             offset_gain for LineOut( HOTEL ) = CODEC_OFFSET_GAIN + UI_OFFSET_GAIN + HOTEL_OFFSET_GAIN + ATT_COMPENSATION
             HOTEL_OFFSET_GAIN = - MM_HOTEL_LO_OFFSET * 0.5 [dB]						
             ATT_COMPENSATION = MM_INPUT_ATT  * 0.5 + MM_MIX_ATT * 0.1 [dB]						
             If volume_gain_setting > ( MM_LOH_VOL_100 + ATT_COMPENSATION + MM_LOH_LIMIT_OFFSET )
           */
            i4VolLimit = rSvtLoH_Data.m_MmLohLimitOffset * 10; //Other items are 0.1 dB unit, this item is 0~6 dB, so * 10
            i4Vol100 = rSvtLoH_Data.m_MmLohVol100;
            i4ChOffset = (rGetActData.m_MmMixAtt*1)+(rGetSmtData.m_MmInputAtt*5)-(rGetActData.m_MmHotelLoOffset*5);
            /* In AQ_VolTable_Offset, 
             Offset is CH Offset + Codec + UI, 
             Limit is  CH Offset + Limit Offset + Vol100
             But in this case, 
             Limit is Limit Offset + ATT + Vol100
             CH_Offset = ATT-Hotel_Offset, So I add Hotel_offset back to compensate it*/
            i4VolLimit = i4VolLimit + (rGetActData.m_MmHotelLoOffset*5);
            aq_printf("m_MmLohLimitOffset=%d, i4Vol100=0x%x, i4ChOffset=%d, i4VolLimit=%d\n",rSvtLoH_Data.m_MmLohLimitOffset, i4Vol100, i4ChOffset, i4VolLimit);
            prQryVol->u4ReturnVal = AQ_VolTable_Offset(u1DecId, u4InputKey, i4Value, i4Vol100 ,i4VolLimit, i4ChOffset, TRUE);
        }
    }

    return 0;

}

INT32 DrvCust_AQ_Get_SVT_ASW(AUD_DrvCust_Qry_T* prQryVol, UINT32 u4InputKey, UINT32 u4VolTbIdx)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmSvtAsw rSvtAsw_Data;
    INT32* pi1Tmp;
    INT32 i4Value, i4Vol100, i4VolLimit, i4ChOffset;
    UINT8 u1DecId = AUD_DEC_MAIN;
    AQDataMmSws rGetSwsData;    

    if (prQryVol!=NULL)
    {
        u1DecId = (UINT8)prQryVol->u4DecId;
    }       
    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_SVT_ASW_MAX, u4InputKey, _ar_MmSvtAswTbl_Key);
    u4Size = sizeof(rSvtAsw_Data); 
    vAprocAqData_Read(MM_SVT_ASW_OFFSET+u4Idx*u4Size, (UINT8*)&rSvtAsw_Data, u4Size);
    pi1Tmp = (INT32*)&rSvtAsw_Data;
    
    if (u4VolTbIdx == AQ_NOT_SPECIFIC) /* Just query table */
    {
        AQ_Dump_Table(pi1Tmp, u4Size);
    }
    else
    {
        prQryVol->u4ReturnVal = AQ_NOT_SPECIFIC;  /*default is invalid value, aud_dsp_cfg.c will check range*/
        if (u4VolTbIdx <= 100)
        {
            /*data in SONY AQ table is dB (e.x. -119.5 dB, SONY will put -1195 in AQ table)*/
            i4Value = pi1Tmp[u4VolTbIdx];  
#ifdef CHANGE_ENDIAN /*MSB, LSB*/
            i4Value = ((i4Value>>24)&0xFF) | ((i4Value>>16)&0xFF)<<8 | ((i4Value>>8)&0xFF)<<16 | (i4Value&0xFF)<<24;
#endif
            aq_printf("u4VolTbIdx=%d, pi1Tmp=0x%x, i4Value=0x%x(%d)\n", u4VolTbIdx, pi1Tmp[u4VolTbIdx], i4Value,i4Value);

            DrvCust_AQ_Get_SWS(&rGetSwsData, u4InputKey, AQ_QRY_ANY_IDX);
#ifdef AQ_SELF_TEST //For Test Only
            rSvtAsw_Data.m_MmAswLimitOffset = 6;
            rGetSwsData.m_MmAswWonda = 130;
#endif              
            i4VolLimit = rSvtAsw_Data.m_MmAswLimitOffset * 10; //Other items are 0.1 dB unit, this item is 0~6 dB, so * 10
            i4Vol100 = rSvtAsw_Data.m_MmAswVol100;
            i4ChOffset = rGetSwsData.m_MmAswWonda-128;
            prQryVol->u4ReturnVal = AQ_VolTable_Offset(u1DecId, u4InputKey, i4Value, i4Vol100 ,i4VolLimit, i4ChOffset, TRUE);
        }
    }

    return 0;
}

INT32 DrvCust_AQ_Get_SVT_DSW(AUD_DrvCust_Qry_T* prQryVol, UINT32 u4InputKey, UINT32 u4VolTbIdx)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmSvtDsw rSvtDsw_Data;
    INT32* pi1Tmp;
    INT32 i4Value, i4Vol100, i4VolLimit, i4ChOffset;
    UINT8 u1DecId = AUD_DEC_MAIN;
    AQDataMmSws rGetSwsData;    

    if (prQryVol!=NULL)
    {
        u1DecId = (UINT8)prQryVol->u4DecId;
    }       
    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_SVT_DSW_MAX, u4InputKey, _ar_MmSvtDswTbl_Key);
    u4Size = sizeof(rSvtDsw_Data); 
    vAprocAqData_Read(MM_SVT_DSW_OFFSET+u4Idx*u4Size, (UINT8*)&rSvtDsw_Data, u4Size);
    pi1Tmp = (INT32*)&rSvtDsw_Data;
    
    if (u4VolTbIdx == AQ_NOT_SPECIFIC) /* Just query table */
    {
        AQ_Dump_Table(pi1Tmp, u4Size);
    }
    else
    {
        prQryVol->u4ReturnVal = AQ_NOT_SPECIFIC;  /*default is invalid value, aud_dsp_cfg.c will check range*/
        if (u4VolTbIdx <= 100)
        {
            /*data in SONY AQ table is dB (e.x. -119.5 dB, SONY will put -1195 in AQ table)*/
            i4Value = pi1Tmp[u4VolTbIdx];  
#ifdef CHANGE_ENDIAN /*MSB, LSB*/
            i4Value = ((i4Value>>24)&0xFF) | ((i4Value>>16)&0xFF)<<8 | ((i4Value>>8)&0xFF)<<16 | (i4Value&0xFF)<<24;
#endif
            aq_printf("u4VolTbIdx=%d, pi1Tmp=0x%x, i4Value=0x%x(%d)\n", u4VolTbIdx, pi1Tmp[u4VolTbIdx], i4Value,i4Value);

            DrvCust_AQ_Get_SWS(&rGetSwsData, u4InputKey, AQ_QRY_ANY_IDX);
#ifdef AQ_SELF_TEST //For Test Only
            rSvtDsw_Data.m_MmDswLimitOffset = 6;
            rGetSwsData.m_MmDswWonda = 130;
#endif              
            i4VolLimit = rSvtDsw_Data.m_MmDswLimitOffset * 10; //Other items are 0.1 dB unit, this item is 0~6 dB, so * 10
            i4Vol100 = rSvtDsw_Data.m_MmDswVol100;
            i4ChOffset = rGetSwsData.m_MmDswWonda-128;
            prQryVol->u4ReturnVal = AQ_VolTable_Offset(u1DecId, u4InputKey, i4Value, i4Vol100 ,i4VolLimit, i4ChOffset, TRUE);
        }
    }

    return 0;

}

INT32 DrvCust_AQ_Get_SVT_BT(AUD_DrvCust_Qry_T* prQryVol, UINT32 u4InputKey, UINT32 u4VolTbIdx)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmSvtBt rSvtBt_Data;
    INT32* pi1Tmp;
    INT32 i4Value, i4Vol100, i4VolLimit, i4ChOffset;
    UINT8 u1DecId = AUD_DEC_MAIN;
    AQDataMmSmt rGetSmtData;  
    AQDataMmAct rGetActData;      

    if (prQryVol!=NULL)
    {
        u1DecId = (UINT8)prQryVol->u4DecId;
    }       
    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_SVT_BT_MAX, u4InputKey, _ar_MmSvtBtTbl_Key);
    u4Size = sizeof(rSvtBt_Data); 
    vAprocAqData_Read(MM_SVT_BT_OFFSET+u4Idx*u4Size, (UINT8*)&rSvtBt_Data, u4Size);
    pi1Tmp = (INT32*)&rSvtBt_Data;
    
    if (u4VolTbIdx == AQ_NOT_SPECIFIC) /* Just query table */
    {
        AQ_Dump_Table(pi1Tmp, u4Size);
    }
    else
    {
        prQryVol->u4ReturnVal = AQ_NOT_SPECIFIC;  /*default is invalid value, aud_dsp_cfg.c will check range*/
        if (u4VolTbIdx <= 100)
        {
            /*data in SONY AQ table is dB (e.x. -119.5 dB, SONY will put -1195 in AQ table)*/
            i4Value = pi1Tmp[u4VolTbIdx];  
#ifdef CHANGE_ENDIAN /*MSB, LSB*/
            i4Value = ((i4Value>>24)&0xFF) | ((i4Value>>16)&0xFF)<<8 | ((i4Value>>8)&0xFF)<<16 | (i4Value&0xFF)<<24;
#endif
            aq_printf("u4VolTbIdx=%d, pi1Tmp=0x%x, i4Value=0x%x(%d)\n", u4VolTbIdx, pi1Tmp[u4VolTbIdx], i4Value,i4Value);

            DrvCust_AQ_Get_SMT(&rGetSmtData, u4InputKey, AQ_QRY_ANY_IDX);
            DrvCust_AQ_Get_ACT(&rGetActData, u4InputKey, AQ_QRY_ANY_IDX);            
#ifdef AQ_SELF_TEST //For Test Only
            rSvtBt_Data.m_MmBtLimitOffset = 6;
            rGetActData.m_MmMixAtt = 240;
            rGetSmtData.m_MmInputAtt = 30;
#endif              
            /*
            offset_gain for Bluetoorh = CODEC_OFFSET_GAIN + UI_OFFSET_GAIN + ATT_COMPENSATION
            ATT_COMPENSATION = MM_INPUT_ATT  * 0.5 + MM_MIX_ATT * 0.1 [dB]
            */
            i4VolLimit = rSvtBt_Data.m_MmBtLimitOffset * 10; //Other items are 0.1 dB unit, this item is 0~6 dB, so * 10
            i4Vol100 = rSvtBt_Data.m_MmBtVol100;
            i4ChOffset = (rGetSmtData.m_MmInputAtt*5) + (rGetActData.m_MmMixAtt*1);
            prQryVol->u4ReturnVal = AQ_VolTable_Offset(u1DecId, u4InputKey, i4Value, i4Vol100 ,i4VolLimit, i4ChOffset, TRUE);
        }
    }

    return 0;

}
#endif // CC_AUD_SAKURA_RENDER

INT32 DrvCust_AQ_Get_DRC(UINT32 u4InputKey)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmDrct rDrcData;

    UINT32 j;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_DRCT_MAX, u4InputKey, _ar_MmDrctTbl_Key);
    u4Size = sizeof(AQDataMmDrct); 
    vAprocAqData_Read(MM_DRCT_OFFSET+u4Idx*u4Size, (UINT8*)&rDrcData, u4Size);

    // Write code for apply data here ....
    pu1Tmp = (UINT8*)&rDrcData;
    for (j=0; j<u4Size; j++)
    {
        if (j%16 == 0)
        {
            aq_printf("\n");
        }
        aq_printf ("0x%02x ", pu1Tmp[j]);
    }

    return 0;
}

#ifdef CC_AUD_SAKURA_RENDER
INT32 DrvCust_AQ_Get_LIMT(AQDataMmLimt* pGetLimtData, UINT32 u4InputKey, UINT32 u4Type)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmLimt rLimtData;

    UINT32 j;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_LIMT_MAX, u4InputKey, _ar_MmLimtTbl_Key);
    u4Size = sizeof(rLimtData); 
    vAprocAqData_Read(MM_LIMT_OFFSET+u4Idx*u4Size, (UINT8*)&rLimtData, u4Size);

    // Write code for apply data here ....
    if (u4Type == AQ_NOT_SPECIFIC)
    {
        pu1Tmp = (UINT8*)&rLimtData;
        for (j=0; j<u4Size; j++)
        {
            if (j%16 == 0)
            {
                aq_printf("\n");
            }
            aq_printf ("0x%02x ", pu1Tmp[j]);
        }
    }
    else
    {
        if (pGetLimtData!=NULL)
        {
            x_memcpy((VOID*)VIRTUAL((UINT32)pGetLimtData), (VOID*)VIRTUAL((UINT32)&rLimtData), sizeof(AQDataMmLimt));
        }
    }

    return 0;
}
#else /*CC_AUD_SAKURA_RENDER*/
INT32 DrvCust_AQ_Get_LIMT(UINT32 u4InputKey)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmLimt rLimtData;

    UINT32 j;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_LIMT_MAX, u4InputKey, _ar_MmLimtTbl_Key);
    u4Size = sizeof(rLimtData); 
    vAprocAqData_Read(MM_LIMT_OFFSET+u4Idx*u4Size, (UINT8*)&rLimtData, u4Size);

    // Write code for apply data here ....
    pu1Tmp = (UINT8*)&rLimtData;
    for (j=0; j<u4Size; j++)
    {
        if (j%16 == 0)
        {
            aq_printf("\n");
        }
        aq_printf ("0x%02x ", pu1Tmp[j]);
    }

    return 0;
}
#endif /*CC_AUD_SAKURA_RENDER*/

INT32 DrvCust_AQ_Get_SMT(AQDataMmSmt* pGetSmtData, UINT32 u4InputKey, UINT32 u4Type)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmSmt rSmtData;

    UINT32 j;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_SMT_MAX, u4InputKey, _ar_MmSmtTbl_Key);
    u4Size = sizeof(AQDataMmSmt); 
    vAprocAqData_Read(MM_SMT_OFFSET+u4Idx*u4Size, (UINT8*)&rSmtData, u4Size);

    if (u4Type == AQ_NOT_SPECIFIC)
    {
        pu1Tmp = (UINT8*)&rSmtData;
        for (j=0; j<u4Size; j++)
        {
            if (j%16 == 0)
            {
                aq_printf("\n");
            }
            aq_printf ("0x%02x ", pu1Tmp[j]);
        }
    }
    else
    {
        if (pGetSmtData!=NULL)
        {
            x_memcpy((VOID*)VIRTUAL((UINT32)pGetSmtData), (VOID*)VIRTUAL((UINT32)&rSmtData), sizeof(AQDataMmSmt));
        }
    }


    return 0;
}

INT32 DrvCust_AQ_Get_SPEQ(UINT32 u4InputKey)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmSpeq rSpeqData;

    UINT32 j;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_SPEQ_MAX, u4InputKey, _ar_MmSpeqTbl_Key);
    u4Size = sizeof(AQDataMmSpeq); 
    vAprocAqData_Read(MM_SPEQ_OFFSET+u4Idx*u4Size, (UINT8*)&rSpeqData, u4Size);

    // Write code for apply data here ....
    pu1Tmp = (UINT8*)&rSpeqData;
    for (j=0; j<u4Size; j++)
    {
        if (j%16 == 0)
        {
            aq_printf("\n");
        }
        aq_printf ("0x%02x ", pu1Tmp[j]);
    }

    return 0;
}

#ifdef CC_AUD_SAKURA_RENDER
INT32 DrvCust_AQ_Get_SLT(AQDataMmSlt* pGetSltData, UINT32 u4InputKey, UINT32 u4Type)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmSlt rSltData;

    UINT32 j;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_SLT_MAX, u4InputKey, _ar_MmSltTbl_Key);
    u4Size = sizeof(rSltData); 
    vAprocAqData_Read(MM_SLT_OFFSET+u4Idx*u4Size, (UINT8*)&rSltData, u4Size);

    // Write code for apply data here ....
    if (u4Type == AQ_NOT_SPECIFIC)
    {
        pu1Tmp = (UINT8*)&rSltData;
        for (j=0; j<u4Size; j++)
        {
            if (j%16 == 0)
            {
                aq_printf("\n");
            }
            aq_printf ("0x%02x ", pu1Tmp[j]);
        }
    }
    else
    {
        if (pGetSltData!=NULL)
        {
            x_memcpy((VOID*)VIRTUAL((UINT32)pGetSltData), (VOID*)VIRTUAL((UINT32)&rSltData), sizeof(AQDataMmSlt));
        }
    }

    return 0;
}
#else /*CC_AUD_SAKURA_RENDER*/
INT32 DrvCust_AQ_Get_SLT(UINT32 u4InputKey)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmSlt rSltData;

    UINT32 j;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_SLT_MAX, u4InputKey, _ar_MmSltTbl_Key);
    u4Size = sizeof(rSltData); 
    vAprocAqData_Read(MM_SLT_OFFSET+u4Idx*u4Size, (UINT8*)&rSltData, u4Size);

    // Write code for apply data here ....
    pu1Tmp = (UINT8*)&rSltData;
    for (j=0; j<u4Size; j++)
    {
        if (j%16 == 0)
        {
            aq_printf("\n");
        }
        aq_printf ("0x%02x ", pu1Tmp[j]);
    }

    return 0;
}
#endif /*CC_AUD_SAKURA_RENDER*/

INT32 DrvCust_AQ_Get_SWS(AQDataMmSws* pGetSwsData, UINT32 u4InputKey, UINT32 u4Type)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmSws rSwsData;

    UINT32 j;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_SWS_MAX, u4InputKey, _ar_MmSwsTbl_Key);
    u4Size = sizeof(rSwsData); 
    vAprocAqData_Read(MM_SWS_OFFSET+u4Idx*u4Size, (UINT8*)&rSwsData, u4Size);

    if (u4Type == AQ_NOT_SPECIFIC)
    {
        pu1Tmp = (UINT8*)&rSwsData;
        for (j=0; j<u4Size; j++)
        {
            if (j%16 == 0)
            {
                aq_printf("\n");
            }
            aq_printf ("0x%02x ", pu1Tmp[j]);
        }
    }
    else
    {
        if (pGetSwsData!=NULL)
        {
            x_memcpy((VOID*)VIRTUAL((UINT32)pGetSwsData), (VOID*)VIRTUAL((UINT32)&rSwsData), sizeof(AQDataMmSws));
        }
    }


    return 0;
}

INT32 DrvCust_AQ_Get_LOUDT(UINT32 u4InputKey)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmLoudt rLoudtData;

    UINT32 j;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_LOUDT_MAX, u4InputKey, _ar_MmLoudtTbl_Key);
    u4Size = sizeof(rLoudtData); 
    vAprocAqData_Read(MM_LOUDT_OFFSET+u4Idx*u4Size, (UINT8*)&rLoudtData, u4Size);

    // Write code for apply data here ....
    pu1Tmp = (UINT8*)&rLoudtData;
    for (j=0; j<u4Size; j++)
    {
        if (j%16 == 0)
        {
            aq_printf("\n");
        }
        aq_printf ("0x%02x ", pu1Tmp[j]);
    }

    return 0;
}

#ifdef CC_AUD_SAKURA_RENDER
INT32 DrvCust_AQ_Get_FIR(AQDataMmFir* pGetFirData, UINT32* pGetFirIdx, UINT32 u4InputKey, UINT32 u4Type)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmFir rFirData;
    INT32* pi1Tmp;
    
    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_FIR_MAX, u4InputKey, _ar_MmFirTbl_Key);
    u4Size = sizeof(rFirData); 
    vAprocAqData_Read(MM_FIR_OFFSET+u4Idx*u4Size, (UINT8*)&rFirData, u4Size);
    
    if (u4Type == AQ_NOT_SPECIFIC) /* Just query table */
    {
        pi1Tmp = (UINT32*)&rFirData;
        AQ_Dump_Table(pi1Tmp, u4Size);
    }
    else
    {
        if (pGetFirData != NULL)
        {
            x_memcpy((VOID*)VIRTUAL((UINT32)pGetFirData), (VOID*)VIRTUAL((UINT32)&rFirData), sizeof(AQDataMmFir));
        }
        
        if (pGetFirIdx != NULL)
        {
            *pGetFirIdx = u4Idx;
        }
    }
    
    return 0;
}
#else
INT32 DrvCust_AQ_Get_FIR(UINT32 u4InputKey)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmFir rFirData;

    UINT32 j;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_FIR_MAX, u4InputKey, _ar_MmFirTbl_Key);
    u4Size = sizeof(rFirData); 
    vAprocAqData_Read(MM_FIR_OFFSET+u4Idx*u4Size, (UINT8*)&rFirData, u4Size);

    // Write code for apply data here ....
    pu1Tmp = (UINT8*)&rFirData;
    for (j=0; j<u4Size; j++)
    {
        if (j%16 == 0)
        {
            aq_printf("\n");
        }
        aq_printf ("0x%02x ", pu1Tmp[j]);
    }

    return 0;
}
#endif /* CC_AUD_SAKURA_RENDER */

#ifdef CC_AUD_SAKURA_RENDER
INT32 DrvCust_AQ_Get_DLY(AQDataMmAuDly* pDlyData, UINT32* pGetDlyIdx, UINT32 u4InputKey, UINT32 u4Type)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmAuDly rDlyData;
    UINT32 u4MtkDrvDly;
    UINT8 u1DecId;
    
    UINT32 j;
    UINT8* pu1Tmp;
    
    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_AU_DLY_MAX, u4InputKey, _ar_MmAuDlyTbl_Key);
    u4Size = sizeof(rDlyData); 
    vAprocAqData_Read(MM_AU_DLY_OFFSET+u4Idx*u4Size, (UINT8*)&rDlyData, u4Size);
    
    if (u4Type == AQ_NOT_SPECIFIC) /* Just query table */
    {
        pu1Tmp = (UINT8*)&rDlyData;
        AQ_Dump_Byte(pu1Tmp, u4Size);
        
        printf("\n === AQ === \n");
        printf("  m_MmMainAdj   = %d \n", rDlyData.m_MmMainAdj);
        printf("  m_MmSpAdj     = %d \n", rDlyData.m_MmSpAdj);
        printf("  m_MmHoloswAdj = %d \n", rDlyData.m_MmHoloswAdj);
        printf("  m_MmSpdifAdj  = %d \n", rDlyData.m_MmSpdifAdj);
        printf("  m_MmWswDly    = %d \n", rDlyData.m_MmWswDly);
        printf("  m_MmBtDly     = %d \n", rDlyData.m_MmBtDly);
    }
    else    // Set Delay to SPK/HP/SPDIF/SCART, both main and diff
    {
        if (pDlyData != NULL)
        {
            x_memcpy((VOID*)VIRTUAL((UINT32)pDlyData), (VOID*)VIRTUAL((UINT32)&rDlyData), sizeof(AQDataMmAuDly));
        }
        
        if (pGetDlyIdx != NULL)
        {
            *pGetDlyIdx = u4Idx;
        }
        
    }
    
    return 0;
}
#else
                        //Idx 0 ~ 24, total 25 items.
                        //UI  -12 -11 -10 -9 -8 -7 -6 -5 -4 -3 -2 -1  0  1 2  3 4  5 6  7  8 9  10  11 12
                        //ms   0   0   0  0  0  0  0  0  0  0  0  0  0  1.33ms   .............       16 ms
                        //bank 0                                         1       .............       12 banks
UINT32 au4U_SW_DLY_ADJ[25] =  {  0,   0,   0, 0,  0, 0,  0, 0,  0, 0, 0,  0, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12};
                        //ms   16ms .....                          1.33
UINT32 au4L_SW_DLY_ADJ[25] =  {  12,  11,  10, 9, 8, 7,  7, 5,  4, 3, 2,  1, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0,  0,  0,  0};                            
INT32 DrvCust_AQ_Get_DLY(AUD_DLY_INFO_T* rAudDlyInfo, UINT32 u4InputKey, BOOL fgSetValue)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmAuDly rDlyData;
    UINT32 u4MtkDrvDly;
    UINT8 u1DecId;
    UINT32 u4Tmp; 
    UINT32 u4USwAdj=0;
    UINT32 u4LSwAdj=0;
    AQDataMmRsv rRsvData; //Debug request from SONY

    UINT32 j;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_AU_DLY_MAX, u4InputKey, _ar_MmAuDlyTbl_Key);
    u4Size = sizeof(rDlyData); 
    vAprocAqData_Read(MM_AU_DLY_OFFSET+u4Idx*u4Size, (UINT8*)&rDlyData, u4Size);

    if (!fgSetValue) //for CLI Query only 
    {
        aq_printf("\n === In the AQ data ===\n");
        pu1Tmp = (UINT8*)&rDlyData;
        for (j=0; j<u4Size; j++)
        {
            if (j%16 == 0)
            {
                aq_printf("\n");
            }
            aq_printf ("0x%02x ", pu1Tmp[j]);
        }
        aq_printf("\n=== AQ ===\n");        
        aq_printf("m_MmMainAdj = 0x%x\n", rDlyData.m_MmMainAdj);
        aq_printf("m_MmSpAdj = 0x%x\n", rDlyData.m_MmSpAdj);
        aq_printf("m_MmHoloswAdj = 0x%x\n", rDlyData.m_MmHoloswAdj);
        aq_printf("m_MmSpdifAdj = 0x%x\n", rDlyData.m_MmSpdifAdj);
        aq_printf("m_MmWswDly = 0x%x\n", rDlyData.m_MmWswDly);
        aq_printf("m_MmBtDly = 0x%x\n", rDlyData.m_MmBtDly);
        aq_printf(" === APROC ===\n");
        aq_printf(" 1. Main Delay\n");        
        aq_printf("u4DrvDly = %d ms\n", rAudDlySetValInfo.u4DrvDly);
        aq_printf("u4BeDly = %d ms\n", rAudDlySetValInfo.u4BeDly);
        aq_printf("i4MainAdj = %d ms\n", rAudDlySetValInfo.i4MainAdj);
        aq_printf("u4MainDelay = %d bank\n", rAudDlySetValInfo.u4MainDelay);
        aq_printf(" 2. SP/ASP Diff Delay\n");
        aq_printf("u4SpAdj = %d bank\n", rAudDlySetValInfo.u4SpAdj);
        aq_printf("u4SubWooferSync = %d (0..24 from UI)\n", rAudDlySetValInfo.u4SubWooferSync);        
        aq_printf("u4USwDlyAdj = %d banks\n", rAudDlySetValInfo.u4USwDlyAdj);
        aq_printf("u4LSwDlyAdj = %d banks\n", rAudDlySetValInfo.u4LSwDlyAdj);        
        aq_printf("u4SpDiffDelay = %d banks\n", rAudDlySetValInfo.u4SpDiffDelay);        
        aq_printf("u4AssistSpDiffDelay = %d banks\n", rAudDlySetValInfo.u4AssistSpDiffDelay);
        aq_printf(" 3. HP Diff Delay\n");        
        aq_printf("u4HoLoSwAdj = %d ms\n", rAudDlySetValInfo.u4HoLoSwAdj);
        aq_printf("u4HpDiffDelay = %d banks\n", rAudDlySetValInfo.u4HpDiffDelay);
        aq_printf(" 4. SPDIF Diff Delay\n");                
        aq_printf("u4Spdif_Adj = %d ms\n", rAudDlySetValInfo.u4Spdif_Adj);
        aq_printf("u4SpdifDiffDelay = %d banks\n", rAudDlySetValInfo.u4SpdifDiffDelay);
        aq_printf(" 5. SPDIF Raw Delay\n");                
        aq_printf("u4SpdifRawDelay = %d frames\n", rAudDlySetValInfo.u4SpdifRawDelay);
        aq_printf(" === ASM ===\n");
        aq_printf("APROC_REG_MDELAY_SNPT= 0x%x\n", u4AprocReg_Read(APROC_ASM_ADDR(APROC_ASM_ID_POSTPROC_4, APROC_REG_MDELAY_SNPT)));
        aq_printf("APROC_REG_DELAY_SP= 0x%x\n", u4AprocReg_Read(APROC_ASM_ADDR(APROC_ASM_ID_POSTPROC_4, APROC_REG_DELAY_SP)));
        aq_printf("APROC_REG_DELAY_HP= 0x%x\n", u4AprocReg_Read(APROC_ASM_ADDR(APROC_ASM_ID_POSTPROC_4, APROC_REG_DELAY_HP)));
        aq_printf("APROC_REG_DELAY_SPDIF_PCM= 0x%x\n", u4AprocReg_Read(APROC_ASM_ADDR(APROC_ASM_ID_POSTPROC_4, APROC_REG_DELAY_SPDIF_PCM)));
        aq_printf("APROC_REG_DELAY_SP_LSRS= 0x%x\n", u4AprocReg_Read(APROC_ASM_ADDR(APROC_ASM_ID_POSTPROC_4, APROC_REG_DELAY_SP_LSRS)));
        aq_printf("APROC_REG_DELAY_AUDIO_OUT= 0x%x\n", u4AprocReg_Read(APROC_ASM_ADDR(APROC_ASM_ID_POSTPROC_4, APROC_REG_DELAY_AUDIO_OUT)));
        aq_printf("APROC_REG_MDELAY_SPDIF_PCM= 0x%x\n", u4AprocReg_Read(APROC_ASM_ADDR(APROC_ASM_ID_POSTPROC_4, APROC_REG_MDELAY_SPDIF_PCM)));
        aq_printf("APROC_REG_AENV_IEC_RAWDELAY= 0x%x\n", u4AprocReg_Read(APROC_ASM_ADDR(APROC_ASM_ID_AENV_1, APROC_REG_AENV_IEC_RAWDELAY)));
    }
    else    // Set Delay to SPK/HP/SPDIF/SCART, both main and diff
    {
        u1DecId = rAudDlyInfo->u1DecId;
        u4MtkDrvDly = rAudDlyInfo->u4OriDelayMs;       

        //1. [Main Delay]
        u4Tmp = 0;
        u4Tmp += u4MtkDrvDly;               // "The current mechanism" Delay setting (ms) 
        u4Tmp += _gu4BeDelay;               // 2k Ex-FRC Video Delay(ms)
        rAudDlySetValInfo.i4MainAdj = (INT32)(rDlyData.m_MmMainAdj) - 128;
        rAudDlySetValInfo.u4BeDly = _gu4BeDelay;
        rAudDlySetValInfo.u4DrvDly = u4MtkDrvDly;        
        if (((INT32)u4Tmp + rAudDlySetValInfo.i4MainAdj) <= 0)
        {
            u4Tmp = 0;
        }
        else
        {
            // MAIN_ADJ from AQ, (0..255) means (-128..127ms)
            u4Tmp = (INT32)u4Tmp + rAudDlySetValInfo.i4MainAdj;
        }
        aq_printf("Sakura_Dly!! u4MtkDrvDly=%d ms, _gu4BeDelay=%d ms\n", rAudDlyInfo->u4OriDelayMs, _gu4BeDelay);
        /* Set it to APROC 
         Delay here is in ms unit. Need to change X ms to 64bank unit.
         64/48 = 1.3 ms, so we need X/1.3 */
        u4Tmp = (u4Tmp*100+65)/130;
        vAprocReg_Write (APROC_ASM_ADDR(APROC_ASM_ID_POSTPROC_4, APROC_REG_MDELAY_SNPT), u4Tmp);
        vAprocReg_Write (APROC_ASM_ADDR(APROC_ASM_ID_POSTPROC_4, APROC_REG_DELAY_HP), u4Tmp);
        vAprocReg_Write (APROC_ASM_ADDR(APROC_ASM_ID_POSTPROC_4, APROC_REG_MDELAY_SPDIF_PCM), u4Tmp);
        rAudDlySetValInfo.u4MainDelay = u4Tmp;        

        //2. [Main SP Diff Delay =  AQ_Data: "SP_ADJ"(ms)+ U_SW_DLY_ADJ]
        // calculate U_SW_DLY_ADJ
        u4Tmp = gSoundSetting.i1SubwooferDelay;
        rAudDlySetValInfo.u4SubWooferSync = gSoundSetting.i1SubwooferDelay;
        if ((u4Tmp>=0) &&(u4Tmp<=24))
        {
            u4USwAdj = au4U_SW_DLY_ADJ[u4Tmp]; //This is alreay in bank units.
        }
        rAudDlySetValInfo.u4USwDlyAdj = u4USwAdj; //bank unit.
        //SP_ADJ is in ms unit, change to bank.
        u4Tmp =  (rDlyData.m_MmSpAdj*100+65)/130;
        rAudDlySetValInfo.u4SpAdj = u4Tmp;
        u4Tmp = u4Tmp + u4USwAdj; // This is in bank unit
        vAprocReg_Write (APROC_ASM_ADDR(APROC_ASM_ID_POSTPROC_4, APROC_REG_DELAY_SP), u4Tmp);                        
        rAudDlySetValInfo.u4SpDiffDelay = u4Tmp;

        //3. [Assist SP Diff Delay =  AQ_Data: "SP_ADJ"(ms)+ L_SW_DLY_ADJ]
        // calculate L_SW_DLY_ADJ
        u4Tmp = gSoundSetting.i1SubwooferDelay;
        if ((u4Tmp>=0) &&(u4Tmp<=24))
        {
            u4LSwAdj = au4L_SW_DLY_ADJ[u4Tmp]; //This is alreay in bank units.
        }
        rAudDlySetValInfo.u4LSwDlyAdj = u4LSwAdj;
        //SP_ADJ is in ms unit, change to bank
        u4Tmp =  (rDlyData.m_MmSpAdj*100+65)/130;
        u4Tmp = u4Tmp + u4LSwAdj; // This is in bank unit
        vAprocReg_Write (APROC_ASM_ADDR(APROC_ASM_ID_POSTPROC_4, APROC_REG_DELAY_SP_LSRS), u4Tmp);        
        rAudDlySetValInfo.u4AssistSpDiffDelay = u4Tmp;

        //4. [HP Diff Delay = AQ_Data: "HOLOSW_ADJ"(ms) + L_SW_DLY_ADJ]
        u4Tmp = rDlyData.m_MmHoloswAdj;
        u4Tmp = (u4Tmp*100+65)/130;        
        rAudDlySetValInfo.u4HoLoSwAdj = u4Tmp;
        u4Tmp = u4LSwAdj + u4Tmp;
        vAprocReg_Write (APROC_ASM_ADDR(APROC_ASM_ID_POSTPROC_4, APROC_REG_DELAY_AUDIO_OUT), u4Tmp);
        rAudDlySetValInfo.u4HpDiffDelay = u4Tmp;

        //5. SPDIF PCM Diff Delay = AQ_Data: "SPDIF_ADJ"(ms)
        u4Tmp = rDlyData.m_MmSpdifAdj;
        rAudDlySetValInfo.u4Spdif_Adj = u4Tmp;
        u4Tmp = (u4Tmp*100+65)/130;        
        vAprocReg_Write (APROC_ASM_ADDR(APROC_ASM_ID_POSTPROC_4, APROC_REG_DELAY_SPDIF_PCM), u4Tmp);
        rAudDlySetValInfo.u4SpdifDiffDelay = u4Tmp;        

        // Todo : Raw Delay should consider decoder type!
        u4Tmp = rAudDlySetValInfo.u4MainDelay * APROC_POSTBUF_BLOCK_SIZE;
        u4Tmp = u4Tmp/1536;  //Fix this (only for AC3 is ok)
        vAprocReg_Write (APROC_ASM_ADDR (APROC_ASM_ID_AENV_1, APROC_REG_AENV_IEC_RAWDELAY), u4Tmp);
        rAudDlySetValInfo.u4SpdifRawDelay = u4Tmp; //fix this !
        

        // Todo : SCART Delay not exist
        
        // Trigger Routine
        _vAprocSetRoutine(APROC_ROUTINE_ID_DR_SP_PATH);
        _vAprocSetRoutine(APROC_ROUTINE_ID_DR_HP_PATH);
        _vAprocSetRoutine(APROC_ROUTINE_ID_DR_SPDIF_PCM_PATH);    

        // Debug request from SONY
        // use Rsv columns 
        rRsvData.m_MmAudioRsv3 = rAudDlySetValInfo.u4MainDelay;   //Main Delay Setting
        rRsvData.m_MmAudioRsv4 = rAudDlySetValInfo.u4SpDiffDelay; //Main SP Diff Delay Setting
        rRsvData.m_MmAudioRsv5 = rAudDlySetValInfo.u4HpDiffDelay; //HP Diff Delay Setting        
        vAprocAqData_Write(MM_RSV_OFFSET, (UINT8*)&rRsvData, u4Size);
        
    }
    
    return 0;
}
#endif /* CC_AUD_SAKURA_RENDER */

#ifdef CC_AUD_SAKURA_RENDER
INT32 DrvCust_AQ_Get_ADCT(AQDataMmAdct* pGetAdctData, UINT32 u4InputKey, UINT32 u4Type)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmAdct rAdctData;

    UINT32 j;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_ADCT_MAX, u4InputKey, _ar_MmAdctTbl_Key);
    u4Size = sizeof(rAdctData); 
    vAprocAqData_Read(MM_ADCT_OFFSET+u4Idx*u4Size, (UINT8*)&rAdctData, u4Size);

    // Write code for apply data here ....
    if(u4Type == AQ_NOT_SPECIFIC)
    {
        pu1Tmp = (UINT8*)&rAdctData;
        for (j=0; j<u4Size; j++)
        {
            if (j%16 == 0)
            {
                aq_printf("\n");
            }
            aq_printf ("0x%02x ", pu1Tmp[j]);
        }
    }
    else
    {
        if (pGetAdctData!=NULL)
        {
            x_memcpy((VOID*)VIRTUAL((UINT32)pGetAdctData), (VOID*)VIRTUAL((UINT32)&rAdctData), sizeof(AQDataMmAdct));
        }
    }
    return 0;
}
#else // CC_AUD_SAKURA_RENDER
INT32 DrvCust_AQ_Get_ADCT(UINT32 u4InputKey)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmAdct rAdctData;

    UINT32 j;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_ADCT_MAX, u4InputKey, _ar_MmAdctTbl_Key);
    u4Size = sizeof(rAdctData); 
    vAprocAqData_Read(MM_ADCT_OFFSET+u4Idx*u4Size, (UINT8*)&rAdctData, u4Size);

    // Write code for apply data here ....
    pu1Tmp = (UINT8*)&rAdctData;
    for (j=0; j<u4Size; j++)
    {
        if (j%16 == 0)
        {
            aq_printf("\n");
        }
        aq_printf ("0x%02x ", pu1Tmp[j]);
    }

    return 0;
}
#endif // CC_AUD_SAKURA_RENDER


INT32 DrvCust_AQ_Get_ACT(AQDataMmAct* pGetActData, UINT32 u4InputKey, UINT32 u4Type)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmAct rActData;

    UINT32 j;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_ACT_MAX, u4InputKey, _ar_MmActTbl_Key);
    u4Size = sizeof(rActData); 
    vAprocAqData_Read(MM_ACT_OFFSET+u4Idx*u4Size, (UINT8*)&rActData, u4Size);

    if (u4Type == AQ_NOT_SPECIFIC)
    {
        pu1Tmp = (UINT8*)&rActData;
        for (j=0; j<u4Size; j++)
        {
            if (j%16 == 0)
            {
                aq_printf("\n");
            }
            aq_printf ("0x%02x ", pu1Tmp[j]);
        }
    }
    else
    {
        if (pGetActData!=NULL)
        {
            x_memcpy((VOID*)VIRTUAL((UINT32)pGetActData), (VOID*)VIRTUAL((UINT32)&rActData), sizeof(AQDataMmAct));
        }
    }
    return 0;
}

extern void AUD_DspSpeakerOutputConfig(UINT8 u1DecIndex, UINT8 u1SpkCfg);
extern UINT8 AUD_DspGetSpeakerOutputConfig(UINT8 u1DecIndex);
INT32 DrvCust_AQ_Get_ADT(UINT32 u4InputKey, BOOL fgExecute)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmAdt rAdtData;
    AQDataMmRsv rRsvData;
    AQDataMmAct rActData;
    UINT32 u4ADTMode = 0;
    UINT32 u4Data0 = AUD_CH_FRONT_LEFT;
    UINT32 u4Data1 = AUD_CH_FRONT_LEFT;
    UINT32 u4Data2 = AUD_CH_FRONT_LEFT;
    
    UINT32 j;
    UINT8* pu1Tmp;
    static UINT32 u4OriSpkSet = AQ_SPKSEL_IS_ORIGNAL;
    static UINT32 u4OriSpkCfg[2] = {AQ_SPKCFG_IS_ORIGNAL, AQ_SPKCFG_IS_ORIGNAL};
    BOOL fgSetDownmixToOff = false;

    //Extra Block Start-----
    //To read Aact table in this function to check DTS certification mode also
    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_ACT_MAX, u4InputKey, _ar_MmActTbl_Key);
    u4Size = sizeof(rActData); 
    vAprocAqData_Read(MM_ACT_OFFSET+u4Idx*u4Size, (UINT8*)&rActData, u4Size);    

    if((rActData.m_MmCertMode == 1) && (u4OriSpkSet==AQ_SPKSEL_IS_ORIGNAL))
    {
        u4OriSpkSet = u4AprocReg_Read (APROC_ASM_ADDR(APROC_ASM_ID_POSTPROC_D, APROC_REG_SP_OUT_SEL));
        vAprocReg_Write(APROC_ASM_ADDR(APROC_ASM_ID_POSTPROC_D, APROC_REG_SP_OUT_SEL), APROC_SPK_OUTPUT_DTS);
    }
    else if((rActData.m_MmCertMode==0) && (u4OriSpkSet!=AQ_SPKSEL_IS_ORIGNAL))
    {
        vAprocReg_Write(APROC_ASM_ADDR(APROC_ASM_ID_POSTPROC_D, APROC_REG_SP_OUT_SEL), u4OriSpkSet);   
        u4OriSpkSet = AQ_SPKSEL_IS_ORIGNAL;
    }
#ifdef CC_AUD_SAKURA_RENDER
    if(rActData.m_MmCertMode == 1){
        vAprocReg_Write(APROC_ASM_ADDR(APROC_ASM_ID_POSTPROC_D, APROC_REG_SP_OUT_SEL), APROC_SPK_OUTPUT_DTS);
    }
#endif/* CC_AUD_SAKURA_RENDER*/    
    //----- End of Extra Block

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_ADT_MAX, u4InputKey, _ar_MmAdtTbl_Key);
    u4Size = sizeof(rAdtData); 
    vAprocAqData_Read(MM_ADT_OFFSET+u4Idx*u4Size, (UINT8*)&rAdtData, u4Size);

    u4Size = sizeof(rRsvData); 
    vAprocAqData_Read(MM_RSV_OFFSET, (UINT8*)&rRsvData, u4Size);
    u4ADTMode = rRsvData.m_MmAudioRsv7;
    
    if (!fgExecute) // Query only
    {
        pu1Tmp = (UINT8*)&rAdtData;
        for (j=0; j<u4Size; j++)
        {
            if (j%16 == 0)
            {
                aq_printf("\n");
            }
            aq_printf ("0x%02x ", pu1Tmp[j]);
        }
    }
    else if (u4ADTMode == AQ_ADT_MODE_ON)
    {
        aq_printf ("ADT Force output is triggered\n ");

        // ------  Check I2S output  ------  
        // Data 0
        if (rAdtData.m_MmForceI2s0OutSel == 0) //SP data
        {
            u4Data0 = AUD_CH_FRONT_LEFT; //Aout buffer 0            
        }
        else if (rAdtData.m_MmForceI2s0OutSel == 1) //Assit SP data
        {
            u4Data0 = AUD_CH_REAR_LEFT; //Aout buffer 1
        }
        else if (rAdtData.m_MmForceI2s0OutSel == 2) //FLFR data
        {
            fgSetDownmixToOff = TRUE;
            u4Data0 = AUD_CH_FRONT_LEFT; //Aout buffer 0
        }
        else if (rAdtData.m_MmForceI2s0OutSel == 3) //LsRs data
        {
            fgSetDownmixToOff = TRUE;
            u4Data0 = AUD_CH_REAR_LEFT; //Aout buffer 1
        }
        else if (rAdtData.m_MmForceI2s0OutSel == 4) //CLFE data
        {
            fgSetDownmixToOff = TRUE;
            u4Data0 = AUD_CH_CENTER; //Aout buffer 2
        }
        else if (rAdtData.m_MmForceI2s0OutSel == 5) // Audio Out
        {
            u4Data0 = AUD_CH_BYPASS_LEFT;  //Aout buffer 5       
        }
        else if (rAdtData.m_MmForceI2s0OutSel == 6) // SPDIF Out
        {
            u4Data0 = AUD_CH_IEC_LEFT;  //Aout buffer 3           
        }
        else if (rAdtData.m_MmForceI2s0OutSel == 7) // SCART Out
        {
            u4Data0 = AUD_CH_CH1314_LEFT;  //Aout buffer 6           
        }
        // Data 1
        if (rAdtData.m_MmForceI2s1OutSel == 0) //ASP data
        {
            u4Data1 = AUD_CH_REAR_LEFT; //Aout buffer 1            
        }
        else if (rAdtData.m_MmForceI2s1OutSel == 1) //SP data
        {
            u4Data1 = AUD_CH_FRONT_LEFT; //Aout buffer 0
        }
        else if (rAdtData.m_MmForceI2s1OutSel == 2) //FLFR data
        {
            fgSetDownmixToOff = TRUE;
            u4Data1 = AUD_CH_FRONT_LEFT; //Aout buffer 0
        }
        else if (rAdtData.m_MmForceI2s1OutSel == 3) //LsRs data
        {
            fgSetDownmixToOff = TRUE;
            u4Data1 = AUD_CH_REAR_LEFT; //Aout buffer 1
        }
        else if (rAdtData.m_MmForceI2s1OutSel == 4) //CLFE data
        {
            fgSetDownmixToOff = TRUE;
            u4Data1 = AUD_CH_CENTER; //Aout buffer 2
        }        
        else if (rAdtData.m_MmForceI2s1OutSel == 5) // Audio Out
        {
            u4Data1 = AUD_CH_BYPASS_LEFT;  //Aout buffer 5       
        }
        else if (rAdtData.m_MmForceI2s1OutSel == 6) // SPDIF Out
        {
            u4Data1 = AUD_CH_IEC_LEFT;  //Aout buffer 3           
        }
        else if (rAdtData.m_MmForceI2s1OutSel == 7) // SCART Out
        {
            u4Data1 = AUD_CH_CH1314_LEFT;  //Aout buffer 6           
        }
        // Data 2
        if (rAdtData.m_MmForceI2s2OutSel == 0) //SP SW data
        {
            u4Data2 = AUD_CH_CENTER; //Aout buffer 2
        }
        else if (rAdtData.m_MmForceI2s2OutSel == 1) //SP data
        {
            u4Data2 = AUD_CH_FRONT_LEFT; //Aout buffer 0
        }
        else if (rAdtData.m_MmForceI2s2OutSel == 2) // ASP Data
        {
            u4Data2 = AUD_CH_REAR_LEFT;  //Aout buffer 1       
        }        
        else if (rAdtData.m_MmForceI2s2OutSel == 3) //FLFR data
        {
            fgSetDownmixToOff = TRUE;
            u4Data1 = AUD_CH_FRONT_LEFT; //Aout buffer 0
        }
        else if (rAdtData.m_MmForceI2s2OutSel == 4) //LsRs data
        {
            fgSetDownmixToOff = TRUE;
            u4Data1 = AUD_CH_REAR_LEFT; //Aout buffer 1
        }        
        else if (rAdtData.m_MmForceI2s2OutSel == 5) // Audio Out
        {
            u4Data2 = AUD_CH_BYPASS_LEFT;  //Aout buffer 5       
        }
        else if (rAdtData.m_MmForceI2s2OutSel == 6) // SPDIF Out
        {
            u4Data2 = AUD_CH_IEC_LEFT;  //Aout buffer 3           
        }
        else if (rAdtData.m_MmForceI2s2OutSel == 7) // SCART Out
        {
            u4Data2 = AUD_CH_CH1314_LEFT;  //Aout buffer 6           
        }

        AUD_AoutPADMux(u4Data0, u4Data1,
                       u4Data2, _grAOutPadCfg.ePadSdata3,
                       _grAOutPadCfg.ePadSdata4, _grAOutPadCfg.ePadSdata5, 0);
        
        // ------  Check SPDIF output  ------  
        if (rAdtData.m_MmForceSpdifOutSel == 0) // SPDIF data        
        {
            u4Data0 = AUD_IEC_PCM_CH_7_8;            
        }
        else if (rAdtData.m_MmForceSpdifOutSel == 1) // SP data
        {
            u4Data0 = AUD_IEC_PCM_CH_L_R;
        }
        else if (rAdtData.m_MmForceSpdifOutSel == 2) // ASP data
        {
            u4Data0 = AUD_IEC_PCM_CH_LS_RS;            
        }
        else if (rAdtData.m_MmForceSpdifOutSel == 3) // FLFR data
        {
            fgSetDownmixToOff = TRUE;
            u4Data0 = AUD_IEC_PCM_CH_L_R; // Buffer 0
        }
        else if (rAdtData.m_MmForceSpdifOutSel == 4) // LsRs data
        {
            fgSetDownmixToOff = TRUE;        
            u4Data0 = AUD_IEC_PCM_CH_LS_RS;  // Buffer 1          
        }
        else if (rAdtData.m_MmForceSpdifOutSel == 5) // CLFE data
        {
            fgSetDownmixToOff = TRUE;        
            u4Data0 = AUD_IEC_PCM_CH_C_SW;  // Buffer 2          
        }
        
        // SPDIF output can't touch aout buffer 5 and 6.
        
        AUD_DspIecChannel((AUD_IEC_CH_T)u4Data0); 

        // ------  Check SCART output  ------          
        if (rAdtData.m_MmForceScartOut == 0) //SCART data
        {
            u4Data0 = AUD_CHL_EXTCH;
        }
        else if (rAdtData.m_MmForceScartOut == 1) //SP data
        {
            u4Data0 = AUD_CHL_L_R;
        }
        else if (rAdtData.m_MmForceScartOut == 2) //ASP data
        {
            u4Data0 = AUD_CHL_LS_RS;
        }
        else if (rAdtData.m_MmForceScartOut == 3) //LR
        {
            fgSetDownmixToOff = TRUE;        
            u4Data0 = AUD_CHL_L_R;
        }
        else if (rAdtData.m_MmForceScartOut == 4) //LsRs
        {
            fgSetDownmixToOff = TRUE;        
            u4Data0 = AUD_CHL_LS_RS;
        }
        else if (rAdtData.m_MmForceScartOut == 5) //CLfe
        {
            fgSetDownmixToOff = TRUE;        
            u4Data0 = AUD_CHL_C_SW;
        }        
        else if (rAdtData.m_MmForceScartOut == 6) // Audio out Data
        {
            u4Data0 = AUD_CHL_EXTCH;
        }
        else if (rAdtData.m_MmForceScartOut == 7) //SPDIF data
        {
            u4Data0 = AUD_CHL_IEC;
        }
        
        ADAC_DacSetChl(2, (AUD_CHL_DEF_T)u4Data0);

        // ---------- MM_FORCE_OUT_CH0 --------
        // ---------- MM_FORCE_OUT_CH1 --------        

        // Check if DSP downmix should off or not
        if (fgSetDownmixToOff)
        {
            u4OriSpkCfg[0] = AUD_DspGetSpeakerOutputConfig(AUD_DEC_MAIN);
            u4OriSpkCfg[1] = AUD_DspGetSpeakerOutputConfig(AUD_DEC_AUX);            
            AUD_DspSpeakerOutputConfig(AUD_DEC_MAIN, 7);
            AUD_DspSpeakerOutputConfig(AUD_DEC_AUX, 7);            
        }
        else if (u4OriSpkCfg[0]!=AQ_SPKCFG_IS_ORIGNAL)
        {
            AUD_DspSpeakerOutputConfig(AUD_DEC_MAIN, u4OriSpkCfg[0]);
            AUD_DspSpeakerOutputConfig(AUD_DEC_AUX, u4OriSpkCfg[1]);
        }
        
        // Clear working bit.
        rRsvData.m_MmAudioRsv7 = 0;
        vAprocAqData_Write(MM_RSV_OFFSET, (UINT8*)&rRsvData, u4Size);
    }
#ifdef CC_AUD_SAKURA_RENDER
    if (u4ADTMode == AQ_ADT_MODE_ON)
    {
        if(gSoundSetting.u1MeasureMode != AQ_MM_MEASURE_MODE_1)
        {
            gSoundSetting.u1MeasureMode = AQ_MM_MEASURE_MODE_1;
            gAqKey.u1MmMode = AQ_MM_MEASURE_MODE_1;
            _AUD_UpdateDspConfig(false);
        }
    }
    else
    {
        if(gSoundSetting.u1MeasureMode != AQ_MM_MEASURE_MODE_0)
        {
            gSoundSetting.u1MeasureMode = AQ_MM_MEASURE_MODE_0;
            gAqKey.u1MmMode = AQ_MM_MEASURE_MODE_0;
            _AUD_UpdateDspConfig(false);
        }
    }
#endif // CC_AUD_SAKURA_RENDER

    return 0;
}

#ifdef CC_AUD_SAKURA_RENDER
INT32 DrvCust_AQ_Get_RSV(AQDataMmRsv* pGetRsvData, UINT32 u4InputKey, UINT32 u4Type)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;

    UINT32 j;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_RSV_MAX, u4InputKey, _ar_MmRsvTbl_Key);
    u4Size = sizeof(AQDataMmRsv); 
    vAprocAqData_Read(MM_RSV_OFFSET+u4Idx*u4Size, pGetRsvData, u4Size);
    
    if (u4Type == AQ_NOT_SPECIFIC) /* Just query table */
    {
        pu1Tmp = (UINT8*)pGetRsvData;
        AQ_Dump_Byte(pu1Tmp, u4Size);
    }

    return 0;
}
#else
INT32 DrvCust_AQ_Get_RSV(UINT32 u4InputKey)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataMmRsv rRsvData;

    UINT32 j;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_MM_RSV_MAX, u4InputKey, _ar_MmRsvTbl_Key);
    u4Size = sizeof(rRsvData); 
    vAprocAqData_Read(MM_ADT_OFFSET+u4Idx*u4Size, (UINT8*)&rRsvData, u4Size);

    // Write code for apply data here ....
    pu1Tmp = (UINT8*)&rRsvData;
    for (j=0; j<u4Size; j++)
    {
        if (j%16 == 0)
        {
            aq_printf("\n");
        }
        aq_printf ("0x%02x ", pu1Tmp[j]);
    }

    return 0;
}
#endif /* CC_AUD_SAKURA_RENDER */

void DrvCust_AQ_Get_DA_5760_CONFIG_SET(UINT8 u1Set, UINT32 u4InputKey)
{
    if(u1Set == 1)
    {
#ifdef CC_AUD_SAKURA_RENDER
        DrvCust_AQ_Get_DA_5760_CONFIG1(u4InputKey, 0);
#else
        DrvCust_AQ_Get_DA_5760_CONFIG1(u4InputKey);
#endif /* CC_AUD_SAKURA_RENDER */

    }
    else if(u1Set==2)
    {
#ifdef CC_AUD_SAKURA_RENDER
        DrvCust_AQ_Get_DA_5760_CONFIG2(u4InputKey, 0);
#else
        DrvCust_AQ_Get_DA_5760_CONFIG2(u4InputKey);
#endif /* CC_AUD_SAKURA_RENDER */
    }
}


#ifdef CC_AUD_SAKURA_RENDER
INT32 DrvCust_AQ_Get_DA_GEN_CFG(UINT32 u4InputKey)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataDaGeneralConfig rDaGenConfData;

//  UINT32 j;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_DA_GENERAL_CONFIG_MAX, u4InputKey, _ar_DaGeneralConfigTbl_Key);
    u4Size = sizeof(rDaGenConfData); 
    vAprocAqData_Read(DA_GENERAL_CONFIG_OFFSET+u4Idx*u4Size, (UINT8*)&rDaGenConfData, u4Size);

    pu1Tmp = (UINT8*)&rDaGenConfData;
    AQ_Dump_Byte(pu1Tmp, u4Size);

    return 0;
}
#else
INT32 DrvCust_AQ_Get_DA_GEN_CFG(UINT32 u4InputKey)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataDaGeneralConfig rDaGenConfData;

    UINT32 j;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_DA_GENERAL_CONFIG_MAX, u4InputKey, _ar_DaGeneralConfigTbl_Key);
    u4Size = sizeof(rDaGenConfData); 
    vAprocAqData_Read(DA_GENERAL_CONFIG_OFFSET+u4Idx*u4Size, (UINT8*)&rDaGenConfData, u4Size);

    // Write code for apply data here ....
    pu1Tmp = (UINT8*)&rDaGenConfData;
    for (j=0; j<u4Size; j++)
    {
        if (j%16 == 0)
        {
            aq_printf("\n");
        }
        aq_printf ("0x%02x ", pu1Tmp[j]);
    }

    return 0;
}
#endif /* CC_AUD_SAKURA_RENDER */


#ifdef CC_AUD_SAKURA_RENDER
INT32 DrvCust_AQ_Get_DA_5760_CONFIG1(UINT32 u4InputKey, UINT32 u4Type)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataDa5760Config1 rDa5760Cfg1Data;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_DA_5760_CONFIG1_MAX, u4InputKey, _ar_Da5760Config1Tbl_Key);
    u4Size = sizeof(AQDataDa5760Config1);

    if (u4Type == AQ_NOT_SPECIFIC) /* Just query table */
    {
        vAprocAqData_Read(DA_5760_CONFIG1_OFFSET+u4Idx*u4Size, (UINT8*)&rDa5760Cfg1Data, u4Size);
        pu1Tmp = (UINT8*)&rDa5760Cfg1Data;
        AQ_Dump_Byte(pu1Tmp, u4Size);
    }
    else
    {
        vAprocAqData_Read(DA_5760_CONFIG1_OFFSET+u4Idx*u4Size, (UINT8*)&gDa5760Cfg1Data, u4Size);
    }

    return 0;
}
#else
INT32 DrvCust_AQ_Get_DA_5760_CONFIG1(UINT32 u4InputKey)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    UINT32 j;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_DA_5760_CONFIG1_MAX, u4InputKey, _ar_Da5760Config1Tbl_Key);
    u4Size = sizeof(gDa5760Cfg1Data); 
    vAprocAqData_Read(DA_5760_CONFIG1_OFFSET+u4Idx*u4Size, (UINT8*)&gDa5760Cfg1Data, u4Size);

    // Write code for apply data here ....
    pu1Tmp = (UINT8*)&gDa5760Cfg1Data;
    for (j=0; j<u4Size; j++)
    {
        if (j%16 == 0)
        {
            aq_printf("\n");
        }
        aq_printf ("0x%02x ", pu1Tmp[j]);
    }   

    return 0;
}
#endif /* CC_AUD_SAKURA_RENDER */


#ifdef CC_AUD_SAKURA_RENDER
INT32 DrvCust_AQ_Get_DA_5760_CONFIG2(UINT32 u4InputKey, UINT32 u4Type)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataDa5760Config2 rDa5760Cfg2Data;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_DA_5760_CONFIG2_MAX, u4InputKey, _ar_Da5760Config2Tbl_Key);
    u4Size = sizeof(AQDataDa5760Config2); 

    if (u4Type == AQ_NOT_SPECIFIC) /* Just query table */
    {
        vAprocAqData_Read(DA_5760_CONFIG2_OFFSET+u4Idx*u4Size, (UINT8*)&rDa5760Cfg2Data, u4Size);
        pu1Tmp = (UINT8*)&rDa5760Cfg2Data;
        AQ_Dump_Byte(pu1Tmp, u4Size);
    }
    else
    {
        vAprocAqData_Read(DA_5760_CONFIG2_OFFSET+u4Idx*u4Size, (UINT8*)&gDa5760Cfg2Data, u4Size);
    }

    return 0;
}
#else
INT32 DrvCust_AQ_Get_DA_5760_CONFIG2(UINT32 u4InputKey)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    UINT32 j;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_DA_5760_CONFIG2_MAX, u4InputKey, _ar_Da5760Config2Tbl_Key);
    u4Size = sizeof(gDa5760Cfg2Data); 
    vAprocAqData_Read(DA_5760_CONFIG2_OFFSET+u4Idx*u4Size, (UINT8*)&gDa5760Cfg2Data, u4Size);

    // Write code for apply data here ....
    pu1Tmp = (UINT8*)&gDa5760Cfg2Data;
    for (j=0; j<u4Size; j++)
    {
        if (j%16 == 0)
        {
            aq_printf("\n");
        }
        aq_printf ("0x%02x ", pu1Tmp[j]);
    }

    return 0;
}
#endif /* CC_AUD_SAKURA_RENDER */


#ifdef CC_AUD_SAKURA_RENDER
INT32 DrvCust_AQ_Get_DA_5538_CONFIG(UINT32 u4InputKey, UINT32 u4Type)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataDa5538Config rDa5538CfgData;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_DA_5538_CONFIG_MAX, u4InputKey, _ar_Da5538ConfigTbl_Key);
    u4Size = sizeof(AQDataDa5538Config); 

    if (u4Type == AQ_NOT_SPECIFIC) /* Just query table */
    {
        vAprocAqData_Read(DA_5538_CONFIG_OFFSET+u4Idx*u4Size, (UINT8*)&rDa5538CfgData, u4Size);
        pu1Tmp = (UINT8*)&rDa5538CfgData;
        AQ_Dump_Byte(pu1Tmp, u4Size);
    }
    else
    {
        vAprocAqData_Read(DA_5538_CONFIG_OFFSET+u4Idx*u4Size, (UINT8*)&gDa5538CfgData, u4Size);
    }

    return 0;
}
#else
INT32 DrvCust_AQ_Get_DA_5538_CONFIG(UINT32 u4InputKey)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;

    UINT32 j;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_DA_5538_CONFIG_MAX, u4InputKey, _ar_Da5538ConfigTbl_Key);
    u4Size = sizeof(gDa5538CfgData); 
    vAprocAqData_Read(DA_5538_CONFIG_OFFSET+u4Idx*u4Size, (UINT8*)&gDa5538CfgData, u4Size);

    // Write code for apply data here ....
    pu1Tmp = (UINT8*)&gDa5538CfgData;
    for (j=0; j<u4Size; j++)
    {
        if (j%16 == 0)
        {
            aq_printf("\n");
        }
        aq_printf ("0x%02x ", pu1Tmp[j]);
    }

    return 0;
}
#endif /* CC_AUD_SAKURA_RENDER */


#ifdef CC_AUD_SAKURA_RENDER
INT32 DrvCust_AQ_Get_DA_5538_BQ(UINT32 u4InputKey, UINT32 u4Type)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataDa5538Bq rDa5538BqData;
//  UINT32 j;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_DA_5538_BQ_MAX, u4InputKey, _ar_Da5538BqTbl_Key);
    u4Size = sizeof(AQDataDa5538Bq);

    if (u4Type == AQ_NOT_SPECIFIC) /* Just query table */
    {
        vAprocAqData_Read(DA_5538_BQ_OFFSET+u4Idx*u4Size, (UINT8*)&rDa5538BqData, u4Size);
        pu1Tmp = (UINT8*)&rDa5538BqData;
        AQ_Dump_Byte(pu1Tmp, u4Size);
    }
    else
    {
        vAprocAqData_Read(DA_5538_BQ_OFFSET+u4Idx*u4Size, (UINT8*)&gDa5538BqData, u4Size);
    }

    return 0;
}
#else
INT32 DrvCust_AQ_Get_DA_5538_BQ(UINT32 u4InputKey)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;

    UINT32 j;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_DA_5538_BQ_MAX, u4InputKey, _ar_Da5538BqTbl_Key);
    u4Size = sizeof(AQDataDa5538Bq); 
    vAprocAqData_Read(DA_5538_BQ_OFFSET+u4Idx*u4Size, (UINT8*)&gDa5538BqData, u4Size);

    // Write code for apply data here ....
    pu1Tmp = (UINT8*)&gDa5538BqData;
    for (j=0; j<u4Size; j++)
    {
        if (j%16 == 0)
        {
            aq_printf("\n");
        }
        aq_printf ("0x%02x ", pu1Tmp[j]);
    }

    return 0;
}
#endif /* CC_AUD_SAKURA_RENDER */


#ifdef CC_AUD_SAKURA_RENDER
INT32 DrvCust_AQ_Get_DA_5538_BT(UINT32 u4InputKey, UINT32 u4Type)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataDa5538Bt rDa5538BtData;
//  UINT32 j;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_DA_5538_BT_MAX, u4InputKey, _ar_Da5538BtTbl_Key);
    u4Size = sizeof(AQDataDa5538Bt);

    if (u4Type == AQ_NOT_SPECIFIC) /* Just query table */
    {
        vAprocAqData_Read(DA_5538_BQ_OFFSET+u4Idx*u4Size, (UINT8*)&rDa5538BtData, u4Size);
        pu1Tmp = (UINT8*)&rDa5538BtData;
        AQ_Dump_Byte(pu1Tmp, u4Size);
    }
    else
    {
        vAprocAqData_Read(DA_5538_BQ_OFFSET+u4Idx*u4Size, (UINT8*)&gDa5538BtData, u4Size);
    }

    return 0;
}
#else
INT32 DrvCust_AQ_Get_DA_5538_BT(UINT32 u4InputKey)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;

    UINT32 j;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_DA_5538_BT_MAX, u4InputKey, _ar_Da5538BtTbl_Key);
    u4Size = sizeof(AQDataDa5538Bt); 
    vAprocAqData_Read(DA_5538_BQ_OFFSET+u4Idx*u4Size, (UINT8*)&gDa5538BtData, u4Size);

    // Write code for apply data here ....
    pu1Tmp = (UINT8*)&gDa5538BtData;
    for (j=0; j<u4Size; j++)
    {
        if (j%16 == 0)
        {
            aq_printf("\n");
        }
        aq_printf ("0x%02x ", pu1Tmp[j]);
    }

    return 0;
}
#endif /* CC_AUD_SAKURA_RENDER */


#ifdef CC_AUD_SAKURA_RENDER
INT32 DrvCust_AQ_Get_DA_5538_LOUD(UINT32 u4InputKey, UINT32 u4Type)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataDa5538Loud rDa5538LoudData;
//  UINT32 j;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_DA_5538_LOUD_MAX, u4InputKey, _ar_Da5538LoudTbl_Key);
    u4Size = sizeof(AQDataDa5538Loud); 

    // Write code for apply data here ....

    if (u4Type == AQ_NOT_SPECIFIC) /* Just query table */
    {
        vAprocAqData_Read(DA_5538_LOUD_OFFSET+u4Idx*u4Size, (UINT8*)&rDa5538LoudData, u4Size);
        pu1Tmp = (UINT8*)&rDa5538LoudData;
        AQ_Dump_Byte(pu1Tmp, u4Size);
    }
    else
    {
        vAprocAqData_Read(DA_5538_LOUD_OFFSET+u4Idx*u4Size, (UINT8*)&gDa5538LoudData, u4Size);
    }

    return 0;
}
#else
INT32 DrvCust_AQ_Get_DA_5538_LOUD(UINT32 u4InputKey)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;

    UINT32 j;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_DA_5538_LOUD_MAX, u4InputKey, _ar_Da5538LoudTbl_Key);
    u4Size = sizeof(AQDataDa5538Loud); 
    vAprocAqData_Read(DA_5538_LOUD_OFFSET+u4Idx*u4Size, (UINT8*)&gDa5538LoudData, u4Size);

    // Write code for apply data here ....
    pu1Tmp = (UINT8*)&gDa5538LoudData;
    for (j=0; j<u4Size; j++)
    {
        if (j%16 == 0)
        {
            aq_printf("\n");
        }
        aq_printf ("0x%02x ", pu1Tmp[j]);
    }

    return 0;
}
#endif /* CC_AUD_SAKURA_RENDER */


#ifdef CC_AUD_SAKURA_RENDER
INT32 DrvCust_AQ_Get_DA_5538_DRC(UINT32 u4InputKey, UINT32 u4Type)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataDa5538Drc rDa5538DrcData;
//  UINT32 j;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_DA_5538_DRC_MAX, u4InputKey, _ar_Da5538DrcTbl_Key);
    u4Size = sizeof(AQDataDa5538Drc); 

    if (u4Type == AQ_NOT_SPECIFIC) /* Just query table */
    {
        vAprocAqData_Read(DA_5538_DRC_OFFSET+u4Idx*u4Size, (UINT8*)&rDa5538DrcData, u4Size);
        pu1Tmp = (UINT8*)&rDa5538DrcData;
        AQ_Dump_Byte(pu1Tmp, u4Size);
    }
    else
    {
        vAprocAqData_Read(DA_5538_DRC_OFFSET+u4Idx*u4Size, (UINT8*)&gDa5538DrcData, u4Size);
    }

    return 0;
}
#else
INT32 DrvCust_AQ_Get_DA_5538_DRC(UINT32 u4InputKey)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;

    UINT32 j;
    UINT8* pu1Tmp;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_DA_5538_DRC_MAX, u4InputKey, _ar_Da5538DrcTbl_Key);
    u4Size = sizeof(AQDataDa5538Drc); 
    vAprocAqData_Read(DA_5538_DRC_OFFSET+u4Idx*u4Size, (UINT8*)&gDa5538DrcData, u4Size);

    // Write code for apply data here ....
    pu1Tmp = (UINT8*)&gDa5538DrcData;
    for (j=0; j<u4Size; j++)
    {
        if (j%16 == 0)
        {
            aq_printf("\n");
        }
        aq_printf ("0x%02x ", pu1Tmp[j]);
    }

    return 0;
}
#endif /* CC_AUD_SAKURA_RENDER */


#ifdef CC_AUD_SAKURA_RENDER
INT32 DrvCust_AQ_Get_DA_GEN_CFG_INIT(UINT32 u4InputKey)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataDaGeneralConfig rDaGenConfData;

    UINT32 i,j;
    UINT8* pu1Tmp;
    UINT8 u1AmpNum=0;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_DA_GENERAL_CONFIG_MAX, u4InputKey, _ar_DaGeneralConfigTbl_Key);
    u4Size = sizeof(rDaGenConfData); 

    vAprocAqData_Read(DA_GENERAL_CONFIG_OFFSET+u4Idx*u4Size, (UINT8*)&rDaGenConfData, u4Size);

    // Write code for apply data here ....
    pu1Tmp = (UINT8*)&rDaGenConfData;
    for (j=0; j<u4Size; j++)
    {
        if (j%16 == 0)
        {
            Printf("\n");
        }
        Printf ("0x%02x ", pu1Tmp[j]);
    }    
    if(rDaGenConfData.m_DaTypeIicBD8!=0)
    {
        gAmpData[u1AmpNum].u1AmpConnect=1;
        gAmpData[u1AmpNum].u2ClkDivAQAmp=1;     //BUS B
        gAmpData[u1AmpNum].u1DevAddrAQAmp=0xD8;
        gAmpData[u1AmpNum].u1AmpTable=rDaGenConfData.m_DaTypeIicBD8-1;
        DrvCust_AQ_Get_DA_5760_CONFIG_SET(rDaGenConfData.m_DaTypeIicBD8, u4InputKey);            
        if(++u1AmpNum > 1)
        {
            return 0;
        }            
    }
    if(rDaGenConfData.m_DaTypeIicBDa!=0)
    {
        gAmpData[u1AmpNum].u1AmpConnect=1;
        gAmpData[u1AmpNum].u2ClkDivAQAmp=1;     //BUS B
        gAmpData[u1AmpNum].u1DevAddrAQAmp=0xDA;
        gAmpData[u1AmpNum].u1AmpTable=rDaGenConfData.m_DaTypeIicBDa-1;
        DrvCust_AQ_Get_DA_5760_CONFIG_SET(rDaGenConfData.m_DaTypeIicBDa, u4InputKey); 
        u1AmpNum++;
    }
    if(rDaGenConfData.m_DaTypeIicCD8!=0)
    {
        gAmpData[u1AmpNum].u1AmpConnect=1;
        gAmpData[u1AmpNum].u2ClkDivAQAmp=0;     //BUS C
        gAmpData[u1AmpNum].u1DevAddrAQAmp=0xD8;
        gAmpData[u1AmpNum].u1AmpTable=rDaGenConfData.m_DaTypeIicCD8-1;
        DrvCust_AQ_Get_DA_5760_CONFIG_SET(rDaGenConfData.m_DaTypeIicCD8, u4InputKey);  
        u1AmpNum++;
    }
    if(rDaGenConfData.m_DaTypeIicCDa!=0)
    {
        gAmpData[u1AmpNum].u1AmpConnect=1;
        gAmpData[u1AmpNum].u2ClkDivAQAmp=0;     //BUS C
        gAmpData[u1AmpNum].u1DevAddrAQAmp=0xDA;
        gAmpData[u1AmpNum].u1AmpTable=rDaGenConfData.m_DaTypeIicCDa-1;
        DrvCust_AQ_Get_DA_5760_CONFIG_SET(rDaGenConfData.m_DaTypeIicCDa, u4InputKey);
        u1AmpNum++;
    }
    if(rDaGenConfData.m_DaTypeIicDD8!=0)
    {
        gAmpData[u1AmpNum].u1AmpConnect=1;
        gAmpData[u1AmpNum].u2ClkDivAQAmp=3;     //BUS D
        gAmpData[u1AmpNum].u1DevAddrAQAmp=0xD8;
        gAmpData[u1AmpNum].u1AmpTable=rDaGenConfData.m_DaTypeIicDD8-1;
        DrvCust_AQ_Get_DA_5760_CONFIG_SET(rDaGenConfData.m_DaTypeIicDD8, u4InputKey);
        u1AmpNum++;
    }    
    if(rDaGenConfData.m_DaTypeIicDDa!=0)
    {
        gAmpData[u1AmpNum].u1AmpConnect=1;
        gAmpData[u1AmpNum].u2ClkDivAQAmp=3;     //BUS D
        gAmpData[u1AmpNum].u1DevAddrAQAmp=0xDA;
        gAmpData[u1AmpNum].u1AmpTable=rDaGenConfData.m_DaTypeIicDDa-1;
        DrvCust_AQ_Get_DA_5760_CONFIG_SET(rDaGenConfData.m_DaTypeIicDDa, u4InputKey);   
        u1AmpNum++;
    }
    if(rDaGenConfData.m_DaTypeIicC34!=0)
    {
        gAmpData[u1AmpNum].u1AmpConnect=1;
        gAmpData[u1AmpNum].u2ClkDivAQAmp=0;     //BUS C
        gAmpData[u1AmpNum].u1DevAddrAQAmp=0x34;
        gAmpData[u1AmpNum].u1AmpTable=rDaGenConfData.m_DaTypeIicC34-1;
        u1AmpNum++;
    }    
    
    LOG(1, "Num of Amp is %d\n", u1AmpNum);
    
    for(i=0; i<u1AmpNum; i++){
        if(gAmpData[i].u1AmpConnect == 1){
            LOG(1, "%dst Amp is connected. BUS=(0x%x), SlaveAddr=(0x%x)\n", i+1, gAmpData[i].u2ClkDivAQAmp, gAmpData[i].u1DevAddrAQAmp);
        }
    }

    return 0;
}
#else
INT32 DrvCust_AQ_Get_DA_GEN_CFG_INIT(UINT32 u4InputKey, AMP_T* _vAmpTbl1 ,AMP_T* _vAmpTbl2)
{
    UINT32 u4Idx = 0;
    UINT32 u4Size;
    AQDataDaGeneralConfig rDaGenConfData;

    UINT32 j;
    UINT8* pu1Tmp;
    UINT8 u1AmpNum=0;

    u4Idx = DrvCust_AQ_Get_SpecificTable(AQDATA_INDEX_DA_GENERAL_CONFIG_MAX, u4InputKey, _ar_DaGeneralConfigTbl_Key);
    u4Size = sizeof(rDaGenConfData); 

    vAprocAqData_Read(DA_GENERAL_CONFIG_OFFSET+u4Idx*u4Size, (UINT8*)&rDaGenConfData, u4Size);

#ifdef CUSTOM_SELF_DIAG_ENABLE
    SelfDiagSetAudAmpType(rDaGenConfData.m_DaErrorDetectType);
#endif

    // Write code for apply data here ....
    pu1Tmp = (UINT8*)&rDaGenConfData;
    for (j=0; j<u4Size; j++)
    {
        if (j%16 == 0)
        {
            Printf("\n");
        }
        Printf ("0x%02x ", pu1Tmp[j]);
    }    
    if(rDaGenConfData.m_DaTypeIicBD8!=0)
    {
        gAmpData[u1AmpNum].u1AmpConnect=1;
        gAmpData[u1AmpNum].u2ClkDivAQAmp=1;     //BUS B
        gAmpData[u1AmpNum].u1DevAddrAQAmp=0xD8;
        gAmpData[u1AmpNum].u1AmpTable=rDaGenConfData.m_DaTypeIicBD8-1;
        DrvCust_AQ_Get_DA_5760_CONFIG_SET(rDaGenConfData.m_DaTypeIicBD8, u4InputKey);            
        if(++u1AmpNum > 1)
        {
            return 0;
        }            
    }
    else if(rDaGenConfData.m_DaTypeIicBDa!=0)
    {
        gAmpData[u1AmpNum].u1AmpConnect=1;
        gAmpData[u1AmpNum].u2ClkDivAQAmp=1;     //BUS B
        gAmpData[u1AmpNum].u1DevAddrAQAmp=0xDA;
        gAmpData[u1AmpNum].u1AmpTable=rDaGenConfData.m_DaTypeIicBDa-1;
        DrvCust_AQ_Get_DA_5760_CONFIG_SET(rDaGenConfData.m_DaTypeIicBDa, u4InputKey);            
        if(++u1AmpNum > 1)
        {
            return 0;
        }            
    }
    else if(rDaGenConfData.m_DaTypeIicCD8!=0)
    {
        gAmpData[u1AmpNum].u1AmpConnect=1;
        gAmpData[u1AmpNum].u2ClkDivAQAmp=2;     //BUS C
        gAmpData[u1AmpNum].u1DevAddrAQAmp=0xD8;
        gAmpData[u1AmpNum].u1AmpTable=rDaGenConfData.m_DaTypeIicCD8-1;
        DrvCust_AQ_Get_DA_5760_CONFIG_SET(rDaGenConfData.m_DaTypeIicCD8, u4InputKey);            
        if(++u1AmpNum > 1)
        {
            return 0;
        }            
    }
    else if(rDaGenConfData.m_DaTypeIicCDa!=0)
    {
        gAmpData[u1AmpNum].u1AmpConnect=1;
        gAmpData[u1AmpNum].u2ClkDivAQAmp=2;     //BUS C
        gAmpData[u1AmpNum].u1DevAddrAQAmp=0xDA;
        gAmpData[u1AmpNum].u1AmpTable=rDaGenConfData.m_DaTypeIicCDa-1;
        DrvCust_AQ_Get_DA_5760_CONFIG_SET(rDaGenConfData.m_DaTypeIicCDa, u4InputKey);            
        if(++u1AmpNum > 1)
        {
            return 0;
        }            
    }
    else if(rDaGenConfData.m_DaTypeIicDD8!=0)
    {
        gAmpData[u1AmpNum].u1AmpConnect=1;
        gAmpData[u1AmpNum].u2ClkDivAQAmp=3;     //BUS D
        gAmpData[u1AmpNum].u1DevAddrAQAmp=0xD8;
        gAmpData[u1AmpNum].u1AmpTable=rDaGenConfData.m_DaTypeIicDD8-1;
        DrvCust_AQ_Get_DA_5760_CONFIG_SET(rDaGenConfData.m_DaTypeIicDD8, u4InputKey);            
        if(++u1AmpNum > 1)
        {
            return 0;
        }            
    }    
    else if(rDaGenConfData.m_DaTypeIicDDa!=0)
    {
        gAmpData[u1AmpNum].u1AmpConnect=1;
        gAmpData[u1AmpNum].u2ClkDivAQAmp=3;     //BUS D
        gAmpData[u1AmpNum].u1DevAddrAQAmp=0xDA;
        gAmpData[u1AmpNum].u1AmpTable=rDaGenConfData.m_DaTypeIicDDa-1;
        DrvCust_AQ_Get_DA_5760_CONFIG_SET(rDaGenConfData.m_DaTypeIicDDa, u4InputKey);            
        if(++u1AmpNum > 1)
        {
            return 0;
        }            
    }
    else if(rDaGenConfData.m_DaTypeIicC34!=0)
    {
        gAmpData[u1AmpNum].u1AmpConnect=1;
        gAmpData[u1AmpNum].u2ClkDivAQAmp=2;     //BUS C
        gAmpData[u1AmpNum].u1DevAddrAQAmp=0x34;
        gAmpData[u1AmpNum].u1AmpTable=rDaGenConfData.m_DaTypeIicC34-1;
        if(++u1AmpNum > 1)
        {
            return 0;
        }            
    }    
    if(u1AmpNum == 2)
    {        
        _vAmpTbl2 = AUD_AMP_GetAQCustFunTbl2();   
    }
    if(u1AmpNum != 0)
    {
        _vAmpTbl1 = AUD_AMP_GetAQCustFunTbl1();   
    }

    return 0;
}
#endif //CC_AUD_SAKURA_RENDER

#ifdef CC_AUD_SAKURA_RENDER
BOOL DrvCust_AQ_IsSurround(AUD_DrvCust_AQ_Key_T rAqKey)
{
    BOOL isSurround = FALSE;

    if(rAqKey.u1SurroundOnOff == AQ_SURROUND_OFF){
        isSurround = FALSE;
    }
    else if(rAqKey.u1SurroundOnOff == AQ_SURROUND_ON){
        isSurround = TRUE;
    }
    else if(rAqKey.u1SurroundOnOff == AQ_SURROUND_AUTO){
        switch(rAqKey.u1ChannelConf) {
        case AQ_CHANNEL_CONF_2_2_0:
        case AQ_CHANNEL_CONF_2_2_1:
        case AQ_CHANNEL_CONF_3_2_0:
        case AQ_CHANNEL_CONF_3_2_1:
            isSurround = TRUE;
            break;
        default:
            isSurround = FALSE;
            break;
        }
    }
    return isSurround;
}
#endif // CC_AUD_SAKURA_RENDER

#endif //#if ((!defined(CC_MTK_PRELOADER)) && (!defined(CC_MTK_LOADER))) 

